/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Subtarget Enumeration Source Fragment                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/


#ifdef GET_SUBTARGETINFO_ENUM
#undef GET_SUBTARGETINFO_ENUM

namespace llvm {
namespace Hexagon {
enum {
  ArchV4 = 0,
  ArchV5 = 1,
  ArchV55 = 2,
  ArchV60 = 3,
  ArchV62 = 4,
  ArchV65 = 5,
  ExtensionHVX = 6,
  ExtensionHVX64B = 7,
  ExtensionHVX128B = 8,
  ExtensionHVXV60 = 9,
  ExtensionHVXV62 = 10,
  ExtensionHVXV65 = 11,
  FeatureDuplex = 12,
  FeatureLongCalls = 13,
  FeatureMemNoShuf = 14,
  FeatureMemops = 15,
  FeatureNVJ = 16,
  FeatureNVS = 17,
  FeaturePackets = 18,
  FeatureReservedR19 = 19,
  FeatureSmallData = 20,
};
} // end namespace Hexagon
} // end namespace llvm

#endif // GET_SUBTARGETINFO_ENUM


#ifdef GET_SUBTARGETINFO_MC_DESC
#undef GET_SUBTARGETINFO_MC_DESC

namespace llvm {
// Sorted (by key) array of values for CPU features.
extern const llvm::SubtargetFeatureKV HexagonFeatureKV[] = {
  { "duplex", "Enable generation of duplex instruction", { Hexagon::FeatureDuplex }, { } },
  { "hvx", "Hexagon HVX instructions", { Hexagon::ExtensionHVX }, { } },
  { "hvx-length128b", "Hexagon HVX 128B instructions", { Hexagon::ExtensionHVX128B }, { Hexagon::ExtensionHVX } },
  { "hvx-length64b", "Hexagon HVX 64B instructions", { Hexagon::ExtensionHVX64B }, { Hexagon::ExtensionHVX } },
  { "hvxv60", "Hexagon HVX instructions", { Hexagon::ExtensionHVXV60 }, { Hexagon::ExtensionHVX } },
  { "hvxv62", "Hexagon HVX instructions", { Hexagon::ExtensionHVXV62 }, { Hexagon::ExtensionHVX, Hexagon::ExtensionHVXV60 } },
  { "hvxv65", "Hexagon HVX instructions", { Hexagon::ExtensionHVXV65 }, { Hexagon::ExtensionHVX, Hexagon::ExtensionHVXV60, Hexagon::ExtensionHVXV62 } },
  { "long-calls", "Use constant-extended calls", { Hexagon::FeatureLongCalls }, { } },
  { "mem_noshuf", "Supports mem_noshuf feature", { Hexagon::FeatureMemNoShuf }, { } },
  { "memops", "Use memop instructions", { Hexagon::FeatureMemops }, { } },
  { "nvj", "Support for new-value jumps", { Hexagon::FeatureNVJ }, { Hexagon::FeaturePackets } },
  { "nvs", "Support for new-value stores", { Hexagon::FeatureNVS }, { Hexagon::FeaturePackets } },
  { "packets", "Support for instruction packets", { Hexagon::FeaturePackets }, { } },
  { "reserved-r19", "Reserve register R19", { Hexagon::FeatureReservedR19 }, { } },
  { "small-data", "Allow GP-relative addressing of global variables", { Hexagon::FeatureSmallData }, { } },
  { "v4", "Enable Hexagon V4 architecture", { Hexagon::ArchV4 }, { } },
  { "v5", "Enable Hexagon V5 architecture", { Hexagon::ArchV5 }, { } },
  { "v55", "Enable Hexagon V55 architecture", { Hexagon::ArchV55 }, { } },
  { "v60", "Enable Hexagon V60 architecture", { Hexagon::ArchV60 }, { } },
  { "v62", "Enable Hexagon V62 architecture", { Hexagon::ArchV62 }, { } },
  { "v65", "Enable Hexagon V65 architecture", { Hexagon::ArchV65 }, { } },
};

// Sorted (by key) array of values for CPU subtype.
extern const llvm::SubtargetFeatureKV HexagonSubTypeKV[] = {
  { "generic", "Select the generic processor", { Hexagon::ArchV4, Hexagon::ArchV5, Hexagon::ArchV55, Hexagon::ArchV60, Hexagon::FeatureDuplex, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
  { "hexagonv4", "Select the hexagonv4 processor", { Hexagon::ArchV4, Hexagon::FeatureDuplex, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
  { "hexagonv5", "Select the hexagonv5 processor", { Hexagon::ArchV4, Hexagon::ArchV5, Hexagon::FeatureDuplex, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
  { "hexagonv55", "Select the hexagonv55 processor", { Hexagon::ArchV4, Hexagon::ArchV5, Hexagon::ArchV55, Hexagon::FeatureDuplex, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
  { "hexagonv60", "Select the hexagonv60 processor", { Hexagon::ArchV4, Hexagon::ArchV5, Hexagon::ArchV55, Hexagon::ArchV60, Hexagon::FeatureDuplex, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
  { "hexagonv62", "Select the hexagonv62 processor", { Hexagon::ArchV4, Hexagon::ArchV5, Hexagon::ArchV55, Hexagon::ArchV60, Hexagon::ArchV62, Hexagon::FeatureDuplex, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
  { "hexagonv65", "Select the hexagonv65 processor", { Hexagon::ArchV4, Hexagon::ArchV5, Hexagon::ArchV55, Hexagon::ArchV60, Hexagon::ArchV62, Hexagon::ArchV65, Hexagon::FeatureDuplex, Hexagon::FeatureMemNoShuf, Hexagon::FeatureMemops, Hexagon::FeatureNVJ, Hexagon::FeatureNVS, Hexagon::FeaturePackets, Hexagon::FeatureSmallData }, { } },
};

#ifdef DBGFIELD
#error "<target>GenSubtargetInfo.inc requires a DBGFIELD macro"
#endif
#if !defined(NDEBUG) || defined(LLVM_ENABLE_DUMP)
#define DBGFIELD(x) x,
#else
#define DBGFIELD(x)
#endif

// Functional units for "HexagonItinerariesV60"
namespace HexagonItinerariesV60FU {
  const unsigned SLOT0 = 1 << 0;
  const unsigned SLOT1 = 1 << 1;
  const unsigned SLOT2 = 1 << 2;
  const unsigned SLOT3 = 1 << 3;
  const unsigned SLOT_ENDLOOP = 1 << 4;
  const unsigned CVI_ST = 1 << 5;
  const unsigned CVI_XLANE = 1 << 6;
  const unsigned CVI_SHIFT = 1 << 7;
  const unsigned CVI_MPY0 = 1 << 8;
  const unsigned CVI_MPY1 = 1 << 9;
  const unsigned CVI_LD = 1 << 10;
  const unsigned CVI_XLSHF = 1 << 11;
  const unsigned CVI_MPY01 = 1 << 12;
  const unsigned CVI_ALL = 1 << 13;
  const unsigned CVI_ALL_NOMEM = 1 << 14;
} // end namespace HexagonItinerariesV60FU

// Pipeline forwarding paths for itineraries "HexagonItinerariesV60"
namespace HexagonItinerariesV60Bypass {
  const unsigned NoBypass = 0;
  const unsigned Hex_FWD = 1 << 0;
  const unsigned HVX_FWD = 1 << 1;
} // end namespace HexagonItinerariesV60Bypass

// Functional units for "HexagonItinerariesV4"
namespace HexagonItinerariesV4FU {
  const unsigned SLOT0 = 1 << 0;
  const unsigned SLOT1 = 1 << 1;
  const unsigned SLOT2 = 1 << 2;
  const unsigned SLOT3 = 1 << 3;
  const unsigned SLOT_ENDLOOP = 1 << 4;
} // end namespace HexagonItinerariesV4FU

// Pipeline forwarding paths for itineraries "HexagonItinerariesV4"
namespace HexagonItinerariesV4Bypass {
  const unsigned NoBypass = 0;
  const unsigned Hex_FWD = 1 << 0;
} // end namespace HexagonItinerariesV4Bypass

// Functional units for "HexagonItinerariesV55"
namespace HexagonItinerariesV55FU {
  const unsigned SLOT0 = 1 << 0;
  const unsigned SLOT1 = 1 << 1;
  const unsigned SLOT2 = 1 << 2;
  const unsigned SLOT3 = 1 << 3;
  const unsigned SLOT_ENDLOOP = 1 << 4;
} // end namespace HexagonItinerariesV55FU

// Pipeline forwarding paths for itineraries "HexagonItinerariesV55"
namespace HexagonItinerariesV55Bypass {
  const unsigned NoBypass = 0;
  const unsigned Hex_FWD = 1 << 0;
} // end namespace HexagonItinerariesV55Bypass

// Functional units for "HexagonItinerariesV62"
namespace HexagonItinerariesV62FU {
  const unsigned SLOT0 = 1 << 0;
  const unsigned SLOT1 = 1 << 1;
  const unsigned SLOT2 = 1 << 2;
  const unsigned SLOT3 = 1 << 3;
  const unsigned SLOT_ENDLOOP = 1 << 4;
  const unsigned CVI_ST = 1 << 5;
  const unsigned CVI_XLANE = 1 << 6;
  const unsigned CVI_SHIFT = 1 << 7;
  const unsigned CVI_MPY0 = 1 << 8;
  const unsigned CVI_MPY1 = 1 << 9;
  const unsigned CVI_LD = 1 << 10;
  const unsigned CVI_XLSHF = 1 << 11;
  const unsigned CVI_MPY01 = 1 << 12;
  const unsigned CVI_ALL = 1 << 13;
  const unsigned CVI_ALL_NOMEM = 1 << 14;
} // end namespace HexagonItinerariesV62FU

// Pipeline forwarding paths for itineraries "HexagonItinerariesV62"
namespace HexagonItinerariesV62Bypass {
  const unsigned NoBypass = 0;
  const unsigned Hex_FWD = 1 << 0;
  const unsigned HVX_FWD = 1 << 1;
} // end namespace HexagonItinerariesV62Bypass

// Functional units for "HexagonItinerariesV65"
namespace HexagonItinerariesV65FU {
  const unsigned SLOT0 = 1 << 0;
  const unsigned SLOT1 = 1 << 1;
  const unsigned SLOT2 = 1 << 2;
  const unsigned SLOT3 = 1 << 3;
  const unsigned SLOT_ENDLOOP = 1 << 4;
  const unsigned CVI_ST = 1 << 5;
  const unsigned CVI_XLANE = 1 << 6;
  const unsigned CVI_SHIFT = 1 << 7;
  const unsigned CVI_MPY0 = 1 << 8;
  const unsigned CVI_MPY1 = 1 << 9;
  const unsigned CVI_LD = 1 << 10;
  const unsigned CVI_XLSHF = 1 << 11;
  const unsigned CVI_MPY01 = 1 << 12;
  const unsigned CVI_ALL = 1 << 13;
  const unsigned CVI_ALL_NOMEM = 1 << 14;
} // end namespace HexagonItinerariesV65FU

// Pipeline forwarding paths for itineraries "HexagonItinerariesV65"
namespace HexagonItinerariesV65Bypass {
  const unsigned NoBypass = 0;
  const unsigned Hex_FWD = 1 << 0;
  const unsigned HVX_FWD = 1 << 1;
} // end namespace HexagonItinerariesV65Bypass

extern const llvm::InstrStage HexagonStages[] = {
  { 0, 0, 0, llvm::InstrStage::Required }, // No itinerary
  { 1, HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 1
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 2
  { 1, HexagonItinerariesV60FU::SLOT0, -1, (llvm::InstrStage::ReservationKinds)0 }, // 3
  { 1, HexagonItinerariesV60FU::SLOT_ENDLOOP, -1, (llvm::InstrStage::ReservationKinds)0 }, // 4
  { 1, HexagonItinerariesV60FU::SLOT2, -1, (llvm::InstrStage::ReservationKinds)0 }, // 5
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 6
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1 | HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 7-8
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY01 | HexagonItinerariesV60FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 9-10
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1 | HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 11-13
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 14-17
  { 1, HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 18-19
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1 | HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 20-22
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 23-26
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_XLANE | HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 27-28
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_SHIFT, -1, (llvm::InstrStage::ReservationKinds)0 }, // 29-30
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY01 | HexagonItinerariesV60FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 31-34
  { 1, HexagonItinerariesV60FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 35
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1 | HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 36-37
  { 1, HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 38-39
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 40-41
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_LD, -1, (llvm::InstrStage::ReservationKinds)0 }, // 42-43
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_ST, -1, (llvm::InstrStage::ReservationKinds)0 }, // 44-45
  { 1, HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY01, -1, (llvm::InstrStage::ReservationKinds)0 }, // 46-47
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 48-49
  { 1, HexagonItinerariesV60FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1 | HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 50-52
  { 1, HexagonItinerariesV60FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY01 | HexagonItinerariesV60FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 53-55
  { 1, HexagonItinerariesV60FU::SLOT0 | HexagonItinerariesV60FU::SLOT1 | HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_ALL, -1, (llvm::InstrStage::ReservationKinds)0 }, // 56-57
  { 1, HexagonItinerariesV60FU::SLOT2, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY01, -1, (llvm::InstrStage::ReservationKinds)0 }, // 58-59
  { 1, HexagonItinerariesV60FU::SLOT2 | HexagonItinerariesV60FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY0 | HexagonItinerariesV60FU::CVI_MPY1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_SHIFT | HexagonItinerariesV60FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 60-62
  { 1, HexagonItinerariesV60FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV60FU::CVI_MPY01 | HexagonItinerariesV60FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 63-65
  { 1, HexagonItinerariesV4FU::SLOT2 | HexagonItinerariesV4FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 66
  { 1, HexagonItinerariesV4FU::SLOT0 | HexagonItinerariesV4FU::SLOT1 | HexagonItinerariesV4FU::SLOT2 | HexagonItinerariesV4FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 67
  { 1, HexagonItinerariesV4FU::SLOT0, -1, (llvm::InstrStage::ReservationKinds)0 }, // 68
  { 1, HexagonItinerariesV4FU::SLOT_ENDLOOP, -1, (llvm::InstrStage::ReservationKinds)0 }, // 69
  { 1, HexagonItinerariesV4FU::SLOT2, -1, (llvm::InstrStage::ReservationKinds)0 }, // 70
  { 1, HexagonItinerariesV4FU::SLOT0 | HexagonItinerariesV4FU::SLOT1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 71
  { 1, HexagonItinerariesV4FU::SLOT2 | HexagonItinerariesV4FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV4FU::SLOT2 | HexagonItinerariesV4FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 72-73
  { 1, HexagonItinerariesV4FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 74
  { 1, HexagonItinerariesV55FU::SLOT2 | HexagonItinerariesV55FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 75
  { 1, HexagonItinerariesV55FU::SLOT0 | HexagonItinerariesV55FU::SLOT1 | HexagonItinerariesV55FU::SLOT2 | HexagonItinerariesV55FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 76
  { 1, HexagonItinerariesV55FU::SLOT0, -1, (llvm::InstrStage::ReservationKinds)0 }, // 77
  { 1, HexagonItinerariesV55FU::SLOT_ENDLOOP, -1, (llvm::InstrStage::ReservationKinds)0 }, // 78
  { 1, HexagonItinerariesV55FU::SLOT2, -1, (llvm::InstrStage::ReservationKinds)0 }, // 79
  { 1, HexagonItinerariesV55FU::SLOT0 | HexagonItinerariesV55FU::SLOT1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 80
  { 1, HexagonItinerariesV55FU::SLOT2 | HexagonItinerariesV55FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV55FU::SLOT2 | HexagonItinerariesV55FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 81-82
  { 1, HexagonItinerariesV55FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 83
  { 1, HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 84
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 85
  { 1, HexagonItinerariesV62FU::SLOT0, -1, (llvm::InstrStage::ReservationKinds)0 }, // 86
  { 1, HexagonItinerariesV62FU::SLOT_ENDLOOP, -1, (llvm::InstrStage::ReservationKinds)0 }, // 87
  { 1, HexagonItinerariesV62FU::SLOT2, -1, (llvm::InstrStage::ReservationKinds)0 }, // 88
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 89
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1 | HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 90-91
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY01 | HexagonItinerariesV62FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 92-93
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1 | HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 94-96
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 97-100
  { 1, HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 101-102
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1 | HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 103-105
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 106-109
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_XLANE | HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 110-111
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_SHIFT, -1, (llvm::InstrStage::ReservationKinds)0 }, // 112-113
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY01 | HexagonItinerariesV62FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 114-117
  { 1, HexagonItinerariesV62FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 118
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1 | HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 119-120
  { 1, HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 121-122
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 123-124
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_LD, -1, (llvm::InstrStage::ReservationKinds)0 }, // 125-126
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_ST, -1, (llvm::InstrStage::ReservationKinds)0 }, // 127-128
  { 1, HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY01, -1, (llvm::InstrStage::ReservationKinds)0 }, // 129-130
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 131-132
  { 1, HexagonItinerariesV62FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1 | HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 133-135
  { 1, HexagonItinerariesV62FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY01 | HexagonItinerariesV62FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 136-138
  { 1, HexagonItinerariesV62FU::SLOT0 | HexagonItinerariesV62FU::SLOT1 | HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_ALL, -1, (llvm::InstrStage::ReservationKinds)0 }, // 139-140
  { 1, HexagonItinerariesV62FU::SLOT2, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY01, -1, (llvm::InstrStage::ReservationKinds)0 }, // 141-142
  { 1, HexagonItinerariesV62FU::SLOT2 | HexagonItinerariesV62FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY0 | HexagonItinerariesV62FU::CVI_MPY1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_SHIFT | HexagonItinerariesV62FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 143-145
  { 1, HexagonItinerariesV62FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV62FU::CVI_MPY01 | HexagonItinerariesV62FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 146-148
  { 1, HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 149
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 150
  { 1, HexagonItinerariesV65FU::SLOT0, -1, (llvm::InstrStage::ReservationKinds)0 }, // 151
  { 1, HexagonItinerariesV65FU::SLOT_ENDLOOP, -1, (llvm::InstrStage::ReservationKinds)0 }, // 152
  { 1, HexagonItinerariesV65FU::SLOT2, -1, (llvm::InstrStage::ReservationKinds)0 }, // 153
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 154
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1 | HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 155-156
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY01 | HexagonItinerariesV65FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 157-158
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1 | HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 159-161
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 162-165
  { 1, HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 166-167
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1 | HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 168-170
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 171-174
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_XLANE | HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 175-176
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_SHIFT, -1, (llvm::InstrStage::ReservationKinds)0 }, // 177-178
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY01 | HexagonItinerariesV65FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 179-182
  { 1, HexagonItinerariesV65FU::SLOT3, -1, (llvm::InstrStage::ReservationKinds)0 }, // 183
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1 | HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 184-185
  { 1, HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1, -1, (llvm::InstrStage::ReservationKinds)0 }, // 186-187
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 188-189
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_LD, -1, (llvm::InstrStage::ReservationKinds)0 }, // 190-191
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_ST, -1, (llvm::InstrStage::ReservationKinds)0 }, // 192-193
  { 1, HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY01, -1, (llvm::InstrStage::ReservationKinds)0 }, // 194-195
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 196-197
  { 1, HexagonItinerariesV65FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1 | HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 198-200
  { 1, HexagonItinerariesV65FU::SLOT1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_LD, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY01 | HexagonItinerariesV65FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 201-203
  { 1, HexagonItinerariesV65FU::SLOT0 | HexagonItinerariesV65FU::SLOT1 | HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_ALL, -1, (llvm::InstrStage::ReservationKinds)0 }, // 204-205
  { 1, HexagonItinerariesV65FU::SLOT2, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY01, -1, (llvm::InstrStage::ReservationKinds)0 }, // 206-207
  { 1, HexagonItinerariesV65FU::SLOT2 | HexagonItinerariesV65FU::SLOT3, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY0 | HexagonItinerariesV65FU::CVI_MPY1, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_SHIFT | HexagonItinerariesV65FU::CVI_XLANE, -1, (llvm::InstrStage::ReservationKinds)0 }, // 208-210
  { 1, HexagonItinerariesV65FU::SLOT0, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_ST, 0, (llvm::InstrStage::ReservationKinds)0 },   { 1, HexagonItinerariesV65FU::CVI_MPY01 | HexagonItinerariesV65FU::CVI_XLSHF, -1, (llvm::InstrStage::ReservationKinds)0 }, // 211-213
  { 0, 0, 0, llvm::InstrStage::Required } // End stages
};
extern const unsigned HexagonOperandCycles[] = {
  0, // No itinerary
  3,   2,   2, // 1-3
  1,   1,   1, // 4-6
  3,   2, // 7-8
  3,   2,   2,   2, // 9-12
  3,   3,   2,   2, // 13-16
  3,   2,   2, // 17-19
  3,   3,   2, // 20-22
  3,   2,   2, // 23-25
  3,   1,   1, // 26-28
  3,   1,   2, // 29-31
  3,   2,   2, // 32-34
  1,   1,   1, // 35-37
  2, // 38
  2,   2, // 39-40
  2,   1, // 41-42
  3,   2,   2, // 43-45
  4,   2,   1,   2, // 46-49
  4,   1,   2, // 50-52
  4,   3,   1,   2, // 53-56
  1,   2,   2, // 57-59
  3,   2,   2, // 60-62
  3,   3,   2, // 63-65
  2, // 66
  3, // 67
  4,   2, // 68-69
  3,   2, // 70-71
  3,   1, // 72-73
  4,   1,   2, // 74-76
  4,   1,   1, // 77-79
  4,   2,   1,   1, // 80-83
  4,   3,   1,   2,   2, // 84-88
  9,   7,   7, // 89-91
  3,   1,   2,   2,   2, // 92-96
  3,   1,   2,   2, // 97-100
  1, // 101
  9,   7,   7, // 102-104
  9,   1,   2, // 105-107
  9,   1,   2, // 108-110
  1,   1,   1, // 111-113
  9,   2,   7, // 114-116
  1,   2,   7, // 117-119
  1,   2,   5, // 120-122
  9,   2,   7,   7, // 123-126
  4,   2,   2, // 127-129
  2,   1,   2,   2, // 130-133
  2,   1,   2,   3, // 134-137
  1,   2,   2, // 138-140
  1,   2,   3, // 141-143
  4,   2,   2,   2,   2, // 144-148
  3,   1,   2,   3, // 149-152
  4,   2,   2, // 153-155
  1,   1,   1, // 156-158
  9,   7,   7,   7, // 159-162
  9,   7, // 163-164
  9,   5,   5,   2, // 165-168
  9, // 169
  1, // 170
  4,   2, // 171-172
  4,   2,   2, // 173-175
  4,   2,   2, // 176-178
  4,   2,   2, // 179-181
  3,   2, // 182-183
  3,   2,   2, // 184-186
  4,   2, // 187-188
  4,   1, // 189-190
  3,   2,   2, // 191-193
  4,   4,   1,   1,   2, // 194-198
  3,   1,   2, // 199-201
  2, // 202
  4,   1,   1, // 203-205
  4,   1,   1,   2, // 206-209
  4,   4,   1,   1,   1, // 210-214
  3,   2,   2, // 215-217
  4,   4,   2,   2, // 218-221
  3,   2, // 222-223
  3,   1,   1, // 224-226
  3,   1, // 227-228
  3,   2,   2,   2, // 229-232
  4,   2, // 233-234
  3,   2,   2,   2, // 235-238
  2, // 239
  5,   1, // 240-241
  4,   2, // 242-243
  5,   1,   1, // 244-246
  5,   2,   1,   1, // 247-250
  5,   2,   1,   1,   2, // 251-255
  5,   5,   1, // 256-258
  4,   2,   2, // 259-261
  5,   5,   1,   1, // 262-265
  4,   2, // 266-267
  4,   1, // 268-269
  2,   2, // 270-271
  1, // 272
  2,   1, // 273-274
  2, // 275
  3,   2, // 276-277
  2,   2, // 278-279
  3,   1, // 280-281
  2,   1, // 282-283
  1,   2, // 284-285
  2,   2, // 286-287
  2,   1, // 288-289
  2, // 290
  2,   2, // 291-292
  2,   1, // 293-294
  2, // 295
  3,   2,   2, // 296-298
  1,   1,   2, // 299-301
  3,   2,   2, // 302-304
  1,   2,   2, // 305-307
  2,   3,   2, // 308-310
  3,   2,   2, // 311-313
  3,   2, // 314-315
  1,   2, // 316-317
  4,   3,   2,   1,   2, // 318-322
  4,   3,   2,   1,   2,   2, // 323-328
  4,   2, // 329-330
  4,   1, // 331-332
  4,   3,   3,   1,   2, // 333-337
  4,   3,   2,   2, // 338-341
  4,   2,   1,   2,   2, // 342-346
  4,   3,   2, // 347-349
  4,   1,   2,   2, // 350-353
  4,   1,   1,   2, // 354-357
  4,   2,   2, // 358-360
  4,   2,   1,   1,   2, // 361-365
  4,   3,   1,   1,   2, // 366-370
  4,   2,   2,   2, // 371-374
  4,   2,   1,   2, // 375-378
  4,   2,   2,   2, // 379-382
  4,   2,   2,   1, // 383-386
  4,   2,   2, // 387-389
  2,   2, // 390-391
  2,   3, // 392-393
  4,   2, // 394-395
  4,   1,   1, // 396-398
  3,   2,   1,   2,   2, // 399-403
  3,   3,   1,   2,   2, // 404-408
  3,   2,   1,   2,   3, // 409-413
  3,   3,   1,   2,   3, // 414-418
  3,   1,   2,   2,   3, // 419-423
  4,   1,   1, // 424-426
  2,   2,   2, // 427-429
  2,   1,   1,   2,   2, // 430-434
  3,   2,   2, // 435-437
  3,   1,   1,   2,   2, // 438-442
  2,   2,   3, // 443-445
  2,   1,   1,   2,   3, // 446-450
  3,   2,   3, // 451-453
  3,   1,   1,   2,   3, // 454-458
  1,   1,   2,   2, // 459-462
  1,   2,   2,   2, // 463-466
  1,   1,   2,   3, // 467-470
  1,   2,   2,   3, // 471-474
  4,   1,   1,   2, // 475-478
  4,   2,   1,   1,   2, // 479-483
  4,   2, // 484-485
  4,   2,   2,   2, // 486-489
  3,   2, // 490-491
  3,   2,   2, // 492-494
  3,   2, // 495-496
  3, // 497
  3, // 498
  1,   2, // 499-500
  2, // 501
  1,   2, // 502-503
  4,   7,   1, // 504-506
  9,   2, // 507-508
  9,   2, // 509-510
  9,   3,   1,   2, // 511-514
  9,   2,   1,   2, // 515-518
  9,   3,   2,   1,   2, // 519-523
  9,   3,   1,   2, // 524-527
  9,   1,   2, // 528-530
  9,   2,   1,   2, // 531-534
  9,   3,   2,   1,   2, // 535-539
  9,   3,   1,   2, // 540-543
  2,   1,   2,   5, // 544-547
  3,   2,   1,   2,   5, // 548-552
  3,   1,   2,   5, // 553-556
  1,   2,   5, // 557-559
  2,   1,   2,   5, // 560-563
  3,   2,   1,   2,   5, // 564-568
  3,   1,   2,   5, // 569-572
  2,   1,   2,   7, // 573-576
  3,   2,   1,   2,   7, // 577-581
  7,   1,   2,   7, // 582-585
  3,   7,   1,   2,   7, // 586-590
  3,   1,   2,   7, // 591-594
  1,   2, // 595-596
  3,   1,   2, // 597-599
  9,   5,   5, // 600-602
  9,   7,   7,   7, // 603-606
  9,   9,   7,   7,   7, // 607-611
  9,   5,   5, // 612-614
  9,   5,   5, // 615-617
  9,   7,   5,   5, // 618-621
  9,   5,   5,   2, // 622-625
  9,   7,   2, // 626-628
  9,   7,   7,   2, // 629-632
  9,   5,   2, // 633-635
  9,   7,   5,   2, // 636-639
  9,   5, // 640-641
  9,   9,   5,   5,   2, // 642-646
  9,   5, // 647-648
  9,   5,   5, // 649-651
  9,   5,   5,   2, // 652-655
  9,   5,   2, // 656-658
  9,   7,   5,   2, // 659-662
  9,   5,   2, // 663-665
  9,   7,   5,   2, // 666-669
  1,   2,   7, // 670-672
  7,   1,   2,   7, // 673-676
  1,   2,   7, // 677-679
  7,   1,   2,   7, // 680-683
  3, // 684
  9,   5,   2, // 685-687
  9,   7,   5,   5,   2, // 688-692
  9,   5,   5,   2, // 693-696
  9,   5,   2, // 697-699
  9,   7,   5,   2, // 700-703
  9,   5,   2,   2, // 704-707
  9,   7,   5,   2,   2, // 708-712
  9,   5,   2, // 713-715
  9,   5,   5, // 716-718
  9,   7, // 719-720
  1,   2,   7,   7, // 721-724
  7,   1,   2,   7,   7, // 725-729
  1,   2,   7,   7, // 730-733
  7,   1,   2,   7,   7, // 734-738
  9,   7,   7,   7, // 739-742
  9,   5, // 743-744
  9,   7,   5, // 745-747
  2, // 748
  3,   2, // 749-750
  1, // 751
  1,   2, // 752-753
  1, // 754
  1,   1, // 755-756
  1, // 757
  3,   2,   2, // 758-760
  1,   1,   1, // 761-763
  3,   2, // 764-765
  3,   2,   2,   2, // 766-769
  3,   3,   2,   2, // 770-773
  3,   2,   2, // 774-776
  3,   3,   2, // 777-779
  3,   2,   2, // 780-782
  3,   1,   1, // 783-785
  3,   1,   2, // 786-788
  3,   2,   2, // 789-791
  1,   1,   1, // 792-794
  2, // 795
  2,   2, // 796-797
  2,   1, // 798-799
  3,   2,   2, // 800-802
  4,   2,   1,   2, // 803-806
  4,   1,   2, // 807-809
  4,   3,   1,   2, // 810-813
  1,   2,   2, // 814-816
  4,   2,   1, // 817-819
  4,   3,   1, // 820-822
  2, // 823
  3, // 824
  4,   2, // 825-826
  4,   2, // 827-828
  2,   1, // 829-830
  4,   1,   2, // 831-833
  4,   1,   1, // 834-836
  4,   2,   1,   1, // 837-840
  4,   3,   1,   2,   2, // 841-845
  3,   1,   2,   2,   2, // 846-850
  3,   1,   2,   2, // 851-854
  1, // 855
  1,   1,   1, // 856-858
  4,   2,   2, // 859-861
  2,   1,   2,   2, // 862-865
  2,   1,   2,   3, // 866-869
  1,   2,   2, // 870-872
  1,   2,   3, // 873-875
  3,   2,   2,   2,   2, // 876-880
  3,   1,   2,   3, // 881-884
  4,   2,   2, // 885-887
  1,   1,   1, // 888-890
  1, // 891
  4,   2, // 892-893
  4,   2,   2, // 894-896
  3,   2,   2, // 897-899
  4,   2,   2, // 900-902
  3,   2, // 903-904
  4,   2,   2, // 905-907
  4,   2, // 908-909
  4,   1, // 910-911
  4,   2,   2, // 912-914
  4,   4,   1,   1,   2, // 915-919
  3,   1,   2, // 920-922
  2, // 923
  4,   1,   1, // 924-926
  4,   1,   1,   1, // 927-930
  4,   4,   1,   1,   1, // 931-935
  3,   2,   2, // 936-938
  4,   4,   2,   2, // 939-942
  3,   2, // 943-944
  3,   1,   1, // 945-947
  3,   1, // 948-949
  3,   2,   2,   2, // 950-953
  4,   2, // 954-955
  3,   2,   2,   2, // 956-959
  2, // 960
  4,   1, // 961-962
  4,   2, // 963-964
  4,   1,   1, // 965-967
  4,   1,   1,   1, // 968-971
  4,   1,   1,   1,   2, // 972-976
  4,   4,   1, // 977-979
  4,   1,   1, // 980-982
  4,   4,   1,   1, // 983-986
  4,   2, // 987-988
  4,   1, // 989-990
  2,   2, // 991-992
  1, // 993
  2,   1, // 994-995
  2, // 996
  3,   2, // 997-998
  2,   2, // 999-1000
  3,   1, // 1001-1002
  2,   1, // 1003-1004
  1,   2, // 1005-1006
  2,   2, // 1007-1008
  2,   1, // 1009-1010
  2, // 1011
  2,   2, // 1012-1013
  2,   1, // 1014-1015
  2, // 1016
  3,   1,   2, // 1017-1019
  1,   1,   2, // 1020-1022
  3,   2,   2, // 1023-1025
  1,   2,   2, // 1026-1028
  1,   3,   2, // 1029-1031
  3,   2,   2, // 1032-1034
  3,   2, // 1035-1036
  1,   2, // 1037-1038
  4,   3,   2,   1,   2, // 1039-1043
  4,   3,   2,   1,   2,   2, // 1044-1049
  4,   2, // 1050-1051
  4,   1, // 1052-1053
  4,   3,   3,   1,   2, // 1054-1058
  4,   3,   2,   2, // 1059-1062
  4,   2,   1,   2,   2, // 1063-1067
  4,   3,   2, // 1068-1070
  4,   1,   2,   2, // 1071-1074
  4,   1,   1,   2, // 1075-1078
  4,   2,   2, // 1079-1081
  4,   2,   1,   1,   2, // 1082-1086
  4,   3,   1,   1,   2, // 1087-1091
  4,   2,   2,   2, // 1092-1095
  4,   2,   1,   2, // 1096-1099
  3,   2,   2,   2, // 1100-1103
  4,   2,   2,   1, // 1104-1107
  4,   2,   2, // 1108-1110
  2,   2, // 1111-1112
  2,   3, // 1113-1114
  3,   2, // 1115-1116
  4,   1,   1, // 1117-1119
  3,   2,   1,   2,   2, // 1120-1124
  3,   3,   1,   2,   2, // 1125-1129
  3,   2,   1,   2,   3, // 1130-1134
  3,   3,   1,   2,   3, // 1135-1139
  3,   1,   2,   2,   3, // 1140-1144
  4,   1,   1, // 1145-1147
  2,   2,   2, // 1148-1150
  2,   1,   1,   2,   2, // 1151-1155
  3,   2,   2, // 1156-1158
  3,   1,   1,   2,   2, // 1159-1163
  2,   2,   3, // 1164-1166
  2,   1,   1,   2,   3, // 1167-1171
  3,   2,   3, // 1172-1174
  3,   1,   1,   2,   3, // 1175-1179
  1,   1,   2,   2, // 1180-1183
  1,   2,   2,   2, // 1184-1187
  1,   1,   2,   3, // 1188-1191
  1,   2,   2,   3, // 1192-1195
  4,   1,   1,   2, // 1196-1199
  4,   2,   1,   1,   2, // 1200-1204
  4,   2, // 1205-1206
  4,   2,   2,   2, // 1207-1210
  3,   2, // 1211-1212
  3,   2,   2, // 1213-1215
  3,   2, // 1216-1217
  3, // 1218
  3, // 1219
  1,   2, // 1220-1221
  2, // 1222
  1,   2, // 1223-1224
  1, // 1225
  1,   2, // 1226-1227
  1, // 1228
  1,   1, // 1229-1230
  1, // 1231
  4,   2,   2, // 1232-1234
  1,   1,   1, // 1235-1237
  3,   2, // 1238-1239
  3,   2,   2,   2, // 1240-1243
  3,   3,   2,   2, // 1244-1247
  3,   2,   2, // 1248-1250
  3,   3,   2, // 1251-1253
  3,   2,   2, // 1254-1256
  3,   1,   1, // 1257-1259
  3,   1,   2, // 1260-1262
  3,   2,   2, // 1263-1265
  1,   1,   1, // 1266-1268
  2, // 1269
  2,   2, // 1270-1271
  2,   1, // 1272-1273
  3,   2,   2, // 1274-1276
  4,   2,   1,   2, // 1277-1280
  4,   1,   2, // 1281-1283
  4,   3,   1,   2, // 1284-1287
  1,   2,   2, // 1288-1290
  3,   2,   2, // 1291-1293
  3,   3,   2, // 1294-1296
  2, // 1297
  3, // 1298
  4,   2, // 1299-1300
  3,   2, // 1301-1302
  3,   1, // 1303-1304
  4,   1,   2, // 1305-1307
  4,   1,   1, // 1308-1310
  4,   2,   1,   1, // 1311-1314
  4,   3,   1,   2,   2, // 1315-1319
  9,   7,   7, // 1320-1322
  3,   1,   2,   2,   2, // 1323-1327
  3,   1,   2,   2, // 1328-1331
  1, // 1332
  9,   7,   7, // 1333-1335
  9,   1,   2, // 1336-1338
  9,   1,   2, // 1339-1341
  1,   1,   1, // 1342-1344
  9,   2,   7, // 1345-1347
  1,   2,   7, // 1348-1350
  1,   2,   5, // 1351-1353
  9,   2,   7,   7, // 1354-1357
  4,   2,   2, // 1358-1360
  2,   1,   2,   2, // 1361-1364
  2,   1,   2,   3, // 1365-1368
  1,   2,   2, // 1369-1371
  1,   2,   3, // 1372-1374
  4,   2,   2,   2,   2, // 1375-1379
  3,   1,   2,   3, // 1380-1383
  4,   2,   2, // 1384-1386
  1,   1,   1, // 1387-1389
  9,   7,   7,   7, // 1390-1393
  9,   7, // 1394-1395
  9,   5,   5,   2, // 1396-1399
  9, // 1400
  1, // 1401
  4,   2, // 1402-1403
  4,   2,   2, // 1404-1406
  4,   2,   2, // 1407-1409
  4,   2,   2, // 1410-1412
  3,   2, // 1413-1414
  3,   2,   2, // 1415-1417
  4,   2, // 1418-1419
  4,   1, // 1420-1421
  3,   2,   2, // 1422-1424
  3,   4,   2,   2,   2, // 1425-1429
  3,   1,   2, // 1430-1432
  2, // 1433
  4,   1,   1, // 1434-1436
  4,   1,   1,   2, // 1437-1440
  4,   4,   2,   1,   1, // 1441-1445
  3,   2,   2, // 1446-1448
  4,   4,   2,   2, // 1449-1452
  3,   2, // 1453-1454
  3,   1,   1, // 1455-1457
  3,   1, // 1458-1459
  3,   2,   2,   2, // 1460-1463
  4,   2, // 1464-1465
  3,   2,   2,   2, // 1466-1469
  2, // 1470
  5,   1, // 1471-1472
  4,   2, // 1473-1474
  5,   1,   1, // 1475-1477
  5,   2,   1,   1, // 1478-1481
  5,   2,   1,   1,   2, // 1482-1486
  5,   5,   1, // 1487-1489
  4,   2,   2, // 1490-1492
  5,   5,   1,   1, // 1493-1496
  4,   2, // 1497-1498
  4,   1, // 1499-1500
  2,   2, // 1501-1502
  1, // 1503
  2,   1, // 1504-1505
  2, // 1506
  3,   2, // 1507-1508
  2,   2, // 1509-1510
  3,   1, // 1511-1512
  2,   1, // 1513-1514
  1,   2, // 1515-1516
  2,   2, // 1517-1518
  2,   1, // 1519-1520
  2, // 1521
  2,   2, // 1522-1523
  2,   1, // 1524-1525
  2, // 1526
  3,   2,   2, // 1527-1529
  1,   1,   2, // 1530-1532
  3,   2,   2, // 1533-1535
  1,   2,   2, // 1536-1538
  2,   3,   2, // 1539-1541
  3,   2,   2, // 1542-1544
  3,   2, // 1545-1546
  1,   2, // 1547-1548
  4,   3,   2,   1,   2, // 1549-1553
  4,   3,   2,   1,   2,   2, // 1554-1559
  4,   2, // 1560-1561
  4,   1, // 1562-1563
  4,   3,   3,   1,   2, // 1564-1568
  4,   3,   2,   2, // 1569-1572
  4,   2,   1,   2,   2, // 1573-1577
  4,   3,   2, // 1578-1580
  4,   1,   2,   2, // 1581-1584
  4,   1,   1,   2, // 1585-1588
  4,   2,   2, // 1589-1591
  4,   2,   1,   1,   2, // 1592-1596
  4,   3,   1,   1,   2, // 1597-1601
  4,   2,   2,   2, // 1602-1605
  4,   2,   1,   2, // 1606-1609
  4,   2,   2,   2, // 1610-1613
  4,   2,   2,   1, // 1614-1617
  4,   2,   2, // 1618-1620
  2,   2, // 1621-1622
  2,   3, // 1623-1624
  4,   2, // 1625-1626
  4,   1,   1, // 1627-1629
  3,   2,   1,   2,   2, // 1630-1634
  3,   3,   1,   2,   2, // 1635-1639
  3,   2,   1,   2,   3, // 1640-1644
  3,   3,   1,   2,   3, // 1645-1649
  3,   1,   2,   2,   3, // 1650-1654
  4,   1,   1, // 1655-1657
  2,   2,   2, // 1658-1660
  2,   1,   1,   2,   2, // 1661-1665
  3,   2,   2, // 1666-1668
  3,   1,   1,   2,   2, // 1669-1673
  2,   2,   3, // 1674-1676
  2,   1,   1,   2,   3, // 1677-1681
  3,   2,   3, // 1682-1684
  3,   1,   1,   2,   3, // 1685-1689
  1,   1,   2,   2, // 1690-1693
  1,   2,   2,   2, // 1694-1697
  1,   1,   2,   3, // 1698-1701
  1,   2,   2,   3, // 1702-1705
  4,   1,   1,   2, // 1706-1709
  4,   2,   1,   1,   2, // 1710-1714
  4,   2, // 1715-1716
  4,   2,   2,   2, // 1717-1720
  3,   2, // 1721-1722
  3,   2,   2, // 1723-1725
  3,   2, // 1726-1727
  3, // 1728
  3, // 1729
  1,   2, // 1730-1731
  2, // 1732
  1,   2, // 1733-1734
  4,   7,   1, // 1735-1737
  9,   2, // 1738-1739
  9,   2, // 1740-1741
  9,   3,   1,   2, // 1742-1745
  9,   2,   1,   2, // 1746-1749
  9,   3,   2,   1,   2, // 1750-1754
  9,   3,   1,   2, // 1755-1758
  9,   1,   2, // 1759-1761
  9,   2,   1,   2, // 1762-1765
  9,   3,   2,   1,   2, // 1766-1770
  9,   3,   1,   2, // 1771-1774
  2,   1,   2,   5, // 1775-1778
  3,   2,   1,   2,   5, // 1779-1783
  3,   1,   2,   5, // 1784-1787
  1,   2,   5, // 1788-1790
  2,   1,   2,   5, // 1791-1794
  3,   2,   1,   2,   5, // 1795-1799
  3,   1,   2,   5, // 1800-1803
  2,   1,   2,   7, // 1804-1807
  3,   2,   1,   2,   7, // 1808-1812
  7,   1,   2,   7, // 1813-1816
  3,   7,   1,   2,   7, // 1817-1821
  3,   1,   2,   7, // 1822-1825
  1,   2, // 1826-1827
  3,   1,   2, // 1828-1830
  9,   5,   5, // 1831-1833
  9,   7,   7,   7, // 1834-1837
  9,   9,   7,   7,   7, // 1838-1842
  9,   5,   5, // 1843-1845
  9,   5,   5, // 1846-1848
  9,   7,   5,   5, // 1849-1852
  9,   5,   5,   2, // 1853-1856
  9,   7,   2, // 1857-1859
  9,   7,   7,   2, // 1860-1863
  9,   5,   2, // 1864-1866
  9,   7,   5,   2, // 1867-1870
  9,   5, // 1871-1872
  9,   9,   5,   5,   2, // 1873-1877
  9,   5, // 1878-1879
  9,   5,   5, // 1880-1882
  9,   5,   5,   2, // 1883-1886
  9,   5,   2, // 1887-1889
  9,   7,   5,   2, // 1890-1893
  9,   5,   2, // 1894-1896
  9,   7,   5,   2, // 1897-1900
  1,   2,   7, // 1901-1903
  7,   1,   2,   7, // 1904-1907
  1,   2,   7, // 1908-1910
  7,   1,   2,   7, // 1911-1914
  3, // 1915
  9,   5,   2, // 1916-1918
  9,   7,   5,   5,   2, // 1919-1923
  9,   5,   5,   2, // 1924-1927
  9,   5,   2, // 1928-1930
  9,   7,   5,   2, // 1931-1934
  9,   5,   2,   2, // 1935-1938
  9,   7,   5,   2,   2, // 1939-1943
  9,   5,   2, // 1944-1946
  9,   7,   7, // 1947-1949
  9,   7, // 1950-1951
  1,   2,   7,   7, // 1952-1955
  7,   1,   2,   7,   7, // 1956-1960
  1,   2,   7,   7, // 1961-1964
  7,   1,   2,   7,   7, // 1965-1969
  9,   7,   7,   7, // 1970-1973
  9,   5, // 1974-1975
  9,   7,   5, // 1976-1978
  2, // 1979
  3,   2, // 1980-1981
  1, // 1982
  1,   2, // 1983-1984
  1, // 1985
  1,   1, // 1986-1987
  1, // 1988
  4,   2,   2, // 1989-1991
  1,   1,   1, // 1992-1994
  3,   2, // 1995-1996
  3,   2,   2,   2, // 1997-2000
  4,   3,   2,   2, // 2001-2004
  3,   2,   2, // 2005-2007
  4,   3,   2, // 2008-2010
  3,   2,   2, // 2011-2013
  3,   2,   2, // 2014-2016
  3,   2,   2, // 2017-2019
  3,   2,   2, // 2020-2022
  1,   1,   1, // 2023-2025
  2, // 2026
  2,   2, // 2027-2028
  2,   2, // 2029-2030
  4,   1,   2, // 2031-2033
  4,   2,   1,   2, // 2034-2037
  4,   1,   2, // 2038-2040
  4,   3,   1,   2, // 2041-2044
  1,   2,   2, // 2045-2047
  3,   2,   1, // 2048-2050
  3,   3,   1, // 2051-2053
  2, // 2054
  3, // 2055
  4,   1, // 2056-2057
  3,   1, // 2058-2059
  3,   1, // 2060-2061
  4,   1,   2, // 2062-2064
  4,   1,   1, // 2065-2067
  4,   2,   1,   1, // 2068-2071
  4,   3,   1,   2,   2, // 2072-2076
  9,   7,   7, // 2077-2079
  3,   1,   2,   2,   2, // 2080-2084
  3,   1,   2,   2, // 2085-2088
  2, // 2089
  9,   7,   7, // 2090-2092
  9,   1,   2, // 2093-2095
  9,   1,   2, // 2096-2098
  1,   1,   1, // 2099-2101
  9,   2,   7, // 2102-2104
  1,   2,   7, // 2105-2107
  1,   2,   5, // 2108-2110
  9,   2,   7,   7, // 2111-2114
  4,   2,   2, // 2115-2117
  2,   1,   2,   2, // 2118-2121
  2,   1,   2,   3, // 2122-2125
  1,   2,   2, // 2126-2128
  1,   2,   3, // 2129-2131
  4,   2,   2,   2,   2, // 2132-2136
  3,   1,   2,   3, // 2137-2140
  3,   1,   2, // 2141-2143
  1,   1,   1, // 2144-2146
  9,   7,   7,   7, // 2147-2150
  9,   7, // 2151-2152
  9,   5,   5,   2, // 2153-2156
  9, // 2157
  1, // 2158
  4,   2, // 2159-2160
  4,   2,   2, // 2161-2163
  4,   2,   2, // 2164-2166
  4,   2,   2, // 2167-2169
  3,   2, // 2170-2171
  3,   2,   2, // 2172-2174
  4,   2, // 2175-2176
  4,   1, // 2177-2178
  3,   2,   2, // 2179-2181
  3,   4,   2,   2,   2, // 2182-2186
  3,   2,   2, // 2187-2189
  2, // 2190
  4,   1,   1, // 2191-2193
  4,   1,   1,   2, // 2194-2197
  4,   4,   2,   1,   1, // 2198-2202
  3,   2,   2, // 2203-2205
  4,   4,   2,   2, // 2206-2209
  3,   2, // 2210-2211
  3,   2,   2, // 2212-2214
  3,   2, // 2215-2216
  3,   2,   2,   2, // 2217-2220
  4,   2, // 2221-2222
  3,   2,   2,   2, // 2223-2226
  2, // 2227
  5,   1, // 2228-2229
  4,   2, // 2230-2231
  5,   1,   1, // 2232-2234
  5,   2,   1,   1, // 2235-2238
  5,   2,   1,   1,   2, // 2239-2243
  5,   5,   1, // 2244-2246
  4,   2,   2, // 2247-2249
  5,   5,   1,   1, // 2250-2253
  4,   2, // 2254-2255
  4,   1, // 2256-2257
  2,   2, // 2258-2259
  1, // 2260
  2,   1, // 2261-2262
  2, // 2263
  3,   2, // 2264-2265
  2,   2, // 2266-2267
  3,   2, // 2268-2269
  2,   2, // 2270-2271
  2,   2, // 2272-2273
  2,   2, // 2274-2275
  2,   1, // 2276-2277
  2, // 2278
  2,   2, // 2279-2280
  2,   1, // 2281-2282
  2, // 2283
  3,   2,   2, // 2284-2286
  2,   2,   2, // 2287-2289
  3,   2,   2, // 2290-2292
  2,   2,   2, // 2293-2295
  2,   3,   2, // 2296-2298
  3,   2,   2, // 2299-2301
  3,   2, // 2302-2303
  2,   2, // 2304-2305
  4,   3,   2,   1,   2, // 2306-2310
  4,   3,   2,   1,   2,   2, // 2311-2316
  4,   2, // 2317-2318
  4,   1, // 2319-2320
  4,   4,   3,   1,   2, // 2321-2325
  4,   3,   2,   2, // 2326-2329
  4,   2,   1,   2,   2, // 2330-2334
  4,   3,   2, // 2335-2337
  4,   1,   2,   2, // 2338-2341
  4,   1,   1,   2, // 2342-2345
  4,   2,   2, // 2346-2348
  4,   2,   1,   1,   2, // 2349-2353
  4,   3,   1,   1,   2, // 2354-2358
  4,   2,   2,   2, // 2359-2362
  4,   2,   1,   2, // 2363-2366
  4,   2,   2,   2, // 2367-2370
  4,   2,   2,   1, // 2371-2374
  4,   2,   2, // 2375-2377
  2,   2, // 2378-2379
  2,   3, // 2380-2381
  4,   2, // 2382-2383
  4,   1,   1, // 2384-2386
  3,   2,   1,   2,   2, // 2387-2391
  4,   3,   1,   2,   1, // 2392-2396
  3,   2,   1,   2,   3, // 2397-2401
  4,   3,   1,   2,   3, // 2402-2406
  3,   1,   2,   2,   3, // 2407-2411
  4,   1,   1, // 2412-2414
  2,   2,   2, // 2415-2417
  2,   1,   1,   2,   2, // 2418-2422
  3,   2,   2, // 2423-2425
  3,   1,   1,   2,   2, // 2426-2430
  2,   2,   3, // 2431-2433
  2,   1,   1,   2,   3, // 2434-2438
  3,   2,   3, // 2439-2441
  3,   1,   1,   2,   3, // 2442-2446
  1,   1,   2,   2, // 2447-2450
  1,   2,   2,   2, // 2451-2454
  1,   1,   2,   3, // 2455-2458
  1,   2,   2,   3, // 2459-2462
  4,   1,   1,   2, // 2463-2466
  4,   2,   1,   1,   2, // 2467-2471
  4,   2, // 2472-2473
  4,   2,   2,   2, // 2474-2477
  3,   2, // 2478-2479
  3,   2,   2, // 2480-2482
  3,   2, // 2483-2484
  3, // 2485
  4, // 2486
  2,   2, // 2487-2488
  2, // 2489
  1,   2, // 2490-2491
  4,   7,   1, // 2492-2494
  9,   2, // 2495-2496
  9,   2, // 2497-2498
  9,   3,   1,   2, // 2499-2502
  9,   2,   1,   2, // 2503-2506
  9,   3,   2,   1,   2, // 2507-2511
  9,   3,   1,   2, // 2512-2515
  9,   1,   2, // 2516-2518
  9,   2,   1,   2, // 2519-2522
  9,   3,   2,   1,   2, // 2523-2527
  9,   3,   1,   2, // 2528-2531
  2,   1,   2,   5, // 2532-2535
  3,   2,   1,   2,   5, // 2536-2540
  3,   1,   2,   5, // 2541-2544
  1,   2,   5, // 2545-2547
  2,   1,   2,   5, // 2548-2551
  3,   2,   1,   2,   5, // 2552-2556
  3,   1,   2,   5, // 2557-2560
  2,   1,   2,   7, // 2561-2564
  3,   2,   1,   2,   7, // 2565-2569
  7,   1,   2,   7, // 2570-2573
  3,   7,   1,   2,   7, // 2574-2578
  3,   1,   2,   7, // 2579-2582
  1,   2, // 2583-2584
  3,   1,   2, // 2585-2587
  9,   5,   5, // 2588-2590
  9,   7,   7,   7, // 2591-2594
  9,   9,   7,   7,   7, // 2595-2599
  9,   5,   5, // 2600-2602
  9,   5,   5, // 2603-2605
  9,   7,   5,   5, // 2606-2609
  9,   5,   5,   2, // 2610-2613
  9,   7,   2, // 2614-2616
  9,   7,   7,   2, // 2617-2620
  9,   5,   2, // 2621-2623
  9,   7,   5,   2, // 2624-2627
  9,   5, // 2628-2629
  9,   9,   5,   5,   2, // 2630-2634
  9,   5, // 2635-2636
  9,   5,   5, // 2637-2639
  9,   5,   5,   2, // 2640-2643
  9,   5,   2, // 2644-2646
  9,   7,   5,   2, // 2647-2650
  9,   5,   2, // 2651-2653
  9,   7,   5,   2, // 2654-2657
  1,   2,   7, // 2658-2660
  7,   1,   2,   7, // 2661-2664
  1,   2,   7, // 2665-2667
  7,   1,   2,   7, // 2668-2671
  3, // 2672
  9,   5,   2, // 2673-2675
  9,   7,   5,   5,   2, // 2676-2680
  9,   5,   5,   2, // 2681-2684
  9,   5,   2, // 2685-2687
  9,   7,   5,   2, // 2688-2691
  9,   5,   2,   2, // 2692-2695
  9,   7,   5,   2,   2, // 2696-2700
  9,   5,   2, // 2701-2703
  9,   7,   7, // 2704-2706
  9,   7, // 2707-2708
  1,   2,   7,   7, // 2709-2712
  7,   1,   2,   7,   7, // 2713-2717
  1,   2,   7,   7, // 2718-2721
  7,   1,   2,   7,   7, // 2722-2726
  9,   7,   7,   7, // 2727-2730
  9,   5, // 2731-2732
  9,   7,   5, // 2733-2735
  2, // 2736
  3,   2, // 2737-2738
  1, // 2739
  1,   2, // 2740-2741
  1, // 2742
  1,   1, // 2743-2744
  1, // 2745
  0 // End operand cycles
};
extern const unsigned HexagonForwardingPaths[] = {
 0, // No itinerary
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 1-3
 0,  0,  0, // 4-6
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 7-8
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 9-12
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 13-16
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 17-19
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 20-22
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 23-25
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 26-28
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 29-31
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 32-34
 0,  0,  0, // 35-37
 0, // 38
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 39-40
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 41-42
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 43-45
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 46-49
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 50-52
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 53-56
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 57-59
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 60-62
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 63-65
HexagonItinerariesV60Bypass::Hex_FWD, // 66
HexagonItinerariesV60Bypass::Hex_FWD, // 67
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 68-69
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 70-71
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 72-73
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 74-76
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 77-79
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 80-83
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 84-88
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 89-91
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 92-96
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 97-100
HexagonItinerariesV60Bypass::Hex_FWD, // 101
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 102-104
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 105-107
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 108-110
 0,  0,  0, // 111-113
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 114-116
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 117-119
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 120-122
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 123-126
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 127-129
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 130-133
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 134-137
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 138-140
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 141-143
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 144-148
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 149-152
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 153-155
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 156-158
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD,  0, // 159-162
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 163-164
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 165-168
HexagonItinerariesV60Bypass::HVX_FWD, // 169
HexagonItinerariesV60Bypass::Hex_FWD, // 170
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 171-172
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 173-175
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 176-178
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 179-181
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 182-183
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 184-186
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 187-188
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 189-190
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 191-193
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 194-198
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 199-201
HexagonItinerariesV60Bypass::Hex_FWD, // 202
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 203-205
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 206-209
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 210-214
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 215-217
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 218-221
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 222-223
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 224-226
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 227-228
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 229-232
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 233-234
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 235-238
HexagonItinerariesV60Bypass::Hex_FWD, // 239
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 240-241
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 242-243
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 244-246
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 247-250
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 251-255
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 256-258
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 259-261
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 262-265
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 266-267
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 268-269
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 270-271
HexagonItinerariesV60Bypass::Hex_FWD, // 272
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 273-274
HexagonItinerariesV60Bypass::Hex_FWD, // 275
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 276-277
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 278-279
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 280-281
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 282-283
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 284-285
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 286-287
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 288-289
HexagonItinerariesV60Bypass::Hex_FWD, // 290
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 291-292
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 293-294
HexagonItinerariesV60Bypass::Hex_FWD, // 295
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 296-298
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 299-301
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 302-304
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 305-307
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 308-310
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 311-313
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 314-315
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 316-317
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 318-322
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 323-328
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 329-330
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 331-332
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 333-337
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 338-341
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 342-346
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 347-349
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 350-353
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 354-357
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 358-360
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 361-365
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 366-370
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 371-374
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 375-378
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 379-382
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 383-386
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 387-389
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 390-391
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 392-393
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 394-395
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 396-398
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 399-403
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 404-408
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 409-413
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 414-418
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 419-423
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 424-426
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 427-429
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 430-434
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 435-437
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 438-442
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 443-445
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 446-450
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 451-453
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 454-458
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 459-462
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 463-466
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 467-470
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 471-474
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 475-478
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 479-483
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 484-485
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 486-489
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 490-491
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 492-494
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 495-496
HexagonItinerariesV60Bypass::Hex_FWD, // 497
HexagonItinerariesV60Bypass::Hex_FWD, // 498
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 499-500
HexagonItinerariesV60Bypass::Hex_FWD, // 501
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 502-503
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 504-506
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 507-508
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 509-510
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 511-514
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 515-518
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 519-523
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 524-527
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 528-530
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 531-534
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 535-539
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 540-543
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 544-547
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 548-552
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 553-556
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 557-559
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 560-563
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 564-568
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 569-572
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 573-576
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 577-581
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 582-585
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 586-590
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 591-594
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 595-596
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 597-599
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 600-602
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 603-606
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 607-611
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 612-614
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 615-617
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 618-621
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 622-625
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 626-628
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 629-632
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 633-635
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 636-639
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 640-641
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 642-646
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 647-648
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 649-651
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 652-655
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 656-658
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 659-662
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 663-665
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 666-669
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 670-672
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 673-676
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 677-679
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 680-683
HexagonItinerariesV60Bypass::HVX_FWD, // 684
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 685-687
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 688-692
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 693-696
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 697-699
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 700-703
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 704-707
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 708-712
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 713-715
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 716-718
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 719-720
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 721-724
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 725-729
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 730-733
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 734-738
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 739-742
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 743-744
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::HVX_FWD, // 745-747
HexagonItinerariesV60Bypass::Hex_FWD, // 748
HexagonItinerariesV60Bypass::HVX_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 749-750
HexagonItinerariesV60Bypass::Hex_FWD, // 751
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 752-753
HexagonItinerariesV60Bypass::Hex_FWD, // 754
HexagonItinerariesV60Bypass::Hex_FWD, HexagonItinerariesV60Bypass::Hex_FWD, // 755-756
HexagonItinerariesV60Bypass::Hex_FWD, // 757
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 758-760
 0,  0,  0, // 761-763
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 764-765
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 766-769
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 770-773
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 774-776
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 777-779
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 780-782
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 783-785
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 786-788
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 789-791
 0,  0,  0, // 792-794
 0, // 795
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 796-797
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 798-799
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 800-802
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 803-806
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 807-809
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 810-813
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 814-816
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 817-819
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 820-822
HexagonItinerariesV55Bypass::Hex_FWD, // 823
HexagonItinerariesV55Bypass::Hex_FWD, // 824
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 825-826
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 827-828
 0,  0, // 829-830
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 831-833
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 834-836
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 837-840
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 841-845
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 846-850
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 851-854
HexagonItinerariesV55Bypass::Hex_FWD, // 855
 0,  0,  0, // 856-858
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 859-861
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 862-865
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 866-869
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 870-872
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 873-875
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 876-880
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 881-884
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 885-887
 0,  0,  0, // 888-890
HexagonItinerariesV55Bypass::Hex_FWD, // 891
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 892-893
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 894-896
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 897-899
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 900-902
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 903-904
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 905-907
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 908-909
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 910-911
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 912-914
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 915-919
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 920-922
HexagonItinerariesV55Bypass::Hex_FWD, // 923
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 924-926
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 927-930
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 931-935
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 936-938
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 939-942
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 943-944
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 945-947
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 948-949
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 950-953
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 954-955
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 956-959
HexagonItinerariesV55Bypass::Hex_FWD, // 960
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 961-962
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 963-964
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 965-967
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 968-971
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 972-976
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 977-979
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 980-982
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 983-986
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 987-988
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 989-990
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 991-992
HexagonItinerariesV55Bypass::Hex_FWD, // 993
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 994-995
HexagonItinerariesV55Bypass::Hex_FWD, // 996
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 997-998
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 999-1000
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1001-1002
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1003-1004
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1005-1006
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1007-1008
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1009-1010
HexagonItinerariesV55Bypass::Hex_FWD, // 1011
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1012-1013
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1014-1015
HexagonItinerariesV55Bypass::Hex_FWD, // 1016
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1017-1019
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1020-1022
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1023-1025
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1026-1028
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1029-1031
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1032-1034
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1035-1036
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1037-1038
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1039-1043
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1044-1049
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1050-1051
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1052-1053
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1054-1058
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1059-1062
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1063-1067
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1068-1070
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1071-1074
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1075-1078
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1079-1081
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1082-1086
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1087-1091
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1092-1095
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1096-1099
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1100-1103
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1104-1107
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1108-1110
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1111-1112
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1113-1114
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1115-1116
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1117-1119
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1120-1124
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1125-1129
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1130-1134
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1135-1139
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1140-1144
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1145-1147
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1148-1150
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1151-1155
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1156-1158
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1159-1163
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1164-1166
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1167-1171
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1172-1174
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1175-1179
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1180-1183
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1184-1187
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1188-1191
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1192-1195
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1196-1199
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1200-1204
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1205-1206
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1207-1210
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1211-1212
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1213-1215
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1216-1217
HexagonItinerariesV55Bypass::Hex_FWD, // 1218
HexagonItinerariesV55Bypass::Hex_FWD, // 1219
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1220-1221
HexagonItinerariesV55Bypass::Hex_FWD, // 1222
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1223-1224
HexagonItinerariesV55Bypass::Hex_FWD, // 1225
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1226-1227
HexagonItinerariesV55Bypass::Hex_FWD, // 1228
HexagonItinerariesV55Bypass::Hex_FWD, HexagonItinerariesV55Bypass::Hex_FWD, // 1229-1230
HexagonItinerariesV55Bypass::Hex_FWD, // 1231
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1232-1234
 0,  0,  0, // 1235-1237
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1238-1239
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1240-1243
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1244-1247
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1248-1250
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1251-1253
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1254-1256
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1257-1259
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1260-1262
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1263-1265
 0,  0,  0, // 1266-1268
 0, // 1269
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1270-1271
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1272-1273
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1274-1276
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1277-1280
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1281-1283
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1284-1287
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1288-1290
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1291-1293
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1294-1296
HexagonItinerariesV62Bypass::Hex_FWD, // 1297
HexagonItinerariesV62Bypass::Hex_FWD, // 1298
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1299-1300
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1301-1302
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1303-1304
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1305-1307
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1308-1310
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1311-1314
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1315-1319
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1320-1322
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1323-1327
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1328-1331
HexagonItinerariesV62Bypass::Hex_FWD, // 1332
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1333-1335
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1336-1338
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1339-1341
 0,  0,  0, // 1342-1344
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1345-1347
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1348-1350
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1351-1353
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1354-1357
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1358-1360
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1361-1364
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1365-1368
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1369-1371
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1372-1374
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1375-1379
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1380-1383
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1384-1386
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1387-1389
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD,  0, // 1390-1393
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1394-1395
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1396-1399
HexagonItinerariesV62Bypass::HVX_FWD, // 1400
HexagonItinerariesV62Bypass::Hex_FWD, // 1401
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1402-1403
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1404-1406
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1407-1409
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1410-1412
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1413-1414
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1415-1417
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1418-1419
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1420-1421
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1422-1424
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1425-1429
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1430-1432
HexagonItinerariesV62Bypass::Hex_FWD, // 1433
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1434-1436
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1437-1440
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1441-1445
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1446-1448
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1449-1452
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1453-1454
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1455-1457
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1458-1459
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1460-1463
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1464-1465
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1466-1469
HexagonItinerariesV62Bypass::Hex_FWD, // 1470
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1471-1472
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1473-1474
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1475-1477
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1478-1481
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1482-1486
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1487-1489
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1490-1492
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1493-1496
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1497-1498
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1499-1500
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1501-1502
HexagonItinerariesV62Bypass::Hex_FWD, // 1503
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1504-1505
HexagonItinerariesV62Bypass::Hex_FWD, // 1506
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1507-1508
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1509-1510
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1511-1512
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1513-1514
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1515-1516
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1517-1518
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1519-1520
HexagonItinerariesV62Bypass::Hex_FWD, // 1521
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1522-1523
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1524-1525
HexagonItinerariesV62Bypass::Hex_FWD, // 1526
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1527-1529
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1530-1532
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1533-1535
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1536-1538
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1539-1541
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1542-1544
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1545-1546
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1547-1548
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1549-1553
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1554-1559
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1560-1561
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1562-1563
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1564-1568
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1569-1572
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1573-1577
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1578-1580
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1581-1584
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1585-1588
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1589-1591
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1592-1596
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1597-1601
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1602-1605
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1606-1609
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1610-1613
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1614-1617
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1618-1620
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1621-1622
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1623-1624
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1625-1626
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1627-1629
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1630-1634
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1635-1639
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1640-1644
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1645-1649
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1650-1654
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1655-1657
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1658-1660
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1661-1665
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1666-1668
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1669-1673
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1674-1676
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1677-1681
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1682-1684
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1685-1689
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1690-1693
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1694-1697
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1698-1701
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1702-1705
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1706-1709
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1710-1714
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1715-1716
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1717-1720
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1721-1722
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1723-1725
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1726-1727
HexagonItinerariesV62Bypass::Hex_FWD, // 1728
HexagonItinerariesV62Bypass::Hex_FWD, // 1729
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1730-1731
HexagonItinerariesV62Bypass::Hex_FWD, // 1732
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1733-1734
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1735-1737
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1738-1739
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1740-1741
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1742-1745
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1746-1749
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1750-1754
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1755-1758
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1759-1761
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1762-1765
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1766-1770
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1771-1774
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1775-1778
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1779-1783
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1784-1787
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1788-1790
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1791-1794
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1795-1799
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1800-1803
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1804-1807
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1808-1812
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1813-1816
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1817-1821
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1822-1825
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1826-1827
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1828-1830
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1831-1833
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1834-1837
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1838-1842
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1843-1845
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1846-1848
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1849-1852
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1853-1856
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1857-1859
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1860-1863
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1864-1866
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1867-1870
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1871-1872
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1873-1877
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1878-1879
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1880-1882
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1883-1886
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1887-1889
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1890-1893
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1894-1896
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1897-1900
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1901-1903
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1904-1907
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1908-1910
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1911-1914
HexagonItinerariesV62Bypass::HVX_FWD, // 1915
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1916-1918
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1919-1923
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1924-1927
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1928-1930
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1931-1934
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1935-1938
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1939-1943
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1944-1946
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1947-1949
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1950-1951
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1952-1955
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1956-1960
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1961-1964
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1965-1969
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1970-1973
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1974-1975
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::HVX_FWD, // 1976-1978
HexagonItinerariesV62Bypass::Hex_FWD, // 1979
HexagonItinerariesV62Bypass::HVX_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1980-1981
HexagonItinerariesV62Bypass::Hex_FWD, // 1982
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1983-1984
HexagonItinerariesV62Bypass::Hex_FWD, // 1985
HexagonItinerariesV62Bypass::Hex_FWD, HexagonItinerariesV62Bypass::Hex_FWD, // 1986-1987
HexagonItinerariesV62Bypass::Hex_FWD, // 1988
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 1989-1991
 0,  0,  0, // 1992-1994
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 1995-1996
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 1997-2000
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2001-2004
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2005-2007
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2008-2010
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2011-2013
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2014-2016
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2017-2019
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2020-2022
 0,  0,  0, // 2023-2025
 0, // 2026
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2027-2028
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2029-2030
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2031-2033
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2034-2037
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2038-2040
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2041-2044
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2045-2047
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2048-2050
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2051-2053
HexagonItinerariesV65Bypass::Hex_FWD, // 2054
HexagonItinerariesV65Bypass::Hex_FWD, // 2055
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2056-2057
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2058-2059
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2060-2061
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2062-2064
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2065-2067
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2068-2071
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2072-2076
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2077-2079
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2080-2084
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2085-2088
HexagonItinerariesV65Bypass::Hex_FWD, // 2089
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2090-2092
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2093-2095
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2096-2098
 0,  0,  0, // 2099-2101
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2102-2104
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2105-2107
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2108-2110
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2111-2114
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2115-2117
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2118-2121
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2122-2125
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2126-2128
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2129-2131
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2132-2136
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2137-2140
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2141-2143
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2144-2146
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD,  0, // 2147-2150
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2151-2152
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2153-2156
HexagonItinerariesV65Bypass::HVX_FWD, // 2157
HexagonItinerariesV65Bypass::Hex_FWD, // 2158
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2159-2160
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2161-2163
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2164-2166
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2167-2169
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2170-2171
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2172-2174
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2175-2176
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2177-2178
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2179-2181
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2182-2186
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2187-2189
HexagonItinerariesV65Bypass::Hex_FWD, // 2190
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2191-2193
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2194-2197
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2198-2202
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2203-2205
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2206-2209
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2210-2211
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2212-2214
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2215-2216
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2217-2220
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2221-2222
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2223-2226
HexagonItinerariesV65Bypass::Hex_FWD, // 2227
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2228-2229
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2230-2231
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2232-2234
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2235-2238
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2239-2243
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2244-2246
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2247-2249
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2250-2253
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2254-2255
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2256-2257
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2258-2259
HexagonItinerariesV65Bypass::Hex_FWD, // 2260
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2261-2262
HexagonItinerariesV65Bypass::Hex_FWD, // 2263
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2264-2265
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2266-2267
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2268-2269
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2270-2271
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2272-2273
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2274-2275
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2276-2277
HexagonItinerariesV65Bypass::Hex_FWD, // 2278
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2279-2280
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2281-2282
HexagonItinerariesV65Bypass::Hex_FWD, // 2283
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2284-2286
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2287-2289
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2290-2292
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2293-2295
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2296-2298
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2299-2301
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2302-2303
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2304-2305
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2306-2310
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2311-2316
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2317-2318
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2319-2320
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2321-2325
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2326-2329
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2330-2334
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2335-2337
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2338-2341
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2342-2345
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2346-2348
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2349-2353
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2354-2358
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2359-2362
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2363-2366
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2367-2370
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2371-2374
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2375-2377
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2378-2379
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2380-2381
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2382-2383
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2384-2386
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2387-2391
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2392-2396
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2397-2401
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2402-2406
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2407-2411
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2412-2414
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2415-2417
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2418-2422
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2423-2425
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2426-2430
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2431-2433
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2434-2438
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2439-2441
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2442-2446
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2447-2450
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2451-2454
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2455-2458
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2459-2462
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2463-2466
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2467-2471
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2472-2473
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2474-2477
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2478-2479
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2480-2482
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2483-2484
HexagonItinerariesV65Bypass::Hex_FWD, // 2485
HexagonItinerariesV65Bypass::Hex_FWD, // 2486
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2487-2488
HexagonItinerariesV65Bypass::Hex_FWD, // 2489
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2490-2491
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2492-2494
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2495-2496
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2497-2498
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2499-2502
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2503-2506
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2507-2511
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2512-2515
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2516-2518
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2519-2522
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2523-2527
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2528-2531
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2532-2535
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2536-2540
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2541-2544
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2545-2547
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2548-2551
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2552-2556
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2557-2560
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2561-2564
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2565-2569
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2570-2573
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2574-2578
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2579-2582
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2583-2584
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2585-2587
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2588-2590
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2591-2594
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2595-2599
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2600-2602
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2603-2605
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2606-2609
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2610-2613
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2614-2616
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2617-2620
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2621-2623
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2624-2627
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2628-2629
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2630-2634
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2635-2636
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2637-2639
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2640-2643
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2644-2646
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2647-2650
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2651-2653
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2654-2657
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2658-2660
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2661-2664
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2665-2667
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2668-2671
HexagonItinerariesV65Bypass::HVX_FWD, // 2672
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2673-2675
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2676-2680
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2681-2684
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2685-2687
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2688-2691
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2692-2695
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2696-2700
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2701-2703
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2704-2706
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2707-2708
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2709-2712
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2713-2717
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2718-2721
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2722-2726
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2727-2730
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2731-2732
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::HVX_FWD, // 2733-2735
HexagonItinerariesV65Bypass::Hex_FWD, // 2736
HexagonItinerariesV65Bypass::HVX_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2737-2738
HexagonItinerariesV65Bypass::Hex_FWD, // 2739
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2740-2741
HexagonItinerariesV65Bypass::Hex_FWD, // 2742
HexagonItinerariesV65Bypass::Hex_FWD, HexagonItinerariesV65Bypass::Hex_FWD, // 2743-2744
HexagonItinerariesV65Bypass::Hex_FWD, // 2745
 0 // End bypass tables
};

static const llvm::InstrItinerary HexagonItinerariesV60[] = {
  { 0, 0, 0, 0, 0 }, // 0 NoInstrModel
  { 1, 1, 2, 1, 4 }, // 1 tc_897d1a9d
  { 1, 2, 3, 4, 7 }, // 2 PSEUDO
  { 1, 2, 3, 7, 9 }, // 3 tc_68cb12ce
  { 1, 2, 3, 9, 13 }, // 4 tc_d6bf0472
  { 1, 2, 3, 13, 17 }, // 5 tc_2b2f4060
  { 1, 2, 3, 17, 20 }, // 6 tc_b9488031
  { 1, 2, 3, 20, 23 }, // 7 tc_5f6847a1
  { 1, 1, 2, 23, 26 }, // 8 tc_540fdfbc
  { 1, 1, 2, 26, 29 }, // 9 tc_1e856f58
  { 1, 2, 3, 29, 32 }, // 10 tc_6ebb4a12
  { 1, 1, 2, 32, 35 }, // 11 tc_53bc8a6a
  { 1, 3, 4, 35, 38 }, // 12 DUPLEX
  { 1, 4, 5, 38, 39 }, // 13 tc_ENDLOOP
  { 1, 2, 3, 0, 0 }, // 14 tc_52d7bbea
  { 1, 1, 2, 39, 41 }, // 15 tc_e9fae2d6
  { 1, 5, 6, 41, 43 }, // 16 tc_e0739b8c
  { 1, 5, 6, 43, 46 }, // 17 tc_59a01ead
  { 1, 6, 7, 46, 50 }, // 18 tc_ef52ed71
  { 1, 6, 7, 50, 53 }, // 19 tc_7f881c76
  { 1, 6, 7, 53, 57 }, // 20 tc_2fc0c436
  { 1, 3, 4, 57, 60 }, // 21 tc_44126683
  { 1, 3, 4, 60, 63 }, // 22 tc_513bef45
  { 1, 3, 4, 63, 66 }, // 23 tc_395dc00f
  { 1, 3, 4, 66, 67 }, // 24 tc_3bc2c5d3
  { 1, 3, 4, 67, 68 }, // 25 tc_e7624c08
  { 1, 6, 7, 68, 70 }, // 26 tc_d1090e34
  { 1, 3, 4, 70, 72 }, // 27 tc_3d04548d
  { 1, 6, 7, 72, 74 }, // 28 LD_tc_ld_SLOT01
  { 1, 1, 2, 74, 77 }, // 29 tc_1853ea6d
  { 1, 1, 2, 77, 80 }, // 30 tc_8fd5f294
  { 1, 1, 2, 80, 84 }, // 31 tc_e913dc32
  { 1, 6, 7, 84, 89 }, // 32 tc_4403ca65
  { 1, 7, 9, 89, 92 }, // 33 tc_bbaf280e
  { 1, 6, 7, 92, 97 }, // 34 tc_9fdb5406
  { 1, 6, 7, 97, 101 }, // 35 tc_f86c328a
  { 1, 5, 6, 101, 102 }, // 36 tc_9faf76ae
  { 1, 9, 11, 102, 105 }, // 37 tc_97c165b9
  { 1, 11, 14, 105, 108 }, // 38 tc_b712833a
  { 1, 14, 18, 108, 111 }, // 39 tc_35e92f8e
  { 1, 18, 20, 111, 114 }, // 40 PSEUDOM
  { 1, 7, 9, 114, 117 }, // 41 tc_b06ab583
  { 1, 20, 23, 117, 120 }, // 42 tc_e3748cdf
  { 1, 23, 27, 120, 123 }, // 43 tc_354299ad
  { 1, 9, 11, 123, 127 }, // 44 tc_2171ebae
  { 1, 1, 2, 127, 130 }, // 45 tc_2b6f77c6
  { 1, 6, 7, 130, 134 }, // 46 tc_8b15472a
  { 1, 3, 4, 134, 138 }, // 47 tc_594ab548
  { 1, 6, 7, 138, 141 }, // 48 tc_05b6c987
  { 1, 3, 4, 141, 144 }, // 49 tc_f7dd9c9f
  { 1, 1, 2, 144, 149 }, // 50 tc_87735c3b
  { 1, 3, 4, 149, 153 }, // 51 tc_e7d02c66
  { 1, 3, 4, 153, 156 }, // 52 tc_e216a5db
  { 1, 6, 7, 156, 159 }, // 53 ST_tc_st_SLOT01
  { 1, 27, 29, 159, 163 }, // 54 CVI_VA
  { 1, 7, 9, 163, 165 }, // 55 tc_71337255
  { 1, 29, 31, 165, 169 }, // 56 tc_7fa8b40f
  { 1, 9, 11, 169, 170 }, // 57 tc_8a6eb39a
  { 1, 31, 35, 0, 0 }, // 58 CVI_GATHER_PSEUDO
  { 1, 3, 4, 170, 171 }, // 59 tc_3da80ba5
  { 1, 1, 2, 171, 173 }, // 60 tc_c2f7d806
  { 1, 1, 2, 173, 176 }, // 61 tc_b44c6e2a
  { 1, 1, 2, 176, 179 }, // 62 tc_1b9c9ee5
  { 1, 2, 3, 179, 182 }, // 63 tc_5ba5997d
  { 1, 1, 2, 182, 184 }, // 64 tc_cde8b071
  { 1, 2, 3, 0, 0 }, // 65 tc_6efc556e
  { 1, 2, 3, 184, 187 }, // 66 tc_8fe6b782
  { 1, 35, 36, 187, 189 }, // 67 tc_29175780
  { 1, 35, 36, 189, 191 }, // 68 tc_a21dc435
  { 1, 1, 2, 191, 194 }, // 69 tc_dbdffe3d
  { 1, 1, 2, 194, 199 }, // 70 tc_523fcf30
  { 1, 1, 2, 199, 202 }, // 71 tc_7a830544
  { 1, 2, 3, 202, 203 }, // 72 tc_452f85af
  { 1, 1, 2, 203, 206 }, // 73 tc_04c9decc
  { 1, 1, 2, 206, 210 }, // 74 tc_c6ce9b3f
  { 1, 1, 2, 210, 215 }, // 75 tc_caaebcba
  { 1, 1, 2, 215, 218 }, // 76 tc_55050d58
  { 1, 1, 2, 218, 222 }, // 77 tc_ef84f62f
  { 1, 1, 2, 222, 224 }, // 78 tc_f2704b9a
  { 1, 2, 3, 224, 227 }, // 79 tc_c6aa82f7
  { 1, 1, 2, 227, 229 }, // 80 tc_351fed2d
  { 1, 1, 2, 229, 233 }, // 81 tc_f8eeed7a
  { 1, 35, 36, 233, 235 }, // 82 tc_b9c4623f
  { 1, 1, 2, 235, 239 }, // 83 tc_481e5e5c
  { 1, 1, 2, 239, 240 }, // 84 tc_a27582fa
  { 1, 1, 2, 240, 242 }, // 85 tc_f3eaa14b
  { 1, 1, 2, 242, 244 }, // 86 tc_234a11a5
  { 1, 1, 2, 244, 247 }, // 87 tc_6792d5ff
  { 1, 1, 2, 247, 251 }, // 88 tc_d580173f
  { 1, 1, 2, 251, 256 }, // 89 tc_038a1342
  { 1, 1, 2, 256, 259 }, // 90 tc_4d99bca9
  { 1, 1, 2, 259, 262 }, // 91 tc_976ddc4f
  { 1, 1, 2, 262, 266 }, // 92 tc_9c00ce8d
  { 1, 35, 36, 266, 268 }, // 93 tc_6fa4db47
  { 1, 35, 36, 268, 270 }, // 94 tc_994333cd
  { 1, 1, 2, 270, 272 }, // 95 tc_2f185f5c
  { 1, 5, 6, 272, 273 }, // 96 tc_15411484
  { 1, 5, 6, 273, 275 }, // 97 tc_10b97e27
  { 1, 1, 2, 275, 276 }, // 98 tc_3669266a
  { 1, 1, 2, 276, 278 }, // 99 tc_a46f0df5
  { 1, 1, 2, 278, 280 }, // 100 tc_e1e99bfa
  { 1, 5, 6, 280, 282 }, // 101 tc_181af5d0
  { 1, 5, 6, 282, 284 }, // 102 tc_97743097
  { 1, 35, 36, 284, 286 }, // 103 tc_73043bf4
  { 1, 35, 36, 286, 288 }, // 104 tc_cf59f215
  { 1, 35, 36, 288, 290 }, // 105 tc_7934b9df
  { 1, 5, 6, 290, 291 }, // 106 tc_681a2300
  { 1, 35, 36, 291, 293 }, // 107 tc_c5e2426d
  { 1, 35, 36, 293, 295 }, // 108 tc_4f7cd700
  { 1, 5, 6, 295, 296 }, // 109 tc_14cd4cfa
  { 1, 3, 4, 296, 299 }, // 110 tc_51b866be
  { 1, 1, 2, 299, 302 }, // 111 tc_855b0b61
  { 1, 3, 4, 302, 305 }, // 112 tc_bde7aaf4
  { 1, 1, 2, 305, 308 }, // 113 tc_99be14ca
  { 1, 3, 4, 308, 311 }, // 114 tc_5eb851fc
  { 1, 1, 2, 311, 314 }, // 115 tc_49eb22c8
  { 1, 3, 4, 314, 316 }, // 116 tc_746baa8e
  { 1, 1, 2, 316, 318 }, // 117 tc_3cb8ea06
  { 1, 6, 7, 318, 323 }, // 118 tc_bad2bcaf
  { 1, 6, 7, 323, 329 }, // 119 tc_03220ffa
  { 1, 6, 7, 329, 331 }, // 120 tc_9c98e8af
  { 1, 3, 4, 331, 333 }, // 121 tc_6aa5711a
  { 1, 6, 7, 333, 338 }, // 122 tc_63fe3df7
  { 1, 6, 7, 338, 342 }, // 123 tc_5acef64a
  { 1, 6, 7, 342, 347 }, // 124 tc_0cd51c76
  { 1, 6, 7, 347, 350 }, // 125 tc_b77c481f
  { 1, 6, 7, 350, 354 }, // 126 tc_cf47a43f
  { 1, 6, 7, 354, 358 }, // 127 tc_f47d212f
  { 1, 6, 7, 358, 361 }, // 128 tc_1d5a38a8
  { 1, 6, 7, 361, 366 }, // 129 tc_9ef61e5c
  { 1, 6, 7, 366, 371 }, // 130 tc_b7dd427e
  { 1, 1, 2, 371, 375 }, // 131 tc_c74f796f
  { 1, 1, 2, 375, 379 }, // 132 tc_16d0d8d5
  { 1, 1, 2, 379, 383 }, // 133 tc_84df2cd3
  { 1, 1, 2, 383, 387 }, // 134 tc_bcc96cee
  { 1, 1, 2, 387, 390 }, // 135 tc_f49e76f4
  { 1, 6, 7, 390, 392 }, // 136 tc_a788683e
  { 1, 3, 4, 392, 394 }, // 137 tc_ff9ee76e
  { 1, 1, 2, 394, 396 }, // 138 tc_d088982c
  { 1, 1, 2, 396, 399 }, // 139 tc_c6ebf8dd
  { 1, 6, 7, 399, 404 }, // 140 tc_cd7374a0
  { 1, 6, 7, 404, 409 }, // 141 tc_74e47fd9
  { 1, 3, 4, 409, 414 }, // 142 tc_d9f95eef
  { 1, 3, 4, 414, 419 }, // 143 tc_d24b2d85
  { 1, 3, 4, 419, 424 }, // 144 tc_9d5941c7
  { 1, 3, 4, 424, 427 }, // 145 tc_1372bca1
  { 1, 6, 7, 427, 430 }, // 146 tc_238d91d2
  { 1, 6, 7, 430, 435 }, // 147 tc_5274e61a
  { 1, 6, 7, 435, 438 }, // 148 tc_66888ded
  { 1, 6, 7, 438, 443 }, // 149 tc_3e07fb90
  { 1, 3, 4, 443, 446 }, // 150 tc_6ac37025
  { 1, 3, 4, 446, 451 }, // 151 tc_adb14c66
  { 1, 3, 4, 451, 454 }, // 152 tc_53bdb2f6
  { 1, 3, 4, 454, 459 }, // 153 tc_e421e012
  { 1, 6, 7, 459, 463 }, // 154 tc_d9709180
  { 1, 6, 7, 463, 467 }, // 155 tc_0dc560de
  { 1, 3, 4, 467, 471 }, // 156 tc_b166348b
  { 1, 3, 4, 471, 475 }, // 157 tc_a8acdac0
  { 1, 1, 2, 475, 479 }, // 158 tc_b9c0b731
  { 1, 1, 2, 479, 484 }, // 159 tc_60571023
  { 1, 1, 2, 484, 486 }, // 160 tc_00afc57e
  { 1, 1, 2, 486, 490 }, // 161 tc_41d5298e
  { 1, 1, 2, 490, 492 }, // 162 tc_be706f30
  { 1, 6, 7, 492, 495 }, // 163 tc_609d2efe
  { 1, 6, 7, 495, 497 }, // 164 tc_a904d137
  { 1, 6, 7, 497, 498 }, // 165 tc_1b82a277
  { 1, 6, 7, 498, 499 }, // 166 tc_e9c822f7
  { 1, 6, 7, 499, 501 }, // 167 tc_90f3e30c
  { 1, 6, 7, 0, 0 }, // 168 tc_36c68ad1
  { 1, 3, 4, 0, 0 }, // 169 tc_2a160009
  { 1, 3, 4, 0, 0 }, // 170 tc_fcab4871
  { 1, 3, 4, 501, 502 }, // 171 tc_0fc1ae07
  { 1, 6, 7, 502, 504 }, // 172 tc_57288781
  { 1, 36, 38, 504, 507 }, // 173 tc_9777e6bf
  { 1, 38, 40, 507, 509 }, // 174 tc_6b78cf13
  { 1, 40, 42, 509, 511 }, // 175 tc_4105d6b5
  { 1, 14, 18, 511, 515 }, // 176 tc_4fd8566e
  { 1, 11, 14, 515, 519 }, // 177 tc_5cbf490b
  { 1, 11, 14, 519, 524 }, // 178 tc_da979fb3
  { 1, 11, 14, 524, 528 }, // 179 tc_eb669007
  { 1, 42, 44, 528, 531 }, // 180 tc_77a4c701
  { 1, 42, 44, 531, 535 }, // 181 tc_51cd3aab
  { 1, 42, 44, 535, 540 }, // 182 tc_38208312
  { 1, 42, 44, 540, 544 }, // 183 tc_9c267309
  { 1, 23, 27, 544, 548 }, // 184 tc_d642eff3
  { 1, 23, 27, 548, 553 }, // 185 tc_6fd9ad30
  { 1, 23, 27, 553, 557 }, // 186 tc_7fa82b08
  { 1, 44, 46, 557, 560 }, // 187 tc_1b93bdc6
  { 1, 44, 46, 560, 564 }, // 188 tc_d5090f3e
  { 1, 44, 46, 564, 569 }, // 189 tc_8b6a873f
  { 1, 44, 46, 569, 573 }, // 190 tc_db5b9e2f
  { 1, 20, 23, 573, 577 }, // 191 tc_85d237e3
  { 1, 20, 23, 577, 582 }, // 192 tc_0317c6ca
  { 1, 20, 23, 582, 586 }, // 193 tc_aedb9f9e
  { 1, 20, 23, 586, 591 }, // 194 tc_99093773
  { 1, 20, 23, 591, 595 }, // 195 tc_a4c9df3b
  { 1, 44, 46, 595, 597 }, // 196 tc_29841470
  { 1, 44, 46, 597, 600 }, // 197 tc_5c03dc63
  { 1, 38, 40, 600, 603 }, // 198 tc_908a4c8c
  { 1, 7, 9, 603, 607 }, // 199 tc_a3127e12
  { 1, 7, 9, 607, 612 }, // 200 tc_5a9fc4ec
  { 1, 29, 31, 612, 615 }, // 201 tc_45453b98
  { 1, 46, 48, 615, 618 }, // 202 tc_eda67dcd
  { 1, 46, 48, 618, 622 }, // 203 tc_e172d86a
  { 1, 40, 42, 622, 626 }, // 204 tc_c4b515c5
  { 1, 38, 40, 626, 629 }, // 205 tc_e231aa4f
  { 1, 38, 40, 629, 633 }, // 206 tc_9311da3f
  { 1, 29, 31, 633, 636 }, // 207 tc_41f4b64e
  { 1, 29, 31, 636, 640 }, // 208 tc_c00bf9c9
  { 1, 29, 31, 640, 642 }, // 209 tc_d2cb81ea
  { 1, 48, 50, 642, 647 }, // 210 tc_5c120602
  { 1, 40, 42, 647, 649 }, // 211 tc_e6299d16
  { 1, 40, 42, 649, 652 }, // 212 tc_f3fc3f83
  { 1, 48, 50, 652, 656 }, // 213 tc_4e2a5159
  { 1, 38, 40, 656, 659 }, // 214 tc_69b6dd20
  { 1, 38, 40, 659, 663 }, // 215 tc_d725e5b0
  { 1, 46, 48, 663, 666 }, // 216 tc_7c3f55c4
  { 1, 46, 48, 666, 670 }, // 217 tc_d98f4d63
  { 1, 50, 53, 670, 673 }, // 218 tc_66bb62ea
  { 1, 50, 53, 673, 677 }, // 219 tc_63e3d94c
  { 1, 53, 56, 677, 680 }, // 220 tc_bfe309d5
  { 1, 53, 56, 680, 684 }, // 221 tc_98733e9d
  { 1, 56, 58, 0, 0 }, // 222 tc_e5053c8f
  { 1, 56, 58, 684, 685 }, // 223 tc_cedf314b
  { 1, 58, 60, 685, 688 }, // 224 tc_fa99dc24
  { 1, 48, 50, 688, 693 }, // 225 tc_cbf6d1dc
  { 1, 58, 60, 693, 697 }, // 226 tc_7474003e
  { 1, 60, 63, 697, 700 }, // 227 tc_a807365d
  { 1, 60, 63, 700, 704 }, // 228 tc_ee927c0e
  { 1, 46, 48, 704, 708 }, // 229 tc_7e9f581b
  { 1, 46, 48, 708, 713 }, // 230 tc_41f99e1c
  { 1, 40, 42, 713, 716 }, // 231 tc_bf142ae2
  { 1, 29, 31, 716, 719 }, // 232 tc_9b9642a1
  { 1, 9, 11, 719, 721 }, // 233 tc_644584f8
  { 1, 20, 23, 721, 725 }, // 234 tc_4f190ba3
  { 1, 20, 23, 725, 730 }, // 235 tc_df54ad52
  { 1, 63, 66, 730, 734 }, // 236 tc_ec58f88a
  { 1, 63, 66, 734, 739 }, // 237 tc_94f43c04
  { 1, 9, 11, 739, 743 }, // 238 tc_316c637c
  { 1, 48, 50, 743, 745 }, // 239 tc_d7bea0ec
  { 1, 48, 50, 745, 748 }, // 240 tc_72ad7b54
  { 1, 56, 58, 748, 749 }, // 241 tc_b77635b4
  { 1, 56, 58, 749, 751 }, // 242 tc_28978789
  { 1, 3, 4, 0, 0 }, // 243 tc_367f7f3d
  { 1, 35, 36, 0, 0 }, // 244 tc_4ca572d4
  { 1, 3, 4, 751, 752 }, // 245 tc_00e7c26e
  { 1, 3, 4, 752, 754 }, // 246 tc_4d9914c9
  { 1, 5, 6, 754, 755 }, // 247 tc_999d32db
  { 1, 5, 6, 0, 0 }, // 248 tc_b13761ae
  { 1, 3, 4, 755, 757 }, // 249 tc_daa058fa
  { 1, 35, 36, 757, 758 }, // 250 tc_c82dc1ff
  { 0, uint16_t(~0U), uint16_t(~0U), uint16_t(~0U), uint16_t(~0U) }// end marker
};

static const llvm::InstrItinerary HexagonItinerariesV4[] = {
  { 0, 0, 0, 0, 0 }, // 0 NoInstrModel
  { 1, 66, 67, 0, 0 }, // 1 tc_897d1a9d
  { 1, 67, 68, 0, 0 }, // 2 PSEUDO
  { 1, 67, 68, 0, 0 }, // 3 tc_68cb12ce
  { 1, 67, 68, 0, 0 }, // 4 tc_d6bf0472
  { 1, 67, 68, 0, 0 }, // 5 tc_2b2f4060
  { 1, 67, 68, 0, 0 }, // 6 tc_b9488031
  { 1, 67, 68, 0, 0 }, // 7 tc_5f6847a1
  { 1, 66, 67, 0, 0 }, // 8 tc_540fdfbc
  { 1, 66, 67, 0, 0 }, // 9 tc_1e856f58
  { 1, 67, 68, 0, 0 }, // 10 tc_6ebb4a12
  { 1, 66, 67, 0, 0 }, // 11 tc_53bc8a6a
  { 1, 68, 69, 0, 0 }, // 12 DUPLEX
  { 1, 69, 70, 0, 0 }, // 13 tc_ENDLOOP
  { 1, 67, 68, 0, 0 }, // 14 tc_52d7bbea
  { 1, 66, 67, 0, 0 }, // 15 tc_e9fae2d6
  { 1, 70, 71, 0, 0 }, // 16 tc_e0739b8c
  { 1, 70, 71, 0, 0 }, // 17 tc_59a01ead
  { 1, 71, 72, 0, 0 }, // 18 tc_ef52ed71
  { 1, 71, 72, 0, 0 }, // 19 tc_7f881c76
  { 1, 71, 72, 0, 0 }, // 20 tc_2fc0c436
  { 1, 68, 69, 0, 0 }, // 21 tc_44126683
  { 1, 68, 69, 0, 0 }, // 22 tc_513bef45
  { 1, 68, 69, 0, 0 }, // 23 tc_395dc00f
  { 1, 68, 69, 0, 0 }, // 24 tc_3bc2c5d3
  { 1, 68, 69, 0, 0 }, // 25 tc_e7624c08
  { 1, 71, 72, 0, 0 }, // 26 tc_d1090e34
  { 1, 68, 69, 0, 0 }, // 27 tc_3d04548d
  { 1, 71, 72, 0, 0 }, // 28 LD_tc_ld_SLOT01
  { 1, 66, 67, 0, 0 }, // 29 tc_1853ea6d
  { 1, 66, 67, 0, 0 }, // 30 tc_8fd5f294
  { 1, 66, 67, 0, 0 }, // 31 tc_e913dc32
  { 1, 71, 72, 0, 0 }, // 32 tc_4403ca65
  { 0, 0, 0, 0, 0 }, // 33 tc_bbaf280e
  { 1, 71, 72, 0, 0 }, // 34 tc_9fdb5406
  { 1, 71, 72, 0, 0 }, // 35 tc_f86c328a
  { 1, 70, 71, 0, 0 }, // 36 tc_9faf76ae
  { 0, 0, 0, 0, 0 }, // 37 tc_97c165b9
  { 0, 0, 0, 0, 0 }, // 38 tc_b712833a
  { 0, 0, 0, 0, 0 }, // 39 tc_35e92f8e
  { 1, 72, 74, 0, 0 }, // 40 PSEUDOM
  { 0, 0, 0, 0, 0 }, // 41 tc_b06ab583
  { 0, 0, 0, 0, 0 }, // 42 tc_e3748cdf
  { 0, 0, 0, 0, 0 }, // 43 tc_354299ad
  { 0, 0, 0, 0, 0 }, // 44 tc_2171ebae
  { 1, 66, 67, 0, 0 }, // 45 tc_2b6f77c6
  { 1, 71, 72, 0, 0 }, // 46 tc_8b15472a
  { 1, 68, 69, 0, 0 }, // 47 tc_594ab548
  { 1, 71, 72, 0, 0 }, // 48 tc_05b6c987
  { 1, 68, 69, 0, 0 }, // 49 tc_f7dd9c9f
  { 1, 66, 67, 0, 0 }, // 50 tc_87735c3b
  { 1, 68, 69, 0, 0 }, // 51 tc_e7d02c66
  { 1, 68, 69, 0, 0 }, // 52 tc_e216a5db
  { 1, 71, 72, 0, 0 }, // 53 ST_tc_st_SLOT01
  { 0, 0, 0, 0, 0 }, // 54 CVI_VA
  { 0, 0, 0, 0, 0 }, // 55 tc_71337255
  { 0, 0, 0, 0, 0 }, // 56 tc_7fa8b40f
  { 0, 0, 0, 0, 0 }, // 57 tc_8a6eb39a
  { 0, 0, 0, 0, 0 }, // 58 CVI_GATHER_PSEUDO
  { 1, 68, 69, 0, 0 }, // 59 tc_3da80ba5
  { 1, 66, 67, 0, 0 }, // 60 tc_c2f7d806
  { 1, 66, 67, 0, 0 }, // 61 tc_b44c6e2a
  { 1, 66, 67, 0, 0 }, // 62 tc_1b9c9ee5
  { 1, 67, 68, 0, 0 }, // 63 tc_5ba5997d
  { 1, 66, 67, 0, 0 }, // 64 tc_cde8b071
  { 1, 67, 68, 0, 0 }, // 65 tc_6efc556e
  { 1, 67, 68, 0, 0 }, // 66 tc_8fe6b782
  { 1, 74, 75, 0, 0 }, // 67 tc_29175780
  { 1, 74, 75, 0, 0 }, // 68 tc_a21dc435
  { 1, 66, 67, 0, 0 }, // 69 tc_dbdffe3d
  { 1, 66, 67, 0, 0 }, // 70 tc_523fcf30
  { 1, 66, 67, 0, 0 }, // 71 tc_7a830544
  { 1, 67, 68, 0, 0 }, // 72 tc_452f85af
  { 1, 66, 67, 0, 0 }, // 73 tc_04c9decc
  { 1, 66, 67, 0, 0 }, // 74 tc_c6ce9b3f
  { 1, 66, 67, 0, 0 }, // 75 tc_caaebcba
  { 1, 66, 67, 0, 0 }, // 76 tc_55050d58
  { 1, 66, 67, 0, 0 }, // 77 tc_ef84f62f
  { 1, 66, 67, 0, 0 }, // 78 tc_f2704b9a
  { 1, 67, 68, 0, 0 }, // 79 tc_c6aa82f7
  { 1, 66, 67, 0, 0 }, // 80 tc_351fed2d
  { 1, 66, 67, 0, 0 }, // 81 tc_f8eeed7a
  { 1, 74, 75, 0, 0 }, // 82 tc_b9c4623f
  { 1, 66, 67, 0, 0 }, // 83 tc_481e5e5c
  { 1, 66, 67, 0, 0 }, // 84 tc_a27582fa
  { 1, 66, 67, 0, 0 }, // 85 tc_f3eaa14b
  { 1, 66, 67, 0, 0 }, // 86 tc_234a11a5
  { 1, 66, 67, 0, 0 }, // 87 tc_6792d5ff
  { 1, 66, 67, 0, 0 }, // 88 tc_d580173f
  { 1, 66, 67, 0, 0 }, // 89 tc_038a1342
  { 1, 66, 67, 0, 0 }, // 90 tc_4d99bca9
  { 1, 66, 67, 0, 0 }, // 91 tc_976ddc4f
  { 1, 66, 67, 0, 0 }, // 92 tc_9c00ce8d
  { 1, 74, 75, 0, 0 }, // 93 tc_6fa4db47
  { 1, 74, 75, 0, 0 }, // 94 tc_994333cd
  { 1, 66, 67, 0, 0 }, // 95 tc_2f185f5c
  { 1, 70, 71, 0, 0 }, // 96 tc_15411484
  { 1, 70, 71, 0, 0 }, // 97 tc_10b97e27
  { 1, 66, 67, 0, 0 }, // 98 tc_3669266a
  { 1, 66, 67, 0, 0 }, // 99 tc_a46f0df5
  { 1, 66, 67, 0, 0 }, // 100 tc_e1e99bfa
  { 1, 70, 71, 0, 0 }, // 101 tc_181af5d0
  { 1, 70, 71, 0, 0 }, // 102 tc_97743097
  { 1, 74, 75, 0, 0 }, // 103 tc_73043bf4
  { 1, 74, 75, 0, 0 }, // 104 tc_cf59f215
  { 1, 74, 75, 0, 0 }, // 105 tc_7934b9df
  { 1, 70, 71, 0, 0 }, // 106 tc_681a2300
  { 1, 74, 75, 0, 0 }, // 107 tc_c5e2426d
  { 1, 74, 75, 0, 0 }, // 108 tc_4f7cd700
  { 1, 70, 71, 0, 0 }, // 109 tc_14cd4cfa
  { 1, 68, 69, 0, 0 }, // 110 tc_51b866be
  { 1, 66, 67, 0, 0 }, // 111 tc_855b0b61
  { 1, 68, 69, 0, 0 }, // 112 tc_bde7aaf4
  { 1, 66, 67, 0, 0 }, // 113 tc_99be14ca
  { 1, 68, 69, 0, 0 }, // 114 tc_5eb851fc
  { 1, 66, 67, 0, 0 }, // 115 tc_49eb22c8
  { 1, 68, 69, 0, 0 }, // 116 tc_746baa8e
  { 1, 66, 67, 0, 0 }, // 117 tc_3cb8ea06
  { 1, 71, 72, 0, 0 }, // 118 tc_bad2bcaf
  { 1, 71, 72, 0, 0 }, // 119 tc_03220ffa
  { 1, 71, 72, 0, 0 }, // 120 tc_9c98e8af
  { 1, 68, 69, 0, 0 }, // 121 tc_6aa5711a
  { 1, 71, 72, 0, 0 }, // 122 tc_63fe3df7
  { 1, 71, 72, 0, 0 }, // 123 tc_5acef64a
  { 1, 71, 72, 0, 0 }, // 124 tc_0cd51c76
  { 1, 71, 72, 0, 0 }, // 125 tc_b77c481f
  { 1, 71, 72, 0, 0 }, // 126 tc_cf47a43f
  { 1, 71, 72, 0, 0 }, // 127 tc_f47d212f
  { 1, 71, 72, 0, 0 }, // 128 tc_1d5a38a8
  { 1, 71, 72, 0, 0 }, // 129 tc_9ef61e5c
  { 1, 71, 72, 0, 0 }, // 130 tc_b7dd427e
  { 1, 66, 67, 0, 0 }, // 131 tc_c74f796f
  { 1, 66, 67, 0, 0 }, // 132 tc_16d0d8d5
  { 1, 66, 67, 0, 0 }, // 133 tc_84df2cd3
  { 1, 66, 67, 0, 0 }, // 134 tc_bcc96cee
  { 1, 66, 67, 0, 0 }, // 135 tc_f49e76f4
  { 1, 71, 72, 0, 0 }, // 136 tc_a788683e
  { 1, 68, 69, 0, 0 }, // 137 tc_ff9ee76e
  { 1, 66, 67, 0, 0 }, // 138 tc_d088982c
  { 1, 66, 67, 0, 0 }, // 139 tc_c6ebf8dd
  { 1, 71, 72, 0, 0 }, // 140 tc_cd7374a0
  { 1, 71, 72, 0, 0 }, // 141 tc_74e47fd9
  { 1, 68, 69, 0, 0 }, // 142 tc_d9f95eef
  { 1, 68, 69, 0, 0 }, // 143 tc_d24b2d85
  { 1, 68, 69, 0, 0 }, // 144 tc_9d5941c7
  { 1, 68, 69, 0, 0 }, // 145 tc_1372bca1
  { 1, 71, 72, 0, 0 }, // 146 tc_238d91d2
  { 1, 71, 72, 0, 0 }, // 147 tc_5274e61a
  { 1, 71, 72, 0, 0 }, // 148 tc_66888ded
  { 1, 71, 72, 0, 0 }, // 149 tc_3e07fb90
  { 1, 68, 69, 0, 0 }, // 150 tc_6ac37025
  { 1, 68, 69, 0, 0 }, // 151 tc_adb14c66
  { 1, 68, 69, 0, 0 }, // 152 tc_53bdb2f6
  { 1, 68, 69, 0, 0 }, // 153 tc_e421e012
  { 1, 71, 72, 0, 0 }, // 154 tc_d9709180
  { 1, 71, 72, 0, 0 }, // 155 tc_0dc560de
  { 1, 68, 69, 0, 0 }, // 156 tc_b166348b
  { 1, 68, 69, 0, 0 }, // 157 tc_a8acdac0
  { 1, 66, 67, 0, 0 }, // 158 tc_b9c0b731
  { 1, 66, 67, 0, 0 }, // 159 tc_60571023
  { 1, 66, 67, 0, 0 }, // 160 tc_00afc57e
  { 1, 66, 67, 0, 0 }, // 161 tc_41d5298e
  { 1, 66, 67, 0, 0 }, // 162 tc_be706f30
  { 1, 71, 72, 0, 0 }, // 163 tc_609d2efe
  { 1, 71, 72, 0, 0 }, // 164 tc_a904d137
  { 1, 71, 72, 0, 0 }, // 165 tc_1b82a277
  { 1, 71, 72, 0, 0 }, // 166 tc_e9c822f7
  { 1, 71, 72, 0, 0 }, // 167 tc_90f3e30c
  { 1, 71, 72, 0, 0 }, // 168 tc_36c68ad1
  { 1, 68, 69, 0, 0 }, // 169 tc_2a160009
  { 1, 68, 69, 0, 0 }, // 170 tc_fcab4871
  { 1, 68, 69, 0, 0 }, // 171 tc_0fc1ae07
  { 1, 71, 72, 0, 0 }, // 172 tc_57288781
  { 0, 0, 0, 0, 0 }, // 173 tc_9777e6bf
  { 0, 0, 0, 0, 0 }, // 174 tc_6b78cf13
  { 0, 0, 0, 0, 0 }, // 175 tc_4105d6b5
  { 0, 0, 0, 0, 0 }, // 176 tc_4fd8566e
  { 0, 0, 0, 0, 0 }, // 177 tc_5cbf490b
  { 0, 0, 0, 0, 0 }, // 178 tc_da979fb3
  { 0, 0, 0, 0, 0 }, // 179 tc_eb669007
  { 0, 0, 0, 0, 0 }, // 180 tc_77a4c701
  { 0, 0, 0, 0, 0 }, // 181 tc_51cd3aab
  { 0, 0, 0, 0, 0 }, // 182 tc_38208312
  { 0, 0, 0, 0, 0 }, // 183 tc_9c267309
  { 0, 0, 0, 0, 0 }, // 184 tc_d642eff3
  { 0, 0, 0, 0, 0 }, // 185 tc_6fd9ad30
  { 0, 0, 0, 0, 0 }, // 186 tc_7fa82b08
  { 0, 0, 0, 0, 0 }, // 187 tc_1b93bdc6
  { 0, 0, 0, 0, 0 }, // 188 tc_d5090f3e
  { 0, 0, 0, 0, 0 }, // 189 tc_8b6a873f
  { 0, 0, 0, 0, 0 }, // 190 tc_db5b9e2f
  { 0, 0, 0, 0, 0 }, // 191 tc_85d237e3
  { 0, 0, 0, 0, 0 }, // 192 tc_0317c6ca
  { 0, 0, 0, 0, 0 }, // 193 tc_aedb9f9e
  { 0, 0, 0, 0, 0 }, // 194 tc_99093773
  { 0, 0, 0, 0, 0 }, // 195 tc_a4c9df3b
  { 0, 0, 0, 0, 0 }, // 196 tc_29841470
  { 0, 0, 0, 0, 0 }, // 197 tc_5c03dc63
  { 0, 0, 0, 0, 0 }, // 198 tc_908a4c8c
  { 0, 0, 0, 0, 0 }, // 199 tc_a3127e12
  { 0, 0, 0, 0, 0 }, // 200 tc_5a9fc4ec
  { 0, 0, 0, 0, 0 }, // 201 tc_45453b98
  { 0, 0, 0, 0, 0 }, // 202 tc_eda67dcd
  { 0, 0, 0, 0, 0 }, // 203 tc_e172d86a
  { 0, 0, 0, 0, 0 }, // 204 tc_c4b515c5
  { 0, 0, 0, 0, 0 }, // 205 tc_e231aa4f
  { 0, 0, 0, 0, 0 }, // 206 tc_9311da3f
  { 0, 0, 0, 0, 0 }, // 207 tc_41f4b64e
  { 0, 0, 0, 0, 0 }, // 208 tc_c00bf9c9
  { 0, 0, 0, 0, 0 }, // 209 tc_d2cb81ea
  { 0, 0, 0, 0, 0 }, // 210 tc_5c120602
  { 0, 0, 0, 0, 0 }, // 211 tc_e6299d16
  { 0, 0, 0, 0, 0 }, // 212 tc_f3fc3f83
  { 0, 0, 0, 0, 0 }, // 213 tc_4e2a5159
  { 0, 0, 0, 0, 0 }, // 214 tc_69b6dd20
  { 0, 0, 0, 0, 0 }, // 215 tc_d725e5b0
  { 0, 0, 0, 0, 0 }, // 216 tc_7c3f55c4
  { 0, 0, 0, 0, 0 }, // 217 tc_d98f4d63
  { 0, 0, 0, 0, 0 }, // 218 tc_66bb62ea
  { 0, 0, 0, 0, 0 }, // 219 tc_63e3d94c
  { 0, 0, 0, 0, 0 }, // 220 tc_bfe309d5
  { 0, 0, 0, 0, 0 }, // 221 tc_98733e9d
  { 0, 0, 0, 0, 0 }, // 222 tc_e5053c8f
  { 0, 0, 0, 0, 0 }, // 223 tc_cedf314b
  { 0, 0, 0, 0, 0 }, // 224 tc_fa99dc24
  { 0, 0, 0, 0, 0 }, // 225 tc_cbf6d1dc
  { 0, 0, 0, 0, 0 }, // 226 tc_7474003e
  { 0, 0, 0, 0, 0 }, // 227 tc_a807365d
  { 0, 0, 0, 0, 0 }, // 228 tc_ee927c0e
  { 0, 0, 0, 0, 0 }, // 229 tc_7e9f581b
  { 0, 0, 0, 0, 0 }, // 230 tc_41f99e1c
  { 0, 0, 0, 0, 0 }, // 231 tc_bf142ae2
  { 0, 0, 0, 0, 0 }, // 232 tc_9b9642a1
  { 0, 0, 0, 0, 0 }, // 233 tc_644584f8
  { 0, 0, 0, 0, 0 }, // 234 tc_4f190ba3
  { 0, 0, 0, 0, 0 }, // 235 tc_df54ad52
  { 0, 0, 0, 0, 0 }, // 236 tc_ec58f88a
  { 0, 0, 0, 0, 0 }, // 237 tc_94f43c04
  { 0, 0, 0, 0, 0 }, // 238 tc_316c637c
  { 0, 0, 0, 0, 0 }, // 239 tc_d7bea0ec
  { 0, 0, 0, 0, 0 }, // 240 tc_72ad7b54
  { 0, 0, 0, 0, 0 }, // 241 tc_b77635b4
  { 0, 0, 0, 0, 0 }, // 242 tc_28978789
  { 1, 68, 69, 0, 0 }, // 243 tc_367f7f3d
  { 1, 74, 75, 0, 0 }, // 244 tc_4ca572d4
  { 1, 68, 69, 0, 0 }, // 245 tc_00e7c26e
  { 1, 68, 69, 0, 0 }, // 246 tc_4d9914c9
  { 1, 70, 71, 0, 0 }, // 247 tc_999d32db
  { 1, 70, 71, 0, 0 }, // 248 tc_b13761ae
  { 1, 68, 69, 0, 0 }, // 249 tc_daa058fa
  { 1, 74, 75, 0, 0 }, // 250 tc_c82dc1ff
  { 0, uint16_t(~0U), uint16_t(~0U), uint16_t(~0U), uint16_t(~0U) }// end marker
};

static const llvm::InstrItinerary HexagonItinerariesV55[] = {
  { 0, 0, 0, 0, 0 }, // 0 NoInstrModel
  { 1, 75, 76, 758, 761 }, // 1 tc_897d1a9d
  { 1, 76, 77, 761, 764 }, // 2 PSEUDO
  { 1, 76, 77, 764, 766 }, // 3 tc_68cb12ce
  { 1, 76, 77, 766, 770 }, // 4 tc_d6bf0472
  { 1, 76, 77, 770, 774 }, // 5 tc_2b2f4060
  { 1, 76, 77, 774, 777 }, // 6 tc_b9488031
  { 1, 76, 77, 777, 780 }, // 7 tc_5f6847a1
  { 1, 75, 76, 780, 783 }, // 8 tc_540fdfbc
  { 1, 75, 76, 783, 786 }, // 9 tc_1e856f58
  { 1, 76, 77, 786, 789 }, // 10 tc_6ebb4a12
  { 1, 75, 76, 789, 792 }, // 11 tc_53bc8a6a
  { 1, 77, 78, 792, 795 }, // 12 DUPLEX
  { 1, 78, 79, 795, 796 }, // 13 tc_ENDLOOP
  { 1, 76, 77, 0, 0 }, // 14 tc_52d7bbea
  { 1, 75, 76, 796, 798 }, // 15 tc_e9fae2d6
  { 1, 79, 80, 798, 800 }, // 16 tc_e0739b8c
  { 1, 79, 80, 800, 803 }, // 17 tc_59a01ead
  { 1, 80, 81, 803, 807 }, // 18 tc_ef52ed71
  { 1, 80, 81, 807, 810 }, // 19 tc_7f881c76
  { 1, 80, 81, 810, 814 }, // 20 tc_2fc0c436
  { 1, 77, 78, 814, 817 }, // 21 tc_44126683
  { 1, 77, 78, 817, 820 }, // 22 tc_513bef45
  { 1, 77, 78, 820, 823 }, // 23 tc_395dc00f
  { 1, 77, 78, 823, 824 }, // 24 tc_3bc2c5d3
  { 1, 77, 78, 824, 825 }, // 25 tc_e7624c08
  { 1, 80, 81, 825, 827 }, // 26 tc_d1090e34
  { 1, 77, 78, 827, 829 }, // 27 tc_3d04548d
  { 1, 80, 81, 829, 831 }, // 28 LD_tc_ld_SLOT01
  { 1, 75, 76, 831, 834 }, // 29 tc_1853ea6d
  { 1, 75, 76, 834, 837 }, // 30 tc_8fd5f294
  { 1, 75, 76, 837, 841 }, // 31 tc_e913dc32
  { 1, 80, 81, 841, 846 }, // 32 tc_4403ca65
  { 0, 0, 0, 0, 0 }, // 33 tc_bbaf280e
  { 1, 80, 81, 846, 851 }, // 34 tc_9fdb5406
  { 1, 80, 81, 851, 855 }, // 35 tc_f86c328a
  { 1, 79, 80, 855, 856 }, // 36 tc_9faf76ae
  { 0, 0, 0, 0, 0 }, // 37 tc_97c165b9
  { 0, 0, 0, 0, 0 }, // 38 tc_b712833a
  { 0, 0, 0, 0, 0 }, // 39 tc_35e92f8e
  { 1, 81, 83, 856, 859 }, // 40 PSEUDOM
  { 0, 0, 0, 0, 0 }, // 41 tc_b06ab583
  { 0, 0, 0, 0, 0 }, // 42 tc_e3748cdf
  { 0, 0, 0, 0, 0 }, // 43 tc_354299ad
  { 0, 0, 0, 0, 0 }, // 44 tc_2171ebae
  { 1, 75, 76, 859, 862 }, // 45 tc_2b6f77c6
  { 1, 80, 81, 862, 866 }, // 46 tc_8b15472a
  { 1, 77, 78, 866, 870 }, // 47 tc_594ab548
  { 1, 80, 81, 870, 873 }, // 48 tc_05b6c987
  { 1, 77, 78, 873, 876 }, // 49 tc_f7dd9c9f
  { 1, 75, 76, 876, 881 }, // 50 tc_87735c3b
  { 1, 77, 78, 881, 885 }, // 51 tc_e7d02c66
  { 1, 77, 78, 885, 888 }, // 52 tc_e216a5db
  { 1, 80, 81, 888, 891 }, // 53 ST_tc_st_SLOT01
  { 0, 0, 0, 0, 0 }, // 54 CVI_VA
  { 0, 0, 0, 0, 0 }, // 55 tc_71337255
  { 0, 0, 0, 0, 0 }, // 56 tc_7fa8b40f
  { 0, 0, 0, 0, 0 }, // 57 tc_8a6eb39a
  { 0, 0, 0, 0, 0 }, // 58 CVI_GATHER_PSEUDO
  { 1, 77, 78, 891, 892 }, // 59 tc_3da80ba5
  { 1, 75, 76, 892, 894 }, // 60 tc_c2f7d806
  { 1, 75, 76, 894, 897 }, // 61 tc_b44c6e2a
  { 1, 75, 76, 897, 900 }, // 62 tc_1b9c9ee5
  { 1, 76, 77, 900, 903 }, // 63 tc_5ba5997d
  { 1, 75, 76, 903, 905 }, // 64 tc_cde8b071
  { 1, 76, 77, 0, 0 }, // 65 tc_6efc556e
  { 1, 76, 77, 905, 908 }, // 66 tc_8fe6b782
  { 1, 83, 84, 908, 910 }, // 67 tc_29175780
  { 1, 83, 84, 910, 912 }, // 68 tc_a21dc435
  { 1, 75, 76, 912, 915 }, // 69 tc_dbdffe3d
  { 1, 75, 76, 915, 920 }, // 70 tc_523fcf30
  { 1, 75, 76, 920, 923 }, // 71 tc_7a830544
  { 1, 76, 77, 923, 924 }, // 72 tc_452f85af
  { 1, 75, 76, 924, 927 }, // 73 tc_04c9decc
  { 1, 75, 76, 927, 931 }, // 74 tc_c6ce9b3f
  { 1, 75, 76, 931, 936 }, // 75 tc_caaebcba
  { 1, 75, 76, 936, 939 }, // 76 tc_55050d58
  { 1, 75, 76, 939, 943 }, // 77 tc_ef84f62f
  { 1, 75, 76, 943, 945 }, // 78 tc_f2704b9a
  { 1, 76, 77, 945, 948 }, // 79 tc_c6aa82f7
  { 1, 75, 76, 948, 950 }, // 80 tc_351fed2d
  { 1, 75, 76, 950, 954 }, // 81 tc_f8eeed7a
  { 1, 83, 84, 954, 956 }, // 82 tc_b9c4623f
  { 1, 75, 76, 956, 960 }, // 83 tc_481e5e5c
  { 1, 75, 76, 960, 961 }, // 84 tc_a27582fa
  { 1, 75, 76, 961, 963 }, // 85 tc_f3eaa14b
  { 1, 75, 76, 963, 965 }, // 86 tc_234a11a5
  { 1, 75, 76, 965, 968 }, // 87 tc_6792d5ff
  { 1, 75, 76, 968, 972 }, // 88 tc_d580173f
  { 1, 75, 76, 972, 977 }, // 89 tc_038a1342
  { 1, 75, 76, 977, 980 }, // 90 tc_4d99bca9
  { 1, 75, 76, 980, 983 }, // 91 tc_976ddc4f
  { 1, 75, 76, 983, 987 }, // 92 tc_9c00ce8d
  { 1, 83, 84, 987, 989 }, // 93 tc_6fa4db47
  { 1, 83, 84, 989, 991 }, // 94 tc_994333cd
  { 1, 75, 76, 991, 993 }, // 95 tc_2f185f5c
  { 1, 79, 80, 993, 994 }, // 96 tc_15411484
  { 1, 79, 80, 994, 996 }, // 97 tc_10b97e27
  { 1, 75, 76, 996, 997 }, // 98 tc_3669266a
  { 1, 75, 76, 997, 999 }, // 99 tc_a46f0df5
  { 1, 75, 76, 999, 1001 }, // 100 tc_e1e99bfa
  { 1, 79, 80, 1001, 1003 }, // 101 tc_181af5d0
  { 1, 79, 80, 1003, 1005 }, // 102 tc_97743097
  { 1, 83, 84, 1005, 1007 }, // 103 tc_73043bf4
  { 1, 83, 84, 1007, 1009 }, // 104 tc_cf59f215
  { 1, 83, 84, 1009, 1011 }, // 105 tc_7934b9df
  { 1, 79, 80, 1011, 1012 }, // 106 tc_681a2300
  { 1, 83, 84, 1012, 1014 }, // 107 tc_c5e2426d
  { 1, 83, 84, 1014, 1016 }, // 108 tc_4f7cd700
  { 1, 79, 80, 1016, 1017 }, // 109 tc_14cd4cfa
  { 1, 77, 78, 1017, 1020 }, // 110 tc_51b866be
  { 1, 75, 76, 1020, 1023 }, // 111 tc_855b0b61
  { 1, 77, 78, 1023, 1026 }, // 112 tc_bde7aaf4
  { 1, 75, 76, 1026, 1029 }, // 113 tc_99be14ca
  { 1, 77, 78, 1029, 1032 }, // 114 tc_5eb851fc
  { 1, 75, 76, 1032, 1035 }, // 115 tc_49eb22c8
  { 1, 77, 78, 1035, 1037 }, // 116 tc_746baa8e
  { 1, 75, 76, 1037, 1039 }, // 117 tc_3cb8ea06
  { 1, 80, 81, 1039, 1044 }, // 118 tc_bad2bcaf
  { 1, 80, 81, 1044, 1050 }, // 119 tc_03220ffa
  { 1, 80, 81, 1050, 1052 }, // 120 tc_9c98e8af
  { 1, 77, 78, 1052, 1054 }, // 121 tc_6aa5711a
  { 1, 80, 81, 1054, 1059 }, // 122 tc_63fe3df7
  { 1, 80, 81, 1059, 1063 }, // 123 tc_5acef64a
  { 1, 80, 81, 1063, 1068 }, // 124 tc_0cd51c76
  { 1, 80, 81, 1068, 1071 }, // 125 tc_b77c481f
  { 1, 80, 81, 1071, 1075 }, // 126 tc_cf47a43f
  { 1, 80, 81, 1075, 1079 }, // 127 tc_f47d212f
  { 1, 80, 81, 1079, 1082 }, // 128 tc_1d5a38a8
  { 1, 80, 81, 1082, 1087 }, // 129 tc_9ef61e5c
  { 1, 80, 81, 1087, 1092 }, // 130 tc_b7dd427e
  { 1, 75, 76, 1092, 1096 }, // 131 tc_c74f796f
  { 1, 75, 76, 1096, 1100 }, // 132 tc_16d0d8d5
  { 1, 75, 76, 1100, 1104 }, // 133 tc_84df2cd3
  { 1, 75, 76, 1104, 1108 }, // 134 tc_bcc96cee
  { 1, 75, 76, 1108, 1111 }, // 135 tc_f49e76f4
  { 1, 80, 81, 1111, 1113 }, // 136 tc_a788683e
  { 1, 77, 78, 1113, 1115 }, // 137 tc_ff9ee76e
  { 1, 75, 76, 1115, 1117 }, // 138 tc_d088982c
  { 1, 75, 76, 1117, 1120 }, // 139 tc_c6ebf8dd
  { 1, 80, 81, 1120, 1125 }, // 140 tc_cd7374a0
  { 1, 80, 81, 1125, 1130 }, // 141 tc_74e47fd9
  { 1, 77, 78, 1130, 1135 }, // 142 tc_d9f95eef
  { 1, 77, 78, 1135, 1140 }, // 143 tc_d24b2d85
  { 1, 77, 78, 1140, 1145 }, // 144 tc_9d5941c7
  { 1, 77, 78, 1145, 1148 }, // 145 tc_1372bca1
  { 1, 80, 81, 1148, 1151 }, // 146 tc_238d91d2
  { 1, 80, 81, 1151, 1156 }, // 147 tc_5274e61a
  { 1, 80, 81, 1156, 1159 }, // 148 tc_66888ded
  { 1, 80, 81, 1159, 1164 }, // 149 tc_3e07fb90
  { 1, 77, 78, 1164, 1167 }, // 150 tc_6ac37025
  { 1, 77, 78, 1167, 1172 }, // 151 tc_adb14c66
  { 1, 77, 78, 1172, 1175 }, // 152 tc_53bdb2f6
  { 1, 77, 78, 1175, 1180 }, // 153 tc_e421e012
  { 1, 80, 81, 1180, 1184 }, // 154 tc_d9709180
  { 1, 80, 81, 1184, 1188 }, // 155 tc_0dc560de
  { 1, 77, 78, 1188, 1192 }, // 156 tc_b166348b
  { 1, 77, 78, 1192, 1196 }, // 157 tc_a8acdac0
  { 1, 75, 76, 1196, 1200 }, // 158 tc_b9c0b731
  { 1, 75, 76, 1200, 1205 }, // 159 tc_60571023
  { 1, 75, 76, 1205, 1207 }, // 160 tc_00afc57e
  { 1, 75, 76, 1207, 1211 }, // 161 tc_41d5298e
  { 1, 75, 76, 1211, 1213 }, // 162 tc_be706f30
  { 1, 80, 81, 1213, 1216 }, // 163 tc_609d2efe
  { 1, 80, 81, 1216, 1218 }, // 164 tc_a904d137
  { 1, 80, 81, 1218, 1219 }, // 165 tc_1b82a277
  { 1, 80, 81, 1219, 1220 }, // 166 tc_e9c822f7
  { 1, 80, 81, 1220, 1222 }, // 167 tc_90f3e30c
  { 1, 80, 81, 0, 0 }, // 168 tc_36c68ad1
  { 1, 77, 78, 0, 0 }, // 169 tc_2a160009
  { 1, 77, 78, 0, 0 }, // 170 tc_fcab4871
  { 1, 77, 78, 1222, 1223 }, // 171 tc_0fc1ae07
  { 1, 80, 81, 1223, 1225 }, // 172 tc_57288781
  { 0, 0, 0, 0, 0 }, // 173 tc_9777e6bf
  { 0, 0, 0, 0, 0 }, // 174 tc_6b78cf13
  { 0, 0, 0, 0, 0 }, // 175 tc_4105d6b5
  { 0, 0, 0, 0, 0 }, // 176 tc_4fd8566e
  { 0, 0, 0, 0, 0 }, // 177 tc_5cbf490b
  { 0, 0, 0, 0, 0 }, // 178 tc_da979fb3
  { 0, 0, 0, 0, 0 }, // 179 tc_eb669007
  { 0, 0, 0, 0, 0 }, // 180 tc_77a4c701
  { 0, 0, 0, 0, 0 }, // 181 tc_51cd3aab
  { 0, 0, 0, 0, 0 }, // 182 tc_38208312
  { 0, 0, 0, 0, 0 }, // 183 tc_9c267309
  { 0, 0, 0, 0, 0 }, // 184 tc_d642eff3
  { 0, 0, 0, 0, 0 }, // 185 tc_6fd9ad30
  { 0, 0, 0, 0, 0 }, // 186 tc_7fa82b08
  { 0, 0, 0, 0, 0 }, // 187 tc_1b93bdc6
  { 0, 0, 0, 0, 0 }, // 188 tc_d5090f3e
  { 0, 0, 0, 0, 0 }, // 189 tc_8b6a873f
  { 0, 0, 0, 0, 0 }, // 190 tc_db5b9e2f
  { 0, 0, 0, 0, 0 }, // 191 tc_85d237e3
  { 0, 0, 0, 0, 0 }, // 192 tc_0317c6ca
  { 0, 0, 0, 0, 0 }, // 193 tc_aedb9f9e
  { 0, 0, 0, 0, 0 }, // 194 tc_99093773
  { 0, 0, 0, 0, 0 }, // 195 tc_a4c9df3b
  { 0, 0, 0, 0, 0 }, // 196 tc_29841470
  { 0, 0, 0, 0, 0 }, // 197 tc_5c03dc63
  { 0, 0, 0, 0, 0 }, // 198 tc_908a4c8c
  { 0, 0, 0, 0, 0 }, // 199 tc_a3127e12
  { 0, 0, 0, 0, 0 }, // 200 tc_5a9fc4ec
  { 0, 0, 0, 0, 0 }, // 201 tc_45453b98
  { 0, 0, 0, 0, 0 }, // 202 tc_eda67dcd
  { 0, 0, 0, 0, 0 }, // 203 tc_e172d86a
  { 0, 0, 0, 0, 0 }, // 204 tc_c4b515c5
  { 0, 0, 0, 0, 0 }, // 205 tc_e231aa4f
  { 0, 0, 0, 0, 0 }, // 206 tc_9311da3f
  { 0, 0, 0, 0, 0 }, // 207 tc_41f4b64e
  { 0, 0, 0, 0, 0 }, // 208 tc_c00bf9c9
  { 0, 0, 0, 0, 0 }, // 209 tc_d2cb81ea
  { 0, 0, 0, 0, 0 }, // 210 tc_5c120602
  { 0, 0, 0, 0, 0 }, // 211 tc_e6299d16
  { 0, 0, 0, 0, 0 }, // 212 tc_f3fc3f83
  { 0, 0, 0, 0, 0 }, // 213 tc_4e2a5159
  { 0, 0, 0, 0, 0 }, // 214 tc_69b6dd20
  { 0, 0, 0, 0, 0 }, // 215 tc_d725e5b0
  { 0, 0, 0, 0, 0 }, // 216 tc_7c3f55c4
  { 0, 0, 0, 0, 0 }, // 217 tc_d98f4d63
  { 0, 0, 0, 0, 0 }, // 218 tc_66bb62ea
  { 0, 0, 0, 0, 0 }, // 219 tc_63e3d94c
  { 0, 0, 0, 0, 0 }, // 220 tc_bfe309d5
  { 0, 0, 0, 0, 0 }, // 221 tc_98733e9d
  { 0, 0, 0, 0, 0 }, // 222 tc_e5053c8f
  { 0, 0, 0, 0, 0 }, // 223 tc_cedf314b
  { 0, 0, 0, 0, 0 }, // 224 tc_fa99dc24
  { 0, 0, 0, 0, 0 }, // 225 tc_cbf6d1dc
  { 0, 0, 0, 0, 0 }, // 226 tc_7474003e
  { 0, 0, 0, 0, 0 }, // 227 tc_a807365d
  { 0, 0, 0, 0, 0 }, // 228 tc_ee927c0e
  { 0, 0, 0, 0, 0 }, // 229 tc_7e9f581b
  { 0, 0, 0, 0, 0 }, // 230 tc_41f99e1c
  { 0, 0, 0, 0, 0 }, // 231 tc_bf142ae2
  { 0, 0, 0, 0, 0 }, // 232 tc_9b9642a1
  { 0, 0, 0, 0, 0 }, // 233 tc_644584f8
  { 0, 0, 0, 0, 0 }, // 234 tc_4f190ba3
  { 0, 0, 0, 0, 0 }, // 235 tc_df54ad52
  { 0, 0, 0, 0, 0 }, // 236 tc_ec58f88a
  { 0, 0, 0, 0, 0 }, // 237 tc_94f43c04
  { 0, 0, 0, 0, 0 }, // 238 tc_316c637c
  { 0, 0, 0, 0, 0 }, // 239 tc_d7bea0ec
  { 0, 0, 0, 0, 0 }, // 240 tc_72ad7b54
  { 0, 0, 0, 0, 0 }, // 241 tc_b77635b4
  { 0, 0, 0, 0, 0 }, // 242 tc_28978789
  { 1, 77, 78, 0, 0 }, // 243 tc_367f7f3d
  { 1, 83, 84, 0, 0 }, // 244 tc_4ca572d4
  { 1, 77, 78, 1225, 1226 }, // 245 tc_00e7c26e
  { 1, 77, 78, 1226, 1228 }, // 246 tc_4d9914c9
  { 1, 79, 80, 1228, 1229 }, // 247 tc_999d32db
  { 1, 79, 80, 0, 0 }, // 248 tc_b13761ae
  { 1, 77, 78, 1229, 1231 }, // 249 tc_daa058fa
  { 1, 83, 84, 1231, 1232 }, // 250 tc_c82dc1ff
  { 0, uint16_t(~0U), uint16_t(~0U), uint16_t(~0U), uint16_t(~0U) }// end marker
};

static const llvm::InstrItinerary HexagonItinerariesV62[] = {
  { 0, 0, 0, 0, 0 }, // 0 NoInstrModel
  { 1, 84, 85, 1232, 1235 }, // 1 tc_897d1a9d
  { 1, 85, 86, 1235, 1238 }, // 2 PSEUDO
  { 1, 85, 86, 1238, 1240 }, // 3 tc_68cb12ce
  { 1, 85, 86, 1240, 1244 }, // 4 tc_d6bf0472
  { 1, 85, 86, 1244, 1248 }, // 5 tc_2b2f4060
  { 1, 85, 86, 1248, 1251 }, // 6 tc_b9488031
  { 1, 85, 86, 1251, 1254 }, // 7 tc_5f6847a1
  { 1, 84, 85, 1254, 1257 }, // 8 tc_540fdfbc
  { 1, 84, 85, 1257, 1260 }, // 9 tc_1e856f58
  { 1, 85, 86, 1260, 1263 }, // 10 tc_6ebb4a12
  { 1, 84, 85, 1263, 1266 }, // 11 tc_53bc8a6a
  { 1, 86, 87, 1266, 1269 }, // 12 DUPLEX
  { 1, 87, 88, 1269, 1270 }, // 13 tc_ENDLOOP
  { 1, 85, 86, 0, 0 }, // 14 tc_52d7bbea
  { 1, 85, 86, 1270, 1272 }, // 15 tc_e9fae2d6
  { 1, 88, 89, 1272, 1274 }, // 16 tc_e0739b8c
  { 1, 88, 89, 1274, 1277 }, // 17 tc_59a01ead
  { 1, 89, 90, 1277, 1281 }, // 18 tc_ef52ed71
  { 1, 89, 90, 1281, 1284 }, // 19 tc_7f881c76
  { 1, 89, 90, 1284, 1288 }, // 20 tc_2fc0c436
  { 1, 86, 87, 1288, 1291 }, // 21 tc_44126683
  { 1, 86, 87, 1291, 1294 }, // 22 tc_513bef45
  { 1, 86, 87, 1294, 1297 }, // 23 tc_395dc00f
  { 1, 86, 87, 1297, 1298 }, // 24 tc_3bc2c5d3
  { 1, 86, 87, 1298, 1299 }, // 25 tc_e7624c08
  { 1, 89, 90, 1299, 1301 }, // 26 tc_d1090e34
  { 1, 86, 87, 1301, 1303 }, // 27 tc_3d04548d
  { 1, 89, 90, 1303, 1305 }, // 28 LD_tc_ld_SLOT01
  { 1, 84, 85, 1305, 1308 }, // 29 tc_1853ea6d
  { 1, 84, 85, 1308, 1311 }, // 30 tc_8fd5f294
  { 1, 84, 85, 1311, 1315 }, // 31 tc_e913dc32
  { 1, 89, 90, 1315, 1320 }, // 32 tc_4403ca65
  { 1, 90, 92, 1320, 1323 }, // 33 tc_bbaf280e
  { 1, 89, 90, 1323, 1328 }, // 34 tc_9fdb5406
  { 1, 89, 90, 1328, 1332 }, // 35 tc_f86c328a
  { 1, 88, 89, 1332, 1333 }, // 36 tc_9faf76ae
  { 1, 92, 94, 1333, 1336 }, // 37 tc_97c165b9
  { 1, 94, 97, 1336, 1339 }, // 38 tc_b712833a
  { 1, 97, 101, 1339, 1342 }, // 39 tc_35e92f8e
  { 1, 101, 103, 1342, 1345 }, // 40 PSEUDOM
  { 1, 90, 92, 1345, 1348 }, // 41 tc_b06ab583
  { 1, 103, 106, 1348, 1351 }, // 42 tc_e3748cdf
  { 1, 106, 110, 1351, 1354 }, // 43 tc_354299ad
  { 1, 92, 94, 1354, 1358 }, // 44 tc_2171ebae
  { 1, 84, 85, 1358, 1361 }, // 45 tc_2b6f77c6
  { 1, 89, 90, 1361, 1365 }, // 46 tc_8b15472a
  { 1, 86, 87, 1365, 1369 }, // 47 tc_594ab548
  { 1, 89, 90, 1369, 1372 }, // 48 tc_05b6c987
  { 1, 86, 87, 1372, 1375 }, // 49 tc_f7dd9c9f
  { 1, 84, 85, 1375, 1380 }, // 50 tc_87735c3b
  { 1, 86, 87, 1380, 1384 }, // 51 tc_e7d02c66
  { 1, 86, 87, 1384, 1387 }, // 52 tc_e216a5db
  { 1, 89, 90, 1387, 1390 }, // 53 ST_tc_st_SLOT01
  { 1, 110, 112, 1390, 1394 }, // 54 CVI_VA
  { 1, 90, 92, 1394, 1396 }, // 55 tc_71337255
  { 1, 112, 114, 1396, 1400 }, // 56 tc_7fa8b40f
  { 1, 92, 94, 1400, 1401 }, // 57 tc_8a6eb39a
  { 1, 114, 118, 0, 0 }, // 58 CVI_GATHER_PSEUDO
  { 1, 86, 87, 1401, 1402 }, // 59 tc_3da80ba5
  { 1, 84, 85, 1402, 1404 }, // 60 tc_c2f7d806
  { 1, 84, 85, 1404, 1407 }, // 61 tc_b44c6e2a
  { 1, 84, 85, 1407, 1410 }, // 62 tc_1b9c9ee5
  { 1, 85, 86, 1410, 1413 }, // 63 tc_5ba5997d
  { 1, 84, 85, 1413, 1415 }, // 64 tc_cde8b071
  { 1, 85, 86, 0, 0 }, // 65 tc_6efc556e
  { 1, 85, 86, 1415, 1418 }, // 66 tc_8fe6b782
  { 1, 118, 119, 1418, 1420 }, // 67 tc_29175780
  { 1, 118, 119, 1420, 1422 }, // 68 tc_a21dc435
  { 1, 84, 85, 1422, 1425 }, // 69 tc_dbdffe3d
  { 1, 84, 85, 1425, 1430 }, // 70 tc_523fcf30
  { 1, 84, 85, 1430, 1433 }, // 71 tc_7a830544
  { 1, 85, 86, 1433, 1434 }, // 72 tc_452f85af
  { 1, 84, 85, 1434, 1437 }, // 73 tc_04c9decc
  { 1, 84, 85, 1437, 1441 }, // 74 tc_c6ce9b3f
  { 1, 84, 85, 1441, 1446 }, // 75 tc_caaebcba
  { 1, 84, 85, 1446, 1449 }, // 76 tc_55050d58
  { 1, 84, 85, 1449, 1453 }, // 77 tc_ef84f62f
  { 1, 84, 85, 1453, 1455 }, // 78 tc_f2704b9a
  { 1, 85, 86, 1455, 1458 }, // 79 tc_c6aa82f7
  { 1, 84, 85, 1458, 1460 }, // 80 tc_351fed2d
  { 1, 84, 85, 1460, 1464 }, // 81 tc_f8eeed7a
  { 1, 118, 119, 1464, 1466 }, // 82 tc_b9c4623f
  { 1, 84, 85, 1466, 1470 }, // 83 tc_481e5e5c
  { 1, 84, 85, 1470, 1471 }, // 84 tc_a27582fa
  { 1, 84, 85, 1471, 1473 }, // 85 tc_f3eaa14b
  { 1, 84, 85, 1473, 1475 }, // 86 tc_234a11a5
  { 1, 84, 85, 1475, 1478 }, // 87 tc_6792d5ff
  { 1, 84, 85, 1478, 1482 }, // 88 tc_d580173f
  { 1, 84, 85, 1482, 1487 }, // 89 tc_038a1342
  { 1, 84, 85, 1487, 1490 }, // 90 tc_4d99bca9
  { 1, 84, 85, 1490, 1493 }, // 91 tc_976ddc4f
  { 1, 84, 85, 1493, 1497 }, // 92 tc_9c00ce8d
  { 1, 118, 119, 1497, 1499 }, // 93 tc_6fa4db47
  { 1, 118, 119, 1499, 1501 }, // 94 tc_994333cd
  { 1, 84, 85, 1501, 1503 }, // 95 tc_2f185f5c
  { 1, 88, 89, 1503, 1504 }, // 96 tc_15411484
  { 1, 88, 89, 1504, 1506 }, // 97 tc_10b97e27
  { 1, 85, 86, 1506, 1507 }, // 98 tc_3669266a
  { 1, 85, 86, 1507, 1509 }, // 99 tc_a46f0df5
  { 1, 85, 86, 1509, 1511 }, // 100 tc_e1e99bfa
  { 1, 88, 89, 1511, 1513 }, // 101 tc_181af5d0
  { 1, 88, 89, 1513, 1515 }, // 102 tc_97743097
  { 1, 118, 119, 1515, 1517 }, // 103 tc_73043bf4
  { 1, 118, 119, 1517, 1519 }, // 104 tc_cf59f215
  { 1, 118, 119, 1519, 1521 }, // 105 tc_7934b9df
  { 1, 88, 89, 1521, 1522 }, // 106 tc_681a2300
  { 1, 118, 119, 1522, 1524 }, // 107 tc_c5e2426d
  { 1, 118, 119, 1524, 1526 }, // 108 tc_4f7cd700
  { 1, 88, 89, 1526, 1527 }, // 109 tc_14cd4cfa
  { 1, 86, 87, 1527, 1530 }, // 110 tc_51b866be
  { 1, 85, 86, 1530, 1533 }, // 111 tc_855b0b61
  { 1, 86, 87, 1533, 1536 }, // 112 tc_bde7aaf4
  { 1, 85, 86, 1536, 1539 }, // 113 tc_99be14ca
  { 1, 86, 87, 1539, 1542 }, // 114 tc_5eb851fc
  { 1, 84, 85, 1542, 1545 }, // 115 tc_49eb22c8
  { 1, 86, 87, 1545, 1547 }, // 116 tc_746baa8e
  { 1, 85, 86, 1547, 1549 }, // 117 tc_3cb8ea06
  { 1, 89, 90, 1549, 1554 }, // 118 tc_bad2bcaf
  { 1, 89, 90, 1554, 1560 }, // 119 tc_03220ffa
  { 1, 89, 90, 1560, 1562 }, // 120 tc_9c98e8af
  { 1, 86, 87, 1562, 1564 }, // 121 tc_6aa5711a
  { 1, 89, 90, 1564, 1569 }, // 122 tc_63fe3df7
  { 1, 89, 90, 1569, 1573 }, // 123 tc_5acef64a
  { 1, 89, 90, 1573, 1578 }, // 124 tc_0cd51c76
  { 1, 89, 90, 1578, 1581 }, // 125 tc_b77c481f
  { 1, 89, 90, 1581, 1585 }, // 126 tc_cf47a43f
  { 1, 89, 90, 1585, 1589 }, // 127 tc_f47d212f
  { 1, 89, 90, 1589, 1592 }, // 128 tc_1d5a38a8
  { 1, 89, 90, 1592, 1597 }, // 129 tc_9ef61e5c
  { 1, 89, 90, 1597, 1602 }, // 130 tc_b7dd427e
  { 1, 84, 85, 1602, 1606 }, // 131 tc_c74f796f
  { 1, 84, 85, 1606, 1610 }, // 132 tc_16d0d8d5
  { 1, 84, 85, 1610, 1614 }, // 133 tc_84df2cd3
  { 1, 84, 85, 1614, 1618 }, // 134 tc_bcc96cee
  { 1, 84, 85, 1618, 1621 }, // 135 tc_f49e76f4
  { 1, 89, 90, 1621, 1623 }, // 136 tc_a788683e
  { 1, 86, 87, 1623, 1625 }, // 137 tc_ff9ee76e
  { 1, 84, 85, 1625, 1627 }, // 138 tc_d088982c
  { 1, 84, 85, 1627, 1630 }, // 139 tc_c6ebf8dd
  { 1, 89, 90, 1630, 1635 }, // 140 tc_cd7374a0
  { 1, 89, 90, 1635, 1640 }, // 141 tc_74e47fd9
  { 1, 86, 87, 1640, 1645 }, // 142 tc_d9f95eef
  { 1, 86, 87, 1645, 1650 }, // 143 tc_d24b2d85
  { 1, 86, 87, 1650, 1655 }, // 144 tc_9d5941c7
  { 1, 86, 87, 1655, 1658 }, // 145 tc_1372bca1
  { 1, 89, 90, 1658, 1661 }, // 146 tc_238d91d2
  { 1, 89, 90, 1661, 1666 }, // 147 tc_5274e61a
  { 1, 89, 90, 1666, 1669 }, // 148 tc_66888ded
  { 1, 89, 90, 1669, 1674 }, // 149 tc_3e07fb90
  { 1, 86, 87, 1674, 1677 }, // 150 tc_6ac37025
  { 1, 86, 87, 1677, 1682 }, // 151 tc_adb14c66
  { 1, 86, 87, 1682, 1685 }, // 152 tc_53bdb2f6
  { 1, 86, 87, 1685, 1690 }, // 153 tc_e421e012
  { 1, 89, 90, 1690, 1694 }, // 154 tc_d9709180
  { 1, 89, 90, 1694, 1698 }, // 155 tc_0dc560de
  { 1, 86, 87, 1698, 1702 }, // 156 tc_b166348b
  { 1, 86, 87, 1702, 1706 }, // 157 tc_a8acdac0
  { 1, 84, 85, 1706, 1710 }, // 158 tc_b9c0b731
  { 1, 84, 85, 1710, 1715 }, // 159 tc_60571023
  { 1, 84, 85, 1715, 1717 }, // 160 tc_00afc57e
  { 1, 84, 85, 1717, 1721 }, // 161 tc_41d5298e
  { 1, 84, 85, 1721, 1723 }, // 162 tc_be706f30
  { 1, 89, 90, 1723, 1726 }, // 163 tc_609d2efe
  { 1, 89, 90, 1726, 1728 }, // 164 tc_a904d137
  { 1, 89, 90, 1728, 1729 }, // 165 tc_1b82a277
  { 1, 89, 90, 1729, 1730 }, // 166 tc_e9c822f7
  { 1, 89, 90, 1730, 1732 }, // 167 tc_90f3e30c
  { 1, 89, 90, 0, 0 }, // 168 tc_36c68ad1
  { 1, 86, 87, 0, 0 }, // 169 tc_2a160009
  { 1, 86, 87, 0, 0 }, // 170 tc_fcab4871
  { 1, 86, 87, 1732, 1733 }, // 171 tc_0fc1ae07
  { 1, 89, 90, 1733, 1735 }, // 172 tc_57288781
  { 1, 119, 121, 1735, 1738 }, // 173 tc_9777e6bf
  { 1, 121, 123, 1738, 1740 }, // 174 tc_6b78cf13
  { 1, 123, 125, 1740, 1742 }, // 175 tc_4105d6b5
  { 1, 97, 101, 1742, 1746 }, // 176 tc_4fd8566e
  { 1, 94, 97, 1746, 1750 }, // 177 tc_5cbf490b
  { 1, 94, 97, 1750, 1755 }, // 178 tc_da979fb3
  { 1, 94, 97, 1755, 1759 }, // 179 tc_eb669007
  { 1, 125, 127, 1759, 1762 }, // 180 tc_77a4c701
  { 1, 125, 127, 1762, 1766 }, // 181 tc_51cd3aab
  { 1, 125, 127, 1766, 1771 }, // 182 tc_38208312
  { 1, 125, 127, 1771, 1775 }, // 183 tc_9c267309
  { 1, 106, 110, 1775, 1779 }, // 184 tc_d642eff3
  { 1, 106, 110, 1779, 1784 }, // 185 tc_6fd9ad30
  { 1, 106, 110, 1784, 1788 }, // 186 tc_7fa82b08
  { 1, 127, 129, 1788, 1791 }, // 187 tc_1b93bdc6
  { 1, 127, 129, 1791, 1795 }, // 188 tc_d5090f3e
  { 1, 127, 129, 1795, 1800 }, // 189 tc_8b6a873f
  { 1, 127, 129, 1800, 1804 }, // 190 tc_db5b9e2f
  { 1, 103, 106, 1804, 1808 }, // 191 tc_85d237e3
  { 1, 103, 106, 1808, 1813 }, // 192 tc_0317c6ca
  { 1, 103, 106, 1813, 1817 }, // 193 tc_aedb9f9e
  { 1, 103, 106, 1817, 1822 }, // 194 tc_99093773
  { 1, 103, 106, 1822, 1826 }, // 195 tc_a4c9df3b
  { 1, 127, 129, 1826, 1828 }, // 196 tc_29841470
  { 1, 127, 129, 1828, 1831 }, // 197 tc_5c03dc63
  { 1, 121, 123, 1831, 1834 }, // 198 tc_908a4c8c
  { 1, 90, 92, 1834, 1838 }, // 199 tc_a3127e12
  { 1, 90, 92, 1838, 1843 }, // 200 tc_5a9fc4ec
  { 1, 112, 114, 1843, 1846 }, // 201 tc_45453b98
  { 1, 129, 131, 1846, 1849 }, // 202 tc_eda67dcd
  { 1, 129, 131, 1849, 1853 }, // 203 tc_e172d86a
  { 1, 123, 125, 1853, 1857 }, // 204 tc_c4b515c5
  { 1, 121, 123, 1857, 1860 }, // 205 tc_e231aa4f
  { 1, 121, 123, 1860, 1864 }, // 206 tc_9311da3f
  { 1, 112, 114, 1864, 1867 }, // 207 tc_41f4b64e
  { 1, 112, 114, 1867, 1871 }, // 208 tc_c00bf9c9
  { 1, 112, 114, 1871, 1873 }, // 209 tc_d2cb81ea
  { 1, 131, 133, 1873, 1878 }, // 210 tc_5c120602
  { 1, 123, 125, 1878, 1880 }, // 211 tc_e6299d16
  { 1, 123, 125, 1880, 1883 }, // 212 tc_f3fc3f83
  { 1, 131, 133, 1883, 1887 }, // 213 tc_4e2a5159
  { 1, 121, 123, 1887, 1890 }, // 214 tc_69b6dd20
  { 1, 121, 123, 1890, 1894 }, // 215 tc_d725e5b0
  { 1, 129, 131, 1894, 1897 }, // 216 tc_7c3f55c4
  { 1, 129, 131, 1897, 1901 }, // 217 tc_d98f4d63
  { 1, 133, 136, 1901, 1904 }, // 218 tc_66bb62ea
  { 1, 133, 136, 1904, 1908 }, // 219 tc_63e3d94c
  { 1, 136, 139, 1908, 1911 }, // 220 tc_bfe309d5
  { 1, 136, 139, 1911, 1915 }, // 221 tc_98733e9d
  { 1, 139, 141, 0, 0 }, // 222 tc_e5053c8f
  { 1, 139, 141, 1915, 1916 }, // 223 tc_cedf314b
  { 1, 141, 143, 1916, 1919 }, // 224 tc_fa99dc24
  { 1, 131, 133, 1919, 1924 }, // 225 tc_cbf6d1dc
  { 1, 141, 143, 1924, 1928 }, // 226 tc_7474003e
  { 1, 143, 146, 1928, 1931 }, // 227 tc_a807365d
  { 1, 143, 146, 1931, 1935 }, // 228 tc_ee927c0e
  { 1, 129, 131, 1935, 1939 }, // 229 tc_7e9f581b
  { 1, 129, 131, 1939, 1944 }, // 230 tc_41f99e1c
  { 1, 123, 125, 1944, 1947 }, // 231 tc_bf142ae2
  { 1, 90, 92, 1947, 1950 }, // 232 tc_9b9642a1
  { 1, 92, 94, 1950, 1952 }, // 233 tc_644584f8
  { 1, 103, 106, 1952, 1956 }, // 234 tc_4f190ba3
  { 1, 103, 106, 1956, 1961 }, // 235 tc_df54ad52
  { 1, 146, 149, 1961, 1965 }, // 236 tc_ec58f88a
  { 1, 146, 149, 1965, 1970 }, // 237 tc_94f43c04
  { 1, 92, 94, 1970, 1974 }, // 238 tc_316c637c
  { 1, 131, 133, 1974, 1976 }, // 239 tc_d7bea0ec
  { 1, 131, 133, 1976, 1979 }, // 240 tc_72ad7b54
  { 1, 139, 141, 1979, 1980 }, // 241 tc_b77635b4
  { 1, 139, 141, 1980, 1982 }, // 242 tc_28978789
  { 1, 86, 87, 0, 0 }, // 243 tc_367f7f3d
  { 1, 118, 119, 0, 0 }, // 244 tc_4ca572d4
  { 1, 86, 87, 1982, 1983 }, // 245 tc_00e7c26e
  { 1, 86, 87, 1983, 1985 }, // 246 tc_4d9914c9
  { 1, 88, 89, 1985, 1986 }, // 247 tc_999d32db
  { 1, 88, 89, 0, 0 }, // 248 tc_b13761ae
  { 1, 86, 87, 1986, 1988 }, // 249 tc_daa058fa
  { 1, 118, 119, 1988, 1989 }, // 250 tc_c82dc1ff
  { 0, uint16_t(~0U), uint16_t(~0U), uint16_t(~0U), uint16_t(~0U) }// end marker
};

static const llvm::InstrItinerary HexagonItinerariesV65[] = {
  { 0, 0, 0, 0, 0 }, // 0 NoInstrModel
  { 1, 149, 150, 1989, 1992 }, // 1 tc_897d1a9d
  { 1, 150, 151, 1992, 1995 }, // 2 PSEUDO
  { 1, 150, 151, 1995, 1997 }, // 3 tc_68cb12ce
  { 1, 150, 151, 1997, 2001 }, // 4 tc_d6bf0472
  { 1, 150, 151, 2001, 2005 }, // 5 tc_2b2f4060
  { 1, 150, 151, 2005, 2008 }, // 6 tc_b9488031
  { 1, 150, 151, 2008, 2011 }, // 7 tc_5f6847a1
  { 1, 149, 150, 2011, 2014 }, // 8 tc_540fdfbc
  { 1, 149, 150, 2014, 2017 }, // 9 tc_1e856f58
  { 1, 150, 151, 2017, 2020 }, // 10 tc_6ebb4a12
  { 1, 149, 150, 2020, 2023 }, // 11 tc_53bc8a6a
  { 1, 151, 152, 2023, 2026 }, // 12 DUPLEX
  { 1, 152, 153, 2026, 2027 }, // 13 tc_ENDLOOP
  { 1, 150, 151, 0, 0 }, // 14 tc_52d7bbea
  { 1, 150, 151, 2027, 2029 }, // 15 tc_e9fae2d6
  { 1, 153, 154, 2029, 2031 }, // 16 tc_e0739b8c
  { 1, 153, 154, 2031, 2034 }, // 17 tc_59a01ead
  { 1, 154, 155, 2034, 2038 }, // 18 tc_ef52ed71
  { 1, 154, 155, 2038, 2041 }, // 19 tc_7f881c76
  { 1, 154, 155, 2041, 2045 }, // 20 tc_2fc0c436
  { 1, 151, 152, 2045, 2048 }, // 21 tc_44126683
  { 1, 151, 152, 2048, 2051 }, // 22 tc_513bef45
  { 1, 151, 152, 2051, 2054 }, // 23 tc_395dc00f
  { 1, 151, 152, 2054, 2055 }, // 24 tc_3bc2c5d3
  { 1, 151, 152, 2055, 2056 }, // 25 tc_e7624c08
  { 1, 154, 155, 2056, 2058 }, // 26 tc_d1090e34
  { 1, 151, 152, 2058, 2060 }, // 27 tc_3d04548d
  { 1, 154, 155, 2060, 2062 }, // 28 LD_tc_ld_SLOT01
  { 1, 149, 150, 2062, 2065 }, // 29 tc_1853ea6d
  { 1, 149, 150, 2065, 2068 }, // 30 tc_8fd5f294
  { 1, 149, 150, 2068, 2072 }, // 31 tc_e913dc32
  { 1, 154, 155, 2072, 2077 }, // 32 tc_4403ca65
  { 1, 155, 157, 2077, 2080 }, // 33 tc_bbaf280e
  { 1, 154, 155, 2080, 2085 }, // 34 tc_9fdb5406
  { 1, 154, 155, 2085, 2089 }, // 35 tc_f86c328a
  { 1, 153, 154, 2089, 2090 }, // 36 tc_9faf76ae
  { 1, 157, 159, 2090, 2093 }, // 37 tc_97c165b9
  { 1, 159, 162, 2093, 2096 }, // 38 tc_b712833a
  { 1, 162, 166, 2096, 2099 }, // 39 tc_35e92f8e
  { 1, 166, 168, 2099, 2102 }, // 40 PSEUDOM
  { 1, 155, 157, 2102, 2105 }, // 41 tc_b06ab583
  { 1, 168, 171, 2105, 2108 }, // 42 tc_e3748cdf
  { 1, 171, 175, 2108, 2111 }, // 43 tc_354299ad
  { 1, 157, 159, 2111, 2115 }, // 44 tc_2171ebae
  { 1, 149, 150, 2115, 2118 }, // 45 tc_2b6f77c6
  { 1, 154, 155, 2118, 2122 }, // 46 tc_8b15472a
  { 1, 151, 152, 2122, 2126 }, // 47 tc_594ab548
  { 1, 154, 155, 2126, 2129 }, // 48 tc_05b6c987
  { 1, 151, 152, 2129, 2132 }, // 49 tc_f7dd9c9f
  { 1, 149, 150, 2132, 2137 }, // 50 tc_87735c3b
  { 1, 151, 152, 2137, 2141 }, // 51 tc_e7d02c66
  { 1, 151, 152, 2141, 2144 }, // 52 tc_e216a5db
  { 1, 154, 155, 2144, 2147 }, // 53 ST_tc_st_SLOT01
  { 1, 175, 177, 2147, 2151 }, // 54 CVI_VA
  { 1, 155, 157, 2151, 2153 }, // 55 tc_71337255
  { 1, 177, 179, 2153, 2157 }, // 56 tc_7fa8b40f
  { 1, 157, 159, 2157, 2158 }, // 57 tc_8a6eb39a
  { 1, 179, 183, 0, 0 }, // 58 CVI_GATHER_PSEUDO
  { 1, 151, 152, 2158, 2159 }, // 59 tc_3da80ba5
  { 1, 149, 150, 2159, 2161 }, // 60 tc_c2f7d806
  { 1, 149, 150, 2161, 2164 }, // 61 tc_b44c6e2a
  { 1, 149, 150, 2164, 2167 }, // 62 tc_1b9c9ee5
  { 1, 150, 151, 2167, 2170 }, // 63 tc_5ba5997d
  { 1, 149, 150, 2170, 2172 }, // 64 tc_cde8b071
  { 1, 150, 151, 0, 0 }, // 65 tc_6efc556e
  { 1, 150, 151, 2172, 2175 }, // 66 tc_8fe6b782
  { 1, 183, 184, 2175, 2177 }, // 67 tc_29175780
  { 1, 183, 184, 2177, 2179 }, // 68 tc_a21dc435
  { 1, 149, 150, 2179, 2182 }, // 69 tc_dbdffe3d
  { 1, 149, 150, 2182, 2187 }, // 70 tc_523fcf30
  { 1, 149, 150, 2187, 2190 }, // 71 tc_7a830544
  { 1, 150, 151, 2190, 2191 }, // 72 tc_452f85af
  { 1, 149, 150, 2191, 2194 }, // 73 tc_04c9decc
  { 1, 149, 150, 2194, 2198 }, // 74 tc_c6ce9b3f
  { 1, 149, 150, 2198, 2203 }, // 75 tc_caaebcba
  { 1, 149, 150, 2203, 2206 }, // 76 tc_55050d58
  { 1, 149, 150, 2206, 2210 }, // 77 tc_ef84f62f
  { 1, 149, 150, 2210, 2212 }, // 78 tc_f2704b9a
  { 1, 150, 151, 2212, 2215 }, // 79 tc_c6aa82f7
  { 1, 149, 150, 2215, 2217 }, // 80 tc_351fed2d
  { 1, 149, 150, 2217, 2221 }, // 81 tc_f8eeed7a
  { 1, 183, 184, 2221, 2223 }, // 82 tc_b9c4623f
  { 1, 149, 150, 2223, 2227 }, // 83 tc_481e5e5c
  { 1, 149, 150, 2227, 2228 }, // 84 tc_a27582fa
  { 1, 149, 150, 2228, 2230 }, // 85 tc_f3eaa14b
  { 1, 149, 150, 2230, 2232 }, // 86 tc_234a11a5
  { 1, 149, 150, 2232, 2235 }, // 87 tc_6792d5ff
  { 1, 149, 150, 2235, 2239 }, // 88 tc_d580173f
  { 1, 149, 150, 2239, 2244 }, // 89 tc_038a1342
  { 1, 149, 150, 2244, 2247 }, // 90 tc_4d99bca9
  { 1, 149, 150, 2247, 2250 }, // 91 tc_976ddc4f
  { 1, 149, 150, 2250, 2254 }, // 92 tc_9c00ce8d
  { 1, 183, 184, 2254, 2256 }, // 93 tc_6fa4db47
  { 1, 183, 184, 2256, 2258 }, // 94 tc_994333cd
  { 1, 149, 150, 2258, 2260 }, // 95 tc_2f185f5c
  { 1, 153, 154, 2260, 2261 }, // 96 tc_15411484
  { 1, 153, 154, 2261, 2263 }, // 97 tc_10b97e27
  { 1, 150, 151, 2263, 2264 }, // 98 tc_3669266a
  { 1, 150, 151, 2264, 2266 }, // 99 tc_a46f0df5
  { 1, 150, 151, 2266, 2268 }, // 100 tc_e1e99bfa
  { 1, 153, 154, 2268, 2270 }, // 101 tc_181af5d0
  { 1, 153, 154, 2270, 2272 }, // 102 tc_97743097
  { 1, 183, 184, 2272, 2274 }, // 103 tc_73043bf4
  { 1, 183, 184, 2274, 2276 }, // 104 tc_cf59f215
  { 1, 183, 184, 2276, 2278 }, // 105 tc_7934b9df
  { 1, 153, 154, 2278, 2279 }, // 106 tc_681a2300
  { 1, 183, 184, 2279, 2281 }, // 107 tc_c5e2426d
  { 1, 183, 184, 2281, 2283 }, // 108 tc_4f7cd700
  { 1, 153, 154, 2283, 2284 }, // 109 tc_14cd4cfa
  { 1, 151, 152, 2284, 2287 }, // 110 tc_51b866be
  { 1, 150, 151, 2287, 2290 }, // 111 tc_855b0b61
  { 1, 151, 152, 2290, 2293 }, // 112 tc_bde7aaf4
  { 1, 150, 151, 2293, 2296 }, // 113 tc_99be14ca
  { 1, 151, 152, 2296, 2299 }, // 114 tc_5eb851fc
  { 1, 149, 150, 2299, 2302 }, // 115 tc_49eb22c8
  { 1, 151, 152, 2302, 2304 }, // 116 tc_746baa8e
  { 1, 150, 151, 2304, 2306 }, // 117 tc_3cb8ea06
  { 1, 154, 155, 2306, 2311 }, // 118 tc_bad2bcaf
  { 1, 154, 155, 2311, 2317 }, // 119 tc_03220ffa
  { 1, 154, 155, 2317, 2319 }, // 120 tc_9c98e8af
  { 1, 151, 152, 2319, 2321 }, // 121 tc_6aa5711a
  { 1, 154, 155, 2321, 2326 }, // 122 tc_63fe3df7
  { 1, 154, 155, 2326, 2330 }, // 123 tc_5acef64a
  { 1, 154, 155, 2330, 2335 }, // 124 tc_0cd51c76
  { 1, 154, 155, 2335, 2338 }, // 125 tc_b77c481f
  { 1, 154, 155, 2338, 2342 }, // 126 tc_cf47a43f
  { 1, 154, 155, 2342, 2346 }, // 127 tc_f47d212f
  { 1, 154, 155, 2346, 2349 }, // 128 tc_1d5a38a8
  { 1, 154, 155, 2349, 2354 }, // 129 tc_9ef61e5c
  { 1, 154, 155, 2354, 2359 }, // 130 tc_b7dd427e
  { 1, 149, 150, 2359, 2363 }, // 131 tc_c74f796f
  { 1, 149, 150, 2363, 2367 }, // 132 tc_16d0d8d5
  { 1, 149, 150, 2367, 2371 }, // 133 tc_84df2cd3
  { 1, 149, 150, 2371, 2375 }, // 134 tc_bcc96cee
  { 1, 149, 150, 2375, 2378 }, // 135 tc_f49e76f4
  { 1, 154, 155, 2378, 2380 }, // 136 tc_a788683e
  { 1, 151, 152, 2380, 2382 }, // 137 tc_ff9ee76e
  { 1, 149, 150, 2382, 2384 }, // 138 tc_d088982c
  { 1, 149, 150, 2384, 2387 }, // 139 tc_c6ebf8dd
  { 1, 154, 155, 2387, 2392 }, // 140 tc_cd7374a0
  { 1, 154, 155, 2392, 2397 }, // 141 tc_74e47fd9
  { 1, 151, 152, 2397, 2402 }, // 142 tc_d9f95eef
  { 1, 151, 152, 2402, 2407 }, // 143 tc_d24b2d85
  { 1, 151, 152, 2407, 2412 }, // 144 tc_9d5941c7
  { 1, 151, 152, 2412, 2415 }, // 145 tc_1372bca1
  { 1, 154, 155, 2415, 2418 }, // 146 tc_238d91d2
  { 1, 154, 155, 2418, 2423 }, // 147 tc_5274e61a
  { 1, 154, 155, 2423, 2426 }, // 148 tc_66888ded
  { 1, 154, 155, 2426, 2431 }, // 149 tc_3e07fb90
  { 1, 151, 152, 2431, 2434 }, // 150 tc_6ac37025
  { 1, 151, 152, 2434, 2439 }, // 151 tc_adb14c66
  { 1, 151, 152, 2439, 2442 }, // 152 tc_53bdb2f6
  { 1, 151, 152, 2442, 2447 }, // 153 tc_e421e012
  { 1, 154, 155, 2447, 2451 }, // 154 tc_d9709180
  { 1, 154, 155, 2451, 2455 }, // 155 tc_0dc560de
  { 1, 151, 152, 2455, 2459 }, // 156 tc_b166348b
  { 1, 151, 152, 2459, 2463 }, // 157 tc_a8acdac0
  { 1, 149, 150, 2463, 2467 }, // 158 tc_b9c0b731
  { 1, 149, 150, 2467, 2472 }, // 159 tc_60571023
  { 1, 149, 150, 2472, 2474 }, // 160 tc_00afc57e
  { 1, 149, 150, 2474, 2478 }, // 161 tc_41d5298e
  { 1, 149, 150, 2478, 2480 }, // 162 tc_be706f30
  { 1, 154, 155, 2480, 2483 }, // 163 tc_609d2efe
  { 1, 154, 155, 2483, 2485 }, // 164 tc_a904d137
  { 1, 154, 155, 2485, 2486 }, // 165 tc_1b82a277
  { 1, 154, 155, 2486, 2487 }, // 166 tc_e9c822f7
  { 1, 154, 155, 2487, 2489 }, // 167 tc_90f3e30c
  { 1, 154, 155, 0, 0 }, // 168 tc_36c68ad1
  { 1, 151, 152, 0, 0 }, // 169 tc_2a160009
  { 1, 151, 152, 0, 0 }, // 170 tc_fcab4871
  { 1, 151, 152, 2489, 2490 }, // 171 tc_0fc1ae07
  { 1, 154, 155, 2490, 2492 }, // 172 tc_57288781
  { 1, 184, 186, 2492, 2495 }, // 173 tc_9777e6bf
  { 1, 186, 188, 2495, 2497 }, // 174 tc_6b78cf13
  { 1, 188, 190, 2497, 2499 }, // 175 tc_4105d6b5
  { 1, 162, 166, 2499, 2503 }, // 176 tc_4fd8566e
  { 1, 159, 162, 2503, 2507 }, // 177 tc_5cbf490b
  { 1, 159, 162, 2507, 2512 }, // 178 tc_da979fb3
  { 1, 159, 162, 2512, 2516 }, // 179 tc_eb669007
  { 1, 190, 192, 2516, 2519 }, // 180 tc_77a4c701
  { 1, 190, 192, 2519, 2523 }, // 181 tc_51cd3aab
  { 1, 190, 192, 2523, 2528 }, // 182 tc_38208312
  { 1, 190, 192, 2528, 2532 }, // 183 tc_9c267309
  { 1, 171, 175, 2532, 2536 }, // 184 tc_d642eff3
  { 1, 171, 175, 2536, 2541 }, // 185 tc_6fd9ad30
  { 1, 171, 175, 2541, 2545 }, // 186 tc_7fa82b08
  { 1, 192, 194, 2545, 2548 }, // 187 tc_1b93bdc6
  { 1, 192, 194, 2548, 2552 }, // 188 tc_d5090f3e
  { 1, 192, 194, 2552, 2557 }, // 189 tc_8b6a873f
  { 1, 192, 194, 2557, 2561 }, // 190 tc_db5b9e2f
  { 1, 168, 171, 2561, 2565 }, // 191 tc_85d237e3
  { 1, 168, 171, 2565, 2570 }, // 192 tc_0317c6ca
  { 1, 168, 171, 2570, 2574 }, // 193 tc_aedb9f9e
  { 1, 168, 171, 2574, 2579 }, // 194 tc_99093773
  { 1, 168, 171, 2579, 2583 }, // 195 tc_a4c9df3b
  { 1, 192, 194, 2583, 2585 }, // 196 tc_29841470
  { 1, 192, 194, 2585, 2588 }, // 197 tc_5c03dc63
  { 1, 186, 188, 2588, 2591 }, // 198 tc_908a4c8c
  { 1, 155, 157, 2591, 2595 }, // 199 tc_a3127e12
  { 1, 155, 157, 2595, 2600 }, // 200 tc_5a9fc4ec
  { 1, 177, 179, 2600, 2603 }, // 201 tc_45453b98
  { 1, 194, 196, 2603, 2606 }, // 202 tc_eda67dcd
  { 1, 194, 196, 2606, 2610 }, // 203 tc_e172d86a
  { 1, 188, 190, 2610, 2614 }, // 204 tc_c4b515c5
  { 1, 186, 188, 2614, 2617 }, // 205 tc_e231aa4f
  { 1, 186, 188, 2617, 2621 }, // 206 tc_9311da3f
  { 1, 177, 179, 2621, 2624 }, // 207 tc_41f4b64e
  { 1, 177, 179, 2624, 2628 }, // 208 tc_c00bf9c9
  { 1, 177, 179, 2628, 2630 }, // 209 tc_d2cb81ea
  { 1, 196, 198, 2630, 2635 }, // 210 tc_5c120602
  { 1, 188, 190, 2635, 2637 }, // 211 tc_e6299d16
  { 1, 188, 190, 2637, 2640 }, // 212 tc_f3fc3f83
  { 1, 196, 198, 2640, 2644 }, // 213 tc_4e2a5159
  { 1, 186, 188, 2644, 2647 }, // 214 tc_69b6dd20
  { 1, 186, 188, 2647, 2651 }, // 215 tc_d725e5b0
  { 1, 194, 196, 2651, 2654 }, // 216 tc_7c3f55c4
  { 1, 194, 196, 2654, 2658 }, // 217 tc_d98f4d63
  { 1, 198, 201, 2658, 2661 }, // 218 tc_66bb62ea
  { 1, 198, 201, 2661, 2665 }, // 219 tc_63e3d94c
  { 1, 201, 204, 2665, 2668 }, // 220 tc_bfe309d5
  { 1, 201, 204, 2668, 2672 }, // 221 tc_98733e9d
  { 1, 204, 206, 0, 0 }, // 222 tc_e5053c8f
  { 1, 204, 206, 2672, 2673 }, // 223 tc_cedf314b
  { 1, 206, 208, 2673, 2676 }, // 224 tc_fa99dc24
  { 1, 196, 198, 2676, 2681 }, // 225 tc_cbf6d1dc
  { 1, 206, 208, 2681, 2685 }, // 226 tc_7474003e
  { 1, 208, 211, 2685, 2688 }, // 227 tc_a807365d
  { 1, 208, 211, 2688, 2692 }, // 228 tc_ee927c0e
  { 1, 194, 196, 2692, 2696 }, // 229 tc_7e9f581b
  { 1, 194, 196, 2696, 2701 }, // 230 tc_41f99e1c
  { 1, 188, 190, 2701, 2704 }, // 231 tc_bf142ae2
  { 1, 155, 157, 2704, 2707 }, // 232 tc_9b9642a1
  { 1, 157, 159, 2707, 2709 }, // 233 tc_644584f8
  { 1, 168, 171, 2709, 2713 }, // 234 tc_4f190ba3
  { 1, 168, 171, 2713, 2718 }, // 235 tc_df54ad52
  { 1, 211, 214, 2718, 2722 }, // 236 tc_ec58f88a
  { 1, 211, 214, 2722, 2727 }, // 237 tc_94f43c04
  { 1, 157, 159, 2727, 2731 }, // 238 tc_316c637c
  { 1, 196, 198, 2731, 2733 }, // 239 tc_d7bea0ec
  { 1, 196, 198, 2733, 2736 }, // 240 tc_72ad7b54
  { 1, 204, 206, 2736, 2737 }, // 241 tc_b77635b4
  { 1, 204, 206, 2737, 2739 }, // 242 tc_28978789
  { 1, 151, 152, 0, 0 }, // 243 tc_367f7f3d
  { 1, 183, 184, 0, 0 }, // 244 tc_4ca572d4
  { 1, 151, 152, 2739, 2740 }, // 245 tc_00e7c26e
  { 1, 151, 152, 2740, 2742 }, // 246 tc_4d9914c9
  { 1, 153, 154, 2742, 2743 }, // 247 tc_999d32db
  { 1, 153, 154, 0, 0 }, // 248 tc_b13761ae
  { 1, 151, 152, 2743, 2745 }, // 249 tc_daa058fa
  { 1, 183, 184, 2745, 2746 }, // 250 tc_c82dc1ff
  { 0, uint16_t(~0U), uint16_t(~0U), uint16_t(~0U), uint16_t(~0U) }// end marker
};

// ===============================================================
// Data tables for the new per-operand machine model.

// {ProcResourceIdx, Cycles}
extern const llvm::MCWriteProcResEntry HexagonWriteProcResTable[] = {
  { 0,  0}, // Invalid
}; // HexagonWriteProcResTable

// {Cycles, WriteResourceID}
extern const llvm::MCWriteLatencyEntry HexagonWriteLatencyTable[] = {
  { 0,  0}, // Invalid
}; // HexagonWriteLatencyTable

// {UseIdx, WriteResourceID, Cycles}
extern const llvm::MCReadAdvanceEntry HexagonReadAdvanceTable[] = {
  {0,  0,  0}, // Invalid
}; // HexagonReadAdvanceTable

static const llvm::MCSchedModel NoSchedModel = {
  MCSchedModel::DefaultIssueWidth,
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  MCSchedModel::DefaultLoadLatency,
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  0, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  nullptr, // No Itinerary
  nullptr // No extra processor descriptor
};

static const llvm::MCSchedModel HexagonModelV60 = {
  4, // IssueWidth
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  1, // LoadLatency
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  1, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  HexagonItinerariesV60,
  nullptr // No extra processor descriptor
};

static const llvm::MCSchedModel HexagonModelV4 = {
  4, // IssueWidth
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  1, // LoadLatency
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  2, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  HexagonItinerariesV4,
  nullptr // No extra processor descriptor
};

static const llvm::MCSchedModel HexagonModelV55 = {
  4, // IssueWidth
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  1, // LoadLatency
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  3, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  HexagonItinerariesV55,
  nullptr // No extra processor descriptor
};

static const llvm::MCSchedModel HexagonModelV62 = {
  4, // IssueWidth
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  1, // LoadLatency
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  4, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  HexagonItinerariesV62,
  nullptr // No extra processor descriptor
};

static const llvm::MCSchedModel HexagonModelV65 = {
  4, // IssueWidth
  MCSchedModel::DefaultMicroOpBufferSize,
  MCSchedModel::DefaultLoopMicroOpBufferSize,
  1, // LoadLatency
  MCSchedModel::DefaultHighLatency,
  MCSchedModel::DefaultMispredictPenalty,
  false, // PostRAScheduler
  false, // CompleteModel
  5, // Processor ID
  nullptr, nullptr, 0, 0, // No instruction-level machine model.
  HexagonItinerariesV65,
  nullptr // No extra processor descriptor
};

// Sorted (by key) array of itineraries for CPU subtype.
extern const llvm::SubtargetInfoKV HexagonProcSchedKV[] = {
  { "generic", (const void *)&HexagonModelV60 },
  { "hexagonv4", (const void *)&HexagonModelV4 },
  { "hexagonv5", (const void *)&HexagonModelV4 },
  { "hexagonv55", (const void *)&HexagonModelV55 },
  { "hexagonv60", (const void *)&HexagonModelV60 },
  { "hexagonv62", (const void *)&HexagonModelV62 },
  { "hexagonv65", (const void *)&HexagonModelV65 },
};

#undef DBGFIELD
namespace Hexagon_MC {
unsigned resolveVariantSchedClassImpl(unsigned SchedClass,
    const MCInst *MI, unsigned CPUID) {
  // Don't know how to resolve this scheduling class.
  return 0;
}
} // end of namespace Hexagon_MC

struct HexagonGenMCSubtargetInfo : public MCSubtargetInfo {
  HexagonGenMCSubtargetInfo(const Triple &TT, 
    StringRef CPU, StringRef FS, ArrayRef<SubtargetFeatureKV> PF,
    ArrayRef<SubtargetFeatureKV> PD,
    const SubtargetInfoKV *ProcSched,
    const MCWriteProcResEntry *WPR,
    const MCWriteLatencyEntry *WL,
    const MCReadAdvanceEntry *RA, const InstrStage *IS,
    const unsigned *OC, const unsigned *FP) :
      MCSubtargetInfo(TT, CPU, FS, PF, PD, ProcSched,
                      WPR, WL, RA, IS, OC, FP) { }

  unsigned resolveVariantSchedClass(unsigned SchedClass,
      const MCInst *MI, unsigned CPUID) const override {
    return Hexagon_MC::resolveVariantSchedClassImpl(SchedClass, MI, CPUID); 
  }
};

static inline MCSubtargetInfo *createHexagonMCSubtargetInfoImpl(const Triple &TT, StringRef CPU, StringRef FS) {
  return new HexagonGenMCSubtargetInfo(TT, CPU, FS, HexagonFeatureKV, HexagonSubTypeKV, 
                      HexagonProcSchedKV, HexagonWriteProcResTable, HexagonWriteLatencyTable, HexagonReadAdvanceTable, 
                      HexagonStages, HexagonOperandCycles, HexagonForwardingPaths);
}

} // end namespace llvm

#endif // GET_SUBTARGETINFO_MC_DESC


#ifdef GET_SUBTARGETINFO_TARGET_DESC
#undef GET_SUBTARGETINFO_TARGET_DESC

#include "llvm/Support/Debug.h"
#include "llvm/Support/raw_ostream.h"

// ParseSubtargetFeatures - Parses features string setting specified
// subtarget options.
void llvm::HexagonSubtarget::ParseSubtargetFeatures(StringRef CPU, StringRef FS) {
  LLVM_DEBUG(dbgs() << "\nFeatures:" << FS);
  LLVM_DEBUG(dbgs() << "\nCPU:" << CPU << "\n\n");
  InitMCProcessorInfo(CPU, FS);
  const FeatureBitset& Bits = getFeatureBits();
  if (Bits[Hexagon::ArchV4] && HexagonArchVersion < Hexagon::ArchEnum::V4) HexagonArchVersion = Hexagon::ArchEnum::V4;
  if (Bits[Hexagon::ArchV5] && HexagonArchVersion < Hexagon::ArchEnum::V5) HexagonArchVersion = Hexagon::ArchEnum::V5;
  if (Bits[Hexagon::ArchV55] && HexagonArchVersion < Hexagon::ArchEnum::V55) HexagonArchVersion = Hexagon::ArchEnum::V55;
  if (Bits[Hexagon::ArchV60] && HexagonArchVersion < Hexagon::ArchEnum::V60) HexagonArchVersion = Hexagon::ArchEnum::V60;
  if (Bits[Hexagon::ArchV62] && HexagonArchVersion < Hexagon::ArchEnum::V62) HexagonArchVersion = Hexagon::ArchEnum::V62;
  if (Bits[Hexagon::ArchV65] && HexagonArchVersion < Hexagon::ArchEnum::V65) HexagonArchVersion = Hexagon::ArchEnum::V65;
  if (Bits[Hexagon::ExtensionHVX] && HexagonHVXVersion < Hexagon::ArchEnum::V60) HexagonHVXVersion = Hexagon::ArchEnum::V60;
  if (Bits[Hexagon::ExtensionHVX64B]) UseHVX64BOps = true;
  if (Bits[Hexagon::ExtensionHVX128B]) UseHVX128BOps = true;
  if (Bits[Hexagon::ExtensionHVXV60] && HexagonHVXVersion < Hexagon::ArchEnum::V60) HexagonHVXVersion = Hexagon::ArchEnum::V60;
  if (Bits[Hexagon::ExtensionHVXV62] && HexagonHVXVersion < Hexagon::ArchEnum::V62) HexagonHVXVersion = Hexagon::ArchEnum::V62;
  if (Bits[Hexagon::ExtensionHVXV65] && HexagonHVXVersion < Hexagon::ArchEnum::V65) HexagonHVXVersion = Hexagon::ArchEnum::V65;
  if (Bits[Hexagon::FeatureDuplex]) EnableDuplex = true;
  if (Bits[Hexagon::FeatureLongCalls]) UseLongCalls = true;
  if (Bits[Hexagon::FeatureMemNoShuf]) HasMemNoShuf = false;
  if (Bits[Hexagon::FeatureMemops]) UseMemops = true;
  if (Bits[Hexagon::FeatureNVJ]) UseNewValueJumps = true;
  if (Bits[Hexagon::FeatureNVS]) UseNewValueStores = true;
  if (Bits[Hexagon::FeaturePackets]) UsePackets = true;
  if (Bits[Hexagon::FeatureReservedR19]) ReservedR19 = true;
  if (Bits[Hexagon::FeatureSmallData]) UseSmallData = true;
}
#endif // GET_SUBTARGETINFO_TARGET_DESC


#ifdef GET_SUBTARGETINFO_HEADER
#undef GET_SUBTARGETINFO_HEADER

namespace llvm {
class DFAPacketizer;
namespace Hexagon_MC {
unsigned resolveVariantSchedClassImpl(unsigned SchedClass, const MCInst *MI, unsigned CPUID);
}

struct HexagonGenSubtargetInfo : public TargetSubtargetInfo {
  explicit HexagonGenSubtargetInfo(const Triple &TT, StringRef CPU, StringRef FS);
public:
  unsigned resolveSchedClass(unsigned SchedClass,  const MachineInstr *DefMI, const TargetSchedModel *SchedModel) const override;
  unsigned resolveVariantSchedClass(unsigned SchedClass, const MCInst *MI, unsigned CPUID) const override;
  DFAPacketizer *createDFAPacketizer(const InstrItineraryData *IID) const;
  unsigned getHwMode() const override;
};
} // end namespace llvm

#endif // GET_SUBTARGETINFO_HEADER


#ifdef GET_SUBTARGETINFO_CTOR
#undef GET_SUBTARGETINFO_CTOR

#include "llvm/CodeGen/TargetSchedule.h"

namespace llvm {
extern const llvm::SubtargetFeatureKV HexagonFeatureKV[];
extern const llvm::SubtargetFeatureKV HexagonSubTypeKV[];
extern const llvm::SubtargetInfoKV HexagonProcSchedKV[];
extern const llvm::MCWriteProcResEntry HexagonWriteProcResTable[];
extern const llvm::MCWriteLatencyEntry HexagonWriteLatencyTable[];
extern const llvm::MCReadAdvanceEntry HexagonReadAdvanceTable[];
extern const llvm::InstrStage HexagonStages[];
extern const unsigned HexagonOperandCycles[];
extern const unsigned HexagonForwardingPaths[];
HexagonGenSubtargetInfo::HexagonGenSubtargetInfo(const Triple &TT, StringRef CPU, StringRef FS)
  : TargetSubtargetInfo(TT, CPU, FS, makeArrayRef(HexagonFeatureKV, 21), makeArrayRef(HexagonSubTypeKV, 7), 
                        HexagonProcSchedKV, HexagonWriteProcResTable, HexagonWriteLatencyTable, HexagonReadAdvanceTable, 
                        HexagonStages, HexagonOperandCycles, HexagonForwardingPaths) {}

unsigned HexagonGenSubtargetInfo
::resolveSchedClass(unsigned SchedClass, const MachineInstr *MI, const TargetSchedModel *SchedModel) const {
  report_fatal_error("Expected a variant SchedClass");
} // HexagonGenSubtargetInfo::resolveSchedClass

unsigned HexagonGenSubtargetInfo
::resolveVariantSchedClass(unsigned SchedClass, const MCInst *MI, unsigned CPUID) const {
  return Hexagon_MC::resolveVariantSchedClassImpl(SchedClass, MI, CPUID);
} // HexagonGenSubtargetInfo::resolveVariantSchedClass
unsigned HexagonGenSubtargetInfo::getHwMode() const {
  if (checkFeatures("+hvx-length128b")) return 1;
  if (checkFeatures("+hvx-length64b")) return 2;
  return 0;
}
} // end namespace llvm

#endif // GET_SUBTARGETINFO_CTOR

