/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|*  * Sparc Disassembler                                                      *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#include "llvm/MC/MCInst.h"
#include "llvm/Support/Debug.h"
#include "llvm/Support/DataTypes.h"
#include "llvm/Support/LEB128.h"
#include "llvm/Support/raw_ostream.h"
#include <assert.h>

namespace llvm {

// Helper function for extracting fields from encoded instructions.
template<typename InsnType>
#if defined(_MSC_VER) && !defined(__clang__)
__declspec(noinline)
#endif
static InsnType fieldFromInstruction(InsnType insn, unsigned startBit,
                                     unsigned numBits) {
    assert(startBit + numBits <= (sizeof(InsnType)*8) &&
           "Instruction field out of bounds!");
    InsnType fieldMask;
    if (numBits == sizeof(InsnType)*8)
      fieldMask = (InsnType)(-1LL);
    else
      fieldMask = (((InsnType)1 << numBits) - 1) << startBit;
    return (insn & fieldMask) >> startBit;
}

static const uint8_t DecoderTableSparc32[] = {
/* 0 */       MCD::OPC_ExtractField, 30, 2,  // Inst{31-30} ...
/* 3 */       MCD::OPC_FilterValue, 0, 155, 2, 0, // Skip to: 675
/* 8 */       MCD::OPC_ExtractField, 22, 3,  // Inst{24-22} ...
/* 11 */      MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 27
/* 16 */      MCD::OPC_CheckField, 25, 5, 0, 30, 31, 0, // Skip to: 7989
/* 23 */      MCD::OPC_Decode, 239, 4, 0, // Opcode: UNIMP
/* 27 */      MCD::OPC_FilterValue, 1, 127, 0, 0, // Skip to: 159
/* 32 */      MCD::OPC_ExtractField, 19, 3,  // Inst{21-19} ...
/* 35 */      MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 71
/* 40 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 43 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 57
/* 48 */      MCD::OPC_CheckPredicate, 0, 0, 31, 0, // Skip to: 7989
/* 53 */      MCD::OPC_Decode, 191, 1, 1, // Opcode: BPICCNT
/* 57 */      MCD::OPC_FilterValue, 1, 247, 30, 0, // Skip to: 7989
/* 62 */      MCD::OPC_CheckPredicate, 0, 242, 30, 0, // Skip to: 7989
/* 67 */      MCD::OPC_Decode, 190, 1, 1, // Opcode: BPICCANT
/* 71 */      MCD::OPC_FilterValue, 1, 31, 0, 0, // Skip to: 107
/* 76 */      MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 79 */      MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 93
/* 84 */      MCD::OPC_CheckPredicate, 0, 220, 30, 0, // Skip to: 7989
/* 89 */      MCD::OPC_Decode, 188, 1, 1, // Opcode: BPICC
/* 93 */      MCD::OPC_FilterValue, 1, 211, 30, 0, // Skip to: 7989
/* 98 */      MCD::OPC_CheckPredicate, 0, 206, 30, 0, // Skip to: 7989
/* 103 */     MCD::OPC_Decode, 189, 1, 1, // Opcode: BPICCA
/* 107 */     MCD::OPC_FilterValue, 4, 21, 0, 0, // Skip to: 133
/* 112 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 115 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 124
/* 120 */     MCD::OPC_Decode, 207, 1, 1, // Opcode: BPXCCNT
/* 124 */     MCD::OPC_FilterValue, 1, 180, 30, 0, // Skip to: 7989
/* 129 */     MCD::OPC_Decode, 206, 1, 1, // Opcode: BPXCCANT
/* 133 */     MCD::OPC_FilterValue, 5, 171, 30, 0, // Skip to: 7989
/* 138 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 141 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 150
/* 146 */     MCD::OPC_Decode, 204, 1, 1, // Opcode: BPXCC
/* 150 */     MCD::OPC_FilterValue, 1, 154, 30, 0, // Skip to: 7989
/* 155 */     MCD::OPC_Decode, 205, 1, 1, // Opcode: BPXCCA
/* 159 */     MCD::OPC_FilterValue, 2, 32, 0, 0, // Skip to: 196
/* 164 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 167 */     MCD::OPC_FilterValue, 0, 15, 0, 0, // Skip to: 187
/* 172 */     MCD::OPC_CheckField, 25, 4, 8, 4, 0, 0, // Skip to: 183
/* 179 */     MCD::OPC_Decode, 170, 1, 0, // Opcode: BA
/* 183 */     MCD::OPC_Decode, 171, 1, 2, // Opcode: BCOND
/* 187 */     MCD::OPC_FilterValue, 1, 117, 30, 0, // Skip to: 7989
/* 192 */     MCD::OPC_Decode, 172, 1, 2, // Opcode: BCONDA
/* 196 */     MCD::OPC_FilterValue, 3, 59, 1, 0, // Skip to: 516
/* 201 */     MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 204 */     MCD::OPC_FilterValue, 1, 21, 0, 0, // Skip to: 230
/* 209 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 212 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 221
/* 217 */     MCD::OPC_Decode, 210, 1, 3, // Opcode: BPZnapn
/* 221 */     MCD::OPC_FilterValue, 1, 83, 30, 0, // Skip to: 7989
/* 226 */     MCD::OPC_Decode, 211, 1, 3, // Opcode: BPZnapt
/* 230 */     MCD::OPC_FilterValue, 2, 21, 0, 0, // Skip to: 256
/* 235 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 238 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 247
/* 243 */     MCD::OPC_Decode, 194, 1, 3, // Opcode: BPLEZnapn
/* 247 */     MCD::OPC_FilterValue, 1, 57, 30, 0, // Skip to: 7989
/* 252 */     MCD::OPC_Decode, 195, 1, 3, // Opcode: BPLEZnapt
/* 256 */     MCD::OPC_FilterValue, 3, 21, 0, 0, // Skip to: 282
/* 261 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 264 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 273
/* 269 */     MCD::OPC_Decode, 198, 1, 3, // Opcode: BPLZnapn
/* 273 */     MCD::OPC_FilterValue, 1, 31, 30, 0, // Skip to: 7989
/* 278 */     MCD::OPC_Decode, 199, 1, 3, // Opcode: BPLZnapt
/* 282 */     MCD::OPC_FilterValue, 5, 21, 0, 0, // Skip to: 308
/* 287 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 290 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 299
/* 295 */     MCD::OPC_Decode, 202, 1, 3, // Opcode: BPNZnapn
/* 299 */     MCD::OPC_FilterValue, 1, 5, 30, 0, // Skip to: 7989
/* 304 */     MCD::OPC_Decode, 203, 1, 3, // Opcode: BPNZnapt
/* 308 */     MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 334
/* 313 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 316 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 325
/* 321 */     MCD::OPC_Decode, 186, 1, 3, // Opcode: BPGZnapn
/* 325 */     MCD::OPC_FilterValue, 1, 235, 29, 0, // Skip to: 7989
/* 330 */     MCD::OPC_Decode, 187, 1, 3, // Opcode: BPGZnapt
/* 334 */     MCD::OPC_FilterValue, 7, 21, 0, 0, // Skip to: 360
/* 339 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 342 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 351
/* 347 */     MCD::OPC_Decode, 182, 1, 3, // Opcode: BPGEZnapn
/* 351 */     MCD::OPC_FilterValue, 1, 209, 29, 0, // Skip to: 7989
/* 356 */     MCD::OPC_Decode, 183, 1, 3, // Opcode: BPGEZnapt
/* 360 */     MCD::OPC_FilterValue, 17, 21, 0, 0, // Skip to: 386
/* 365 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 368 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 377
/* 373 */     MCD::OPC_Decode, 208, 1, 3, // Opcode: BPZapn
/* 377 */     MCD::OPC_FilterValue, 1, 183, 29, 0, // Skip to: 7989
/* 382 */     MCD::OPC_Decode, 209, 1, 3, // Opcode: BPZapt
/* 386 */     MCD::OPC_FilterValue, 18, 21, 0, 0, // Skip to: 412
/* 391 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 394 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 403
/* 399 */     MCD::OPC_Decode, 192, 1, 3, // Opcode: BPLEZapn
/* 403 */     MCD::OPC_FilterValue, 1, 157, 29, 0, // Skip to: 7989
/* 408 */     MCD::OPC_Decode, 193, 1, 3, // Opcode: BPLEZapt
/* 412 */     MCD::OPC_FilterValue, 19, 21, 0, 0, // Skip to: 438
/* 417 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 420 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 429
/* 425 */     MCD::OPC_Decode, 196, 1, 3, // Opcode: BPLZapn
/* 429 */     MCD::OPC_FilterValue, 1, 131, 29, 0, // Skip to: 7989
/* 434 */     MCD::OPC_Decode, 197, 1, 3, // Opcode: BPLZapt
/* 438 */     MCD::OPC_FilterValue, 21, 21, 0, 0, // Skip to: 464
/* 443 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 446 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 455
/* 451 */     MCD::OPC_Decode, 200, 1, 3, // Opcode: BPNZapn
/* 455 */     MCD::OPC_FilterValue, 1, 105, 29, 0, // Skip to: 7989
/* 460 */     MCD::OPC_Decode, 201, 1, 3, // Opcode: BPNZapt
/* 464 */     MCD::OPC_FilterValue, 22, 21, 0, 0, // Skip to: 490
/* 469 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 472 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 481
/* 477 */     MCD::OPC_Decode, 184, 1, 3, // Opcode: BPGZapn
/* 481 */     MCD::OPC_FilterValue, 1, 79, 29, 0, // Skip to: 7989
/* 486 */     MCD::OPC_Decode, 185, 1, 3, // Opcode: BPGZapt
/* 490 */     MCD::OPC_FilterValue, 23, 70, 29, 0, // Skip to: 7989
/* 495 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 498 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 507
/* 503 */     MCD::OPC_Decode, 180, 1, 3, // Opcode: BPGEZapn
/* 507 */     MCD::OPC_FilterValue, 1, 53, 29, 0, // Skip to: 7989
/* 512 */     MCD::OPC_Decode, 181, 1, 3, // Opcode: BPGEZapt
/* 516 */     MCD::OPC_FilterValue, 4, 22, 0, 0, // Skip to: 543
/* 521 */     MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 539
/* 528 */     MCD::OPC_CheckField, 0, 22, 0, 4, 0, 0, // Skip to: 539
/* 535 */     MCD::OPC_Decode, 225, 3, 4, // Opcode: NOP
/* 539 */     MCD::OPC_Decode, 132, 4, 5, // Opcode: SETHIi
/* 543 */     MCD::OPC_FilterValue, 5, 75, 0, 0, // Skip to: 623
/* 548 */     MCD::OPC_ExtractField, 19, 1,  // Inst{19} ...
/* 551 */     MCD::OPC_FilterValue, 0, 31, 0, 0, // Skip to: 587
/* 556 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 559 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 573
/* 564 */     MCD::OPC_CheckPredicate, 0, 252, 28, 0, // Skip to: 7989
/* 569 */     MCD::OPC_Decode, 179, 1, 6, // Opcode: BPFCCNT
/* 573 */     MCD::OPC_FilterValue, 1, 243, 28, 0, // Skip to: 7989
/* 578 */     MCD::OPC_CheckPredicate, 0, 238, 28, 0, // Skip to: 7989
/* 583 */     MCD::OPC_Decode, 178, 1, 6, // Opcode: BPFCCANT
/* 587 */     MCD::OPC_FilterValue, 1, 229, 28, 0, // Skip to: 7989
/* 592 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 595 */     MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 609
/* 600 */     MCD::OPC_CheckPredicate, 0, 216, 28, 0, // Skip to: 7989
/* 605 */     MCD::OPC_Decode, 176, 1, 6, // Opcode: BPFCC
/* 609 */     MCD::OPC_FilterValue, 1, 207, 28, 0, // Skip to: 7989
/* 614 */     MCD::OPC_CheckPredicate, 0, 202, 28, 0, // Skip to: 7989
/* 619 */     MCD::OPC_Decode, 177, 1, 6, // Opcode: BPFCCA
/* 623 */     MCD::OPC_FilterValue, 6, 21, 0, 0, // Skip to: 649
/* 628 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 631 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 640
/* 636 */     MCD::OPC_Decode, 252, 1, 2, // Opcode: FBCOND
/* 640 */     MCD::OPC_FilterValue, 1, 176, 28, 0, // Skip to: 7989
/* 645 */     MCD::OPC_Decode, 253, 1, 2, // Opcode: FBCONDA
/* 649 */     MCD::OPC_FilterValue, 7, 167, 28, 0, // Skip to: 7989
/* 654 */     MCD::OPC_ExtractField, 29, 1,  // Inst{29} ...
/* 657 */     MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 666
/* 662 */     MCD::OPC_Decode, 220, 1, 2, // Opcode: CBCOND
/* 666 */     MCD::OPC_FilterValue, 1, 150, 28, 0, // Skip to: 7989
/* 671 */     MCD::OPC_Decode, 221, 1, 2, // Opcode: CBCONDA
/* 675 */     MCD::OPC_FilterValue, 1, 4, 0, 0, // Skip to: 684
/* 680 */     MCD::OPC_Decode, 213, 1, 7, // Opcode: CALL
/* 684 */     MCD::OPC_FilterValue, 2, 164, 22, 0, // Skip to: 6485
/* 689 */     MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 692 */     MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 725
/* 697 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 700 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 716
/* 705 */     MCD::OPC_CheckField, 5, 8, 0, 109, 28, 0, // Skip to: 7989
/* 712 */     MCD::OPC_Decode, 153, 1, 8, // Opcode: ADDrr
/* 716 */     MCD::OPC_FilterValue, 1, 100, 28, 0, // Skip to: 7989
/* 721 */     MCD::OPC_Decode, 152, 1, 9, // Opcode: ADDri
/* 725 */     MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 758
/* 730 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 733 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 749
/* 738 */     MCD::OPC_CheckField, 5, 8, 0, 76, 28, 0, // Skip to: 7989
/* 745 */     MCD::OPC_Decode, 166, 1, 8, // Opcode: ANDrr
/* 749 */     MCD::OPC_FilterValue, 1, 67, 28, 0, // Skip to: 7989
/* 754 */     MCD::OPC_Decode, 165, 1, 9, // Opcode: ANDri
/* 758 */     MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 791
/* 763 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 766 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 782
/* 771 */     MCD::OPC_CheckField, 5, 8, 0, 43, 28, 0, // Skip to: 7989
/* 778 */     MCD::OPC_Decode, 236, 3, 8, // Opcode: ORrr
/* 782 */     MCD::OPC_FilterValue, 1, 34, 28, 0, // Skip to: 7989
/* 787 */     MCD::OPC_Decode, 235, 3, 9, // Opcode: ORri
/* 791 */     MCD::OPC_FilterValue, 3, 28, 0, 0, // Skip to: 824
/* 796 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 799 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 815
/* 804 */     MCD::OPC_CheckField, 5, 8, 0, 10, 28, 0, // Skip to: 7989
/* 811 */     MCD::OPC_Decode, 145, 5, 8, // Opcode: XORrr
/* 815 */     MCD::OPC_FilterValue, 1, 1, 28, 0, // Skip to: 7989
/* 820 */     MCD::OPC_Decode, 144, 5, 9, // Opcode: XORri
/* 824 */     MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 857
/* 829 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 832 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 848
/* 837 */     MCD::OPC_CheckField, 5, 8, 0, 233, 27, 0, // Skip to: 7989
/* 844 */     MCD::OPC_Decode, 200, 4, 8, // Opcode: SUBrr
/* 848 */     MCD::OPC_FilterValue, 1, 224, 27, 0, // Skip to: 7989
/* 853 */     MCD::OPC_Decode, 199, 4, 9, // Opcode: SUBri
/* 857 */     MCD::OPC_FilterValue, 5, 28, 0, 0, // Skip to: 890
/* 862 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 865 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 881
/* 870 */     MCD::OPC_CheckField, 5, 8, 0, 200, 27, 0, // Skip to: 7989
/* 877 */     MCD::OPC_Decode, 161, 1, 8, // Opcode: ANDNrr
/* 881 */     MCD::OPC_FilterValue, 1, 191, 27, 0, // Skip to: 7989
/* 886 */     MCD::OPC_Decode, 160, 1, 9, // Opcode: ANDNri
/* 890 */     MCD::OPC_FilterValue, 6, 28, 0, 0, // Skip to: 923
/* 895 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 898 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 914
/* 903 */     MCD::OPC_CheckField, 5, 8, 0, 167, 27, 0, // Skip to: 7989
/* 910 */     MCD::OPC_Decode, 231, 3, 8, // Opcode: ORNrr
/* 914 */     MCD::OPC_FilterValue, 1, 158, 27, 0, // Skip to: 7989
/* 919 */     MCD::OPC_Decode, 230, 3, 9, // Opcode: ORNri
/* 923 */     MCD::OPC_FilterValue, 7, 28, 0, 0, // Skip to: 956
/* 928 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 931 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 947
/* 936 */     MCD::OPC_CheckField, 5, 8, 0, 134, 27, 0, // Skip to: 7989
/* 943 */     MCD::OPC_Decode, 139, 5, 8, // Opcode: XNORrr
/* 947 */     MCD::OPC_FilterValue, 1, 125, 27, 0, // Skip to: 7989
/* 952 */     MCD::OPC_Decode, 138, 5, 9, // Opcode: XNORri
/* 956 */     MCD::OPC_FilterValue, 8, 28, 0, 0, // Skip to: 989
/* 961 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 964 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 980
/* 969 */     MCD::OPC_CheckField, 5, 8, 0, 101, 27, 0, // Skip to: 7989
/* 976 */     MCD::OPC_Decode, 145, 1, 8, // Opcode: ADDCrr
/* 980 */     MCD::OPC_FilterValue, 1, 92, 27, 0, // Skip to: 7989
/* 985 */     MCD::OPC_Decode, 144, 1, 9, // Opcode: ADDCri
/* 989 */     MCD::OPC_FilterValue, 9, 28, 0, 0, // Skip to: 1022
/* 994 */     MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 997 */     MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1013
/* 1002 */    MCD::OPC_CheckField, 5, 8, 0, 68, 27, 0, // Skip to: 7989
/* 1009 */    MCD::OPC_Decode, 224, 3, 10, // Opcode: MULXrr
/* 1013 */    MCD::OPC_FilterValue, 1, 59, 27, 0, // Skip to: 7989
/* 1018 */    MCD::OPC_Decode, 223, 3, 11, // Opcode: MULXri
/* 1022 */    MCD::OPC_FilterValue, 10, 28, 0, 0, // Skip to: 1055
/* 1027 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1030 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1046
/* 1035 */    MCD::OPC_CheckField, 5, 8, 0, 35, 27, 0, // Skip to: 7989
/* 1042 */    MCD::OPC_Decode, 238, 4, 8, // Opcode: UMULrr
/* 1046 */    MCD::OPC_FilterValue, 1, 26, 27, 0, // Skip to: 7989
/* 1051 */    MCD::OPC_Decode, 237, 4, 9, // Opcode: UMULri
/* 1055 */    MCD::OPC_FilterValue, 11, 28, 0, 0, // Skip to: 1088
/* 1060 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1063 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1079
/* 1068 */    MCD::OPC_CheckField, 5, 8, 0, 2, 27, 0, // Skip to: 7989
/* 1075 */    MCD::OPC_Decode, 144, 4, 8, // Opcode: SMULrr
/* 1079 */    MCD::OPC_FilterValue, 1, 249, 26, 0, // Skip to: 7989
/* 1084 */    MCD::OPC_Decode, 143, 4, 9, // Opcode: SMULri
/* 1088 */    MCD::OPC_FilterValue, 12, 28, 0, 0, // Skip to: 1121
/* 1093 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1096 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1112
/* 1101 */    MCD::OPC_CheckField, 5, 8, 0, 225, 26, 0, // Skip to: 7989
/* 1108 */    MCD::OPC_Decode, 194, 4, 8, // Opcode: SUBCrr
/* 1112 */    MCD::OPC_FilterValue, 1, 216, 26, 0, // Skip to: 7989
/* 1117 */    MCD::OPC_Decode, 193, 4, 9, // Opcode: SUBCri
/* 1121 */    MCD::OPC_FilterValue, 13, 28, 0, 0, // Skip to: 1154
/* 1126 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1129 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1145
/* 1134 */    MCD::OPC_CheckField, 5, 8, 0, 192, 26, 0, // Skip to: 7989
/* 1141 */    MCD::OPC_Decode, 229, 4, 10, // Opcode: UDIVXrr
/* 1145 */    MCD::OPC_FilterValue, 1, 183, 26, 0, // Skip to: 7989
/* 1150 */    MCD::OPC_Decode, 228, 4, 11, // Opcode: UDIVXri
/* 1154 */    MCD::OPC_FilterValue, 14, 28, 0, 0, // Skip to: 1187
/* 1159 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1162 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1178
/* 1167 */    MCD::OPC_CheckField, 5, 8, 0, 159, 26, 0, // Skip to: 7989
/* 1174 */    MCD::OPC_Decode, 231, 4, 8, // Opcode: UDIVrr
/* 1178 */    MCD::OPC_FilterValue, 1, 150, 26, 0, // Skip to: 7989
/* 1183 */    MCD::OPC_Decode, 230, 4, 9, // Opcode: UDIVri
/* 1187 */    MCD::OPC_FilterValue, 15, 28, 0, 0, // Skip to: 1220
/* 1192 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1195 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1211
/* 1200 */    MCD::OPC_CheckField, 5, 8, 0, 126, 26, 0, // Skip to: 7989
/* 1207 */    MCD::OPC_Decode, 130, 4, 8, // Opcode: SDIVrr
/* 1211 */    MCD::OPC_FilterValue, 1, 117, 26, 0, // Skip to: 7989
/* 1216 */    MCD::OPC_Decode, 129, 4, 9, // Opcode: SDIVri
/* 1220 */    MCD::OPC_FilterValue, 16, 28, 0, 0, // Skip to: 1253
/* 1225 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1228 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1244
/* 1233 */    MCD::OPC_CheckField, 5, 8, 0, 93, 26, 0, // Skip to: 7989
/* 1240 */    MCD::OPC_Decode, 143, 1, 8, // Opcode: ADDCCrr
/* 1244 */    MCD::OPC_FilterValue, 1, 84, 26, 0, // Skip to: 7989
/* 1249 */    MCD::OPC_Decode, 142, 1, 9, // Opcode: ADDCCri
/* 1253 */    MCD::OPC_FilterValue, 17, 28, 0, 0, // Skip to: 1286
/* 1258 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1261 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1277
/* 1266 */    MCD::OPC_CheckField, 5, 8, 0, 60, 26, 0, // Skip to: 7989
/* 1273 */    MCD::OPC_Decode, 157, 1, 8, // Opcode: ANDCCrr
/* 1277 */    MCD::OPC_FilterValue, 1, 51, 26, 0, // Skip to: 7989
/* 1282 */    MCD::OPC_Decode, 156, 1, 9, // Opcode: ANDCCri
/* 1286 */    MCD::OPC_FilterValue, 18, 28, 0, 0, // Skip to: 1319
/* 1291 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1294 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1310
/* 1299 */    MCD::OPC_CheckField, 5, 8, 0, 27, 26, 0, // Skip to: 7989
/* 1306 */    MCD::OPC_Decode, 227, 3, 8, // Opcode: ORCCrr
/* 1310 */    MCD::OPC_FilterValue, 1, 18, 26, 0, // Skip to: 7989
/* 1315 */    MCD::OPC_Decode, 226, 3, 9, // Opcode: ORCCri
/* 1319 */    MCD::OPC_FilterValue, 19, 28, 0, 0, // Skip to: 1352
/* 1324 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1327 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1343
/* 1332 */    MCD::OPC_CheckField, 5, 8, 0, 250, 25, 0, // Skip to: 7989
/* 1339 */    MCD::OPC_Decode, 141, 5, 8, // Opcode: XORCCrr
/* 1343 */    MCD::OPC_FilterValue, 1, 241, 25, 0, // Skip to: 7989
/* 1348 */    MCD::OPC_Decode, 140, 5, 9, // Opcode: XORCCri
/* 1352 */    MCD::OPC_FilterValue, 20, 51, 0, 0, // Skip to: 1408
/* 1357 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1360 */    MCD::OPC_FilterValue, 0, 23, 0, 0, // Skip to: 1388
/* 1365 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 1368 */    MCD::OPC_FilterValue, 0, 216, 25, 0, // Skip to: 7989
/* 1373 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1384
/* 1380 */    MCD::OPC_Decode, 226, 1, 12, // Opcode: CMPrr
/* 1384 */    MCD::OPC_Decode, 192, 4, 8, // Opcode: SUBCCrr
/* 1388 */    MCD::OPC_FilterValue, 1, 196, 25, 0, // Skip to: 7989
/* 1393 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 1404
/* 1400 */    MCD::OPC_Decode, 225, 1, 13, // Opcode: CMPri
/* 1404 */    MCD::OPC_Decode, 191, 4, 9, // Opcode: SUBCCri
/* 1408 */    MCD::OPC_FilterValue, 21, 28, 0, 0, // Skip to: 1441
/* 1413 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1416 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1432
/* 1421 */    MCD::OPC_CheckField, 5, 8, 0, 161, 25, 0, // Skip to: 7989
/* 1428 */    MCD::OPC_Decode, 159, 1, 8, // Opcode: ANDNCCrr
/* 1432 */    MCD::OPC_FilterValue, 1, 152, 25, 0, // Skip to: 7989
/* 1437 */    MCD::OPC_Decode, 158, 1, 9, // Opcode: ANDNCCri
/* 1441 */    MCD::OPC_FilterValue, 22, 28, 0, 0, // Skip to: 1474
/* 1446 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1449 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1465
/* 1454 */    MCD::OPC_CheckField, 5, 8, 0, 128, 25, 0, // Skip to: 7989
/* 1461 */    MCD::OPC_Decode, 229, 3, 8, // Opcode: ORNCCrr
/* 1465 */    MCD::OPC_FilterValue, 1, 119, 25, 0, // Skip to: 7989
/* 1470 */    MCD::OPC_Decode, 228, 3, 9, // Opcode: ORNCCri
/* 1474 */    MCD::OPC_FilterValue, 23, 28, 0, 0, // Skip to: 1507
/* 1479 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1482 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1498
/* 1487 */    MCD::OPC_CheckField, 5, 8, 0, 95, 25, 0, // Skip to: 7989
/* 1494 */    MCD::OPC_Decode, 136, 5, 8, // Opcode: XNORCCrr
/* 1498 */    MCD::OPC_FilterValue, 1, 86, 25, 0, // Skip to: 7989
/* 1503 */    MCD::OPC_Decode, 135, 5, 9, // Opcode: XNORCCri
/* 1507 */    MCD::OPC_FilterValue, 24, 28, 0, 0, // Skip to: 1540
/* 1512 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1515 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1531
/* 1520 */    MCD::OPC_CheckField, 5, 8, 0, 62, 25, 0, // Skip to: 7989
/* 1527 */    MCD::OPC_Decode, 147, 1, 8, // Opcode: ADDErr
/* 1531 */    MCD::OPC_FilterValue, 1, 53, 25, 0, // Skip to: 7989
/* 1536 */    MCD::OPC_Decode, 146, 1, 9, // Opcode: ADDEri
/* 1540 */    MCD::OPC_FilterValue, 26, 28, 0, 0, // Skip to: 1573
/* 1545 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1548 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1564
/* 1553 */    MCD::OPC_CheckField, 5, 8, 0, 29, 25, 0, // Skip to: 7989
/* 1560 */    MCD::OPC_Decode, 235, 4, 8, // Opcode: UMULCCrr
/* 1564 */    MCD::OPC_FilterValue, 1, 20, 25, 0, // Skip to: 7989
/* 1569 */    MCD::OPC_Decode, 234, 4, 9, // Opcode: UMULCCri
/* 1573 */    MCD::OPC_FilterValue, 27, 28, 0, 0, // Skip to: 1606
/* 1578 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1581 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1597
/* 1586 */    MCD::OPC_CheckField, 5, 8, 0, 252, 24, 0, // Skip to: 7989
/* 1593 */    MCD::OPC_Decode, 142, 4, 8, // Opcode: SMULCCrr
/* 1597 */    MCD::OPC_FilterValue, 1, 243, 24, 0, // Skip to: 7989
/* 1602 */    MCD::OPC_Decode, 141, 4, 9, // Opcode: SMULCCri
/* 1606 */    MCD::OPC_FilterValue, 28, 28, 0, 0, // Skip to: 1639
/* 1611 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1614 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1630
/* 1619 */    MCD::OPC_CheckField, 5, 8, 0, 219, 24, 0, // Skip to: 7989
/* 1626 */    MCD::OPC_Decode, 196, 4, 8, // Opcode: SUBErr
/* 1630 */    MCD::OPC_FilterValue, 1, 210, 24, 0, // Skip to: 7989
/* 1635 */    MCD::OPC_Decode, 195, 4, 9, // Opcode: SUBEri
/* 1639 */    MCD::OPC_FilterValue, 30, 28, 0, 0, // Skip to: 1672
/* 1644 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1647 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1663
/* 1652 */    MCD::OPC_CheckField, 5, 8, 0, 186, 24, 0, // Skip to: 7989
/* 1659 */    MCD::OPC_Decode, 227, 4, 8, // Opcode: UDIVCCrr
/* 1663 */    MCD::OPC_FilterValue, 1, 177, 24, 0, // Skip to: 7989
/* 1668 */    MCD::OPC_Decode, 226, 4, 9, // Opcode: UDIVCCri
/* 1672 */    MCD::OPC_FilterValue, 31, 28, 0, 0, // Skip to: 1705
/* 1677 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1680 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1696
/* 1685 */    MCD::OPC_CheckField, 5, 8, 0, 153, 24, 0, // Skip to: 7989
/* 1692 */    MCD::OPC_Decode, 254, 3, 8, // Opcode: SDIVCCrr
/* 1696 */    MCD::OPC_FilterValue, 1, 144, 24, 0, // Skip to: 7989
/* 1701 */    MCD::OPC_Decode, 253, 3, 9, // Opcode: SDIVCCri
/* 1705 */    MCD::OPC_FilterValue, 32, 28, 0, 0, // Skip to: 1738
/* 1710 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1713 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1729
/* 1718 */    MCD::OPC_CheckField, 5, 8, 0, 120, 24, 0, // Skip to: 7989
/* 1725 */    MCD::OPC_Decode, 210, 4, 8, // Opcode: TADDCCrr
/* 1729 */    MCD::OPC_FilterValue, 1, 111, 24, 0, // Skip to: 7989
/* 1734 */    MCD::OPC_Decode, 209, 4, 9, // Opcode: TADDCCri
/* 1738 */    MCD::OPC_FilterValue, 33, 28, 0, 0, // Skip to: 1771
/* 1743 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1746 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1762
/* 1751 */    MCD::OPC_CheckField, 5, 8, 0, 87, 24, 0, // Skip to: 7989
/* 1758 */    MCD::OPC_Decode, 223, 4, 8, // Opcode: TSUBCCrr
/* 1762 */    MCD::OPC_FilterValue, 1, 78, 24, 0, // Skip to: 7989
/* 1767 */    MCD::OPC_Decode, 222, 4, 9, // Opcode: TSUBCCri
/* 1771 */    MCD::OPC_FilterValue, 34, 28, 0, 0, // Skip to: 1804
/* 1776 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1779 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1795
/* 1784 */    MCD::OPC_CheckField, 5, 8, 0, 54, 24, 0, // Skip to: 7989
/* 1791 */    MCD::OPC_Decode, 208, 4, 8, // Opcode: TADDCCTVrr
/* 1795 */    MCD::OPC_FilterValue, 1, 45, 24, 0, // Skip to: 7989
/* 1800 */    MCD::OPC_Decode, 207, 4, 9, // Opcode: TADDCCTVri
/* 1804 */    MCD::OPC_FilterValue, 35, 28, 0, 0, // Skip to: 1837
/* 1809 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1812 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1828
/* 1817 */    MCD::OPC_CheckField, 5, 8, 0, 21, 24, 0, // Skip to: 7989
/* 1824 */    MCD::OPC_Decode, 221, 4, 8, // Opcode: TSUBCCTVrr
/* 1828 */    MCD::OPC_FilterValue, 1, 12, 24, 0, // Skip to: 7989
/* 1833 */    MCD::OPC_Decode, 220, 4, 9, // Opcode: TSUBCCTVri
/* 1837 */    MCD::OPC_FilterValue, 36, 28, 0, 0, // Skip to: 1870
/* 1842 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1845 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1861
/* 1850 */    MCD::OPC_CheckField, 5, 8, 0, 244, 23, 0, // Skip to: 7989
/* 1857 */    MCD::OPC_Decode, 222, 3, 8, // Opcode: MULSCCrr
/* 1861 */    MCD::OPC_FilterValue, 1, 235, 23, 0, // Skip to: 7989
/* 1866 */    MCD::OPC_Decode, 221, 3, 9, // Opcode: MULSCCri
/* 1870 */    MCD::OPC_FilterValue, 37, 56, 0, 0, // Skip to: 1931
/* 1875 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1878 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 1911
/* 1883 */    MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 1886 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1902
/* 1891 */    MCD::OPC_CheckField, 5, 7, 0, 203, 23, 0, // Skip to: 7989
/* 1898 */    MCD::OPC_Decode, 138, 4, 8, // Opcode: SLLrr
/* 1902 */    MCD::OPC_FilterValue, 1, 194, 23, 0, // Skip to: 7989
/* 1907 */    MCD::OPC_Decode, 136, 4, 14, // Opcode: SLLXrr
/* 1911 */    MCD::OPC_FilterValue, 1, 185, 23, 0, // Skip to: 7989
/* 1916 */    MCD::OPC_CheckField, 12, 1, 1, 4, 0, 0, // Skip to: 1927
/* 1923 */    MCD::OPC_Decode, 135, 4, 15, // Opcode: SLLXri
/* 1927 */    MCD::OPC_Decode, 137, 4, 9, // Opcode: SLLri
/* 1931 */    MCD::OPC_FilterValue, 38, 56, 0, 0, // Skip to: 1992
/* 1936 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 1939 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 1972
/* 1944 */    MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 1947 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 1963
/* 1952 */    MCD::OPC_CheckField, 5, 7, 0, 142, 23, 0, // Skip to: 7989
/* 1959 */    MCD::OPC_Decode, 152, 4, 8, // Opcode: SRLrr
/* 1963 */    MCD::OPC_FilterValue, 1, 133, 23, 0, // Skip to: 7989
/* 1968 */    MCD::OPC_Decode, 150, 4, 14, // Opcode: SRLXrr
/* 1972 */    MCD::OPC_FilterValue, 1, 124, 23, 0, // Skip to: 7989
/* 1977 */    MCD::OPC_CheckField, 12, 1, 1, 4, 0, 0, // Skip to: 1988
/* 1984 */    MCD::OPC_Decode, 149, 4, 15, // Opcode: SRLXri
/* 1988 */    MCD::OPC_Decode, 151, 4, 9, // Opcode: SRLri
/* 1992 */    MCD::OPC_FilterValue, 39, 56, 0, 0, // Skip to: 2053
/* 1997 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2000 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 2033
/* 2005 */    MCD::OPC_ExtractField, 12, 1,  // Inst{12} ...
/* 2008 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2024
/* 2013 */    MCD::OPC_CheckField, 5, 7, 0, 81, 23, 0, // Skip to: 7989
/* 2020 */    MCD::OPC_Decode, 148, 4, 8, // Opcode: SRArr
/* 2024 */    MCD::OPC_FilterValue, 1, 72, 23, 0, // Skip to: 7989
/* 2029 */    MCD::OPC_Decode, 146, 4, 14, // Opcode: SRAXrr
/* 2033 */    MCD::OPC_FilterValue, 1, 63, 23, 0, // Skip to: 7989
/* 2038 */    MCD::OPC_CheckField, 12, 1, 1, 4, 0, 0, // Skip to: 2049
/* 2045 */    MCD::OPC_Decode, 145, 4, 15, // Opcode: SRAXri
/* 2049 */    MCD::OPC_Decode, 147, 4, 9, // Opcode: SRAri
/* 2053 */    MCD::OPC_FilterValue, 40, 66, 0, 0, // Skip to: 2124
/* 2058 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2061 */    MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 2096
/* 2066 */    MCD::OPC_ExtractField, 0, 13,  // Inst{12-0} ...
/* 2069 */    MCD::OPC_FilterValue, 0, 27, 23, 0, // Skip to: 7989
/* 2074 */    MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 2092
/* 2081 */    MCD::OPC_CheckField, 14, 5, 15, 4, 0, 0, // Skip to: 2092
/* 2088 */    MCD::OPC_Decode, 154, 4, 4, // Opcode: STBAR
/* 2092 */    MCD::OPC_Decode, 240, 3, 16, // Opcode: RDASR
/* 2096 */    MCD::OPC_FilterValue, 1, 0, 23, 0, // Skip to: 7989
/* 2101 */    MCD::OPC_CheckPredicate, 0, 251, 22, 0, // Skip to: 7989
/* 2106 */    MCD::OPC_CheckField, 25, 5, 0, 244, 22, 0, // Skip to: 7989
/* 2113 */    MCD::OPC_CheckField, 14, 5, 15, 237, 22, 0, // Skip to: 7989
/* 2120 */    MCD::OPC_Decode, 197, 3, 17, // Opcode: MEMBARi
/* 2124 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 2140
/* 2129 */    MCD::OPC_CheckField, 0, 19, 0, 221, 22, 0, // Skip to: 7989
/* 2136 */    MCD::OPC_Decode, 242, 3, 18, // Opcode: RDPSR
/* 2140 */    MCD::OPC_FilterValue, 42, 28, 0, 0, // Skip to: 2173
/* 2145 */    MCD::OPC_ExtractField, 0, 14,  // Inst{13-0} ...
/* 2148 */    MCD::OPC_FilterValue, 0, 204, 22, 0, // Skip to: 7989
/* 2153 */    MCD::OPC_CheckField, 14, 5, 0, 4, 0, 0, // Skip to: 2164
/* 2160 */    MCD::OPC_Decode, 244, 3, 18, // Opcode: RDWIM
/* 2164 */    MCD::OPC_CheckPredicate, 0, 188, 22, 0, // Skip to: 7989
/* 2169 */    MCD::OPC_Decode, 241, 3, 19, // Opcode: RDPR
/* 2173 */    MCD::OPC_FilterValue, 43, 28, 0, 0, // Skip to: 2206
/* 2178 */    MCD::OPC_ExtractField, 0, 19,  // Inst{18-0} ...
/* 2181 */    MCD::OPC_FilterValue, 0, 171, 22, 0, // Skip to: 7989
/* 2186 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2202
/* 2191 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2202
/* 2198 */    MCD::OPC_Decode, 157, 2, 4, // Opcode: FLUSHW
/* 2202 */    MCD::OPC_Decode, 243, 3, 18, // Opcode: RDTBR
/* 2206 */    MCD::OPC_FilterValue, 44, 141, 0, 0, // Skip to: 2352
/* 2211 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2214 */    MCD::OPC_FilterValue, 0, 64, 0, 0, // Skip to: 2283
/* 2219 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2222 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2252
/* 2227 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2243
/* 2232 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 2243
/* 2239 */    MCD::OPC_Decode, 200, 3, 20, // Opcode: MOVFCCrr
/* 2243 */    MCD::OPC_CheckPredicate, 0, 109, 22, 0, // Skip to: 7989
/* 2248 */    MCD::OPC_Decode, 250, 4, 21, // Opcode: V9MOVFCCrr
/* 2252 */    MCD::OPC_FilterValue, 1, 100, 22, 0, // Skip to: 7989
/* 2257 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 2260 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2274
/* 2265 */    MCD::OPC_CheckPredicate, 0, 87, 22, 0, // Skip to: 7989
/* 2270 */    MCD::OPC_Decode, 202, 3, 20, // Opcode: MOVICCrr
/* 2274 */    MCD::OPC_FilterValue, 2, 78, 22, 0, // Skip to: 7989
/* 2279 */    MCD::OPC_Decode, 219, 3, 20, // Opcode: MOVXCCrr
/* 2283 */    MCD::OPC_FilterValue, 1, 69, 22, 0, // Skip to: 7989
/* 2288 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 2291 */    MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 2321
/* 2296 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 2312
/* 2301 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 2312
/* 2308 */    MCD::OPC_Decode, 199, 3, 22, // Opcode: MOVFCCri
/* 2312 */    MCD::OPC_CheckPredicate, 0, 40, 22, 0, // Skip to: 7989
/* 2317 */    MCD::OPC_Decode, 249, 4, 23, // Opcode: V9MOVFCCri
/* 2321 */    MCD::OPC_FilterValue, 1, 31, 22, 0, // Skip to: 7989
/* 2326 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 2329 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 2343
/* 2334 */    MCD::OPC_CheckPredicate, 0, 18, 22, 0, // Skip to: 7989
/* 2339 */    MCD::OPC_Decode, 201, 3, 22, // Opcode: MOVICCri
/* 2343 */    MCD::OPC_FilterValue, 2, 9, 22, 0, // Skip to: 7989
/* 2348 */    MCD::OPC_Decode, 218, 3, 22, // Opcode: MOVXCCri
/* 2352 */    MCD::OPC_FilterValue, 45, 28, 0, 0, // Skip to: 2385
/* 2357 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2360 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2376
/* 2365 */    MCD::OPC_CheckField, 5, 8, 0, 241, 21, 0, // Skip to: 7989
/* 2372 */    MCD::OPC_Decode, 128, 4, 10, // Opcode: SDIVXrr
/* 2376 */    MCD::OPC_FilterValue, 1, 232, 21, 0, // Skip to: 7989
/* 2381 */    MCD::OPC_Decode, 255, 3, 11, // Opcode: SDIVXri
/* 2385 */    MCD::OPC_FilterValue, 46, 16, 0, 0, // Skip to: 2406
/* 2390 */    MCD::OPC_CheckPredicate, 0, 218, 21, 0, // Skip to: 7989
/* 2395 */    MCD::OPC_CheckField, 5, 14, 0, 211, 21, 0, // Skip to: 7989
/* 2402 */    MCD::OPC_Decode, 239, 3, 24, // Opcode: POPCrr
/* 2406 */    MCD::OPC_FilterValue, 47, 153, 0, 0, // Skip to: 2564
/* 2411 */    MCD::OPC_ExtractField, 10, 4,  // Inst{13-10} ...
/* 2414 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2430
/* 2419 */    MCD::OPC_CheckField, 5, 5, 0, 187, 21, 0, // Skip to: 7989
/* 2426 */    MCD::OPC_Decode, 214, 3, 14, // Opcode: MOVRRZrr
/* 2430 */    MCD::OPC_FilterValue, 2, 11, 0, 0, // Skip to: 2446
/* 2435 */    MCD::OPC_CheckField, 5, 5, 0, 171, 21, 0, // Skip to: 7989
/* 2442 */    MCD::OPC_Decode, 208, 3, 14, // Opcode: MOVRLEZrr
/* 2446 */    MCD::OPC_FilterValue, 3, 11, 0, 0, // Skip to: 2462
/* 2451 */    MCD::OPC_CheckField, 5, 5, 0, 155, 21, 0, // Skip to: 7989
/* 2458 */    MCD::OPC_Decode, 210, 3, 14, // Opcode: MOVRLZrr
/* 2462 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2478
/* 2467 */    MCD::OPC_CheckField, 5, 5, 0, 139, 21, 0, // Skip to: 7989
/* 2474 */    MCD::OPC_Decode, 212, 3, 14, // Opcode: MOVRNZrr
/* 2478 */    MCD::OPC_FilterValue, 6, 11, 0, 0, // Skip to: 2494
/* 2483 */    MCD::OPC_CheckField, 5, 5, 0, 123, 21, 0, // Skip to: 7989
/* 2490 */    MCD::OPC_Decode, 206, 3, 14, // Opcode: MOVRGZrr
/* 2494 */    MCD::OPC_FilterValue, 7, 11, 0, 0, // Skip to: 2510
/* 2499 */    MCD::OPC_CheckField, 5, 5, 0, 107, 21, 0, // Skip to: 7989
/* 2506 */    MCD::OPC_Decode, 204, 3, 14, // Opcode: MOVRGEZrr
/* 2510 */    MCD::OPC_FilterValue, 9, 4, 0, 0, // Skip to: 2519
/* 2515 */    MCD::OPC_Decode, 213, 3, 25, // Opcode: MOVRRZri
/* 2519 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 2528
/* 2524 */    MCD::OPC_Decode, 207, 3, 25, // Opcode: MOVRLEZri
/* 2528 */    MCD::OPC_FilterValue, 11, 4, 0, 0, // Skip to: 2537
/* 2533 */    MCD::OPC_Decode, 209, 3, 25, // Opcode: MOVRLZri
/* 2537 */    MCD::OPC_FilterValue, 13, 4, 0, 0, // Skip to: 2546
/* 2542 */    MCD::OPC_Decode, 211, 3, 25, // Opcode: MOVRNZri
/* 2546 */    MCD::OPC_FilterValue, 14, 4, 0, 0, // Skip to: 2555
/* 2551 */    MCD::OPC_Decode, 205, 3, 25, // Opcode: MOVRGZri
/* 2555 */    MCD::OPC_FilterValue, 15, 53, 21, 0, // Skip to: 7989
/* 2560 */    MCD::OPC_Decode, 203, 3, 25, // Opcode: MOVRGEZri
/* 2564 */    MCD::OPC_FilterValue, 48, 28, 0, 0, // Skip to: 2597
/* 2569 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2572 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 2588
/* 2577 */    MCD::OPC_CheckField, 5, 8, 0, 29, 21, 0, // Skip to: 7989
/* 2584 */    MCD::OPC_Decode, 252, 4, 26, // Opcode: WRASRrr
/* 2588 */    MCD::OPC_FilterValue, 1, 20, 21, 0, // Skip to: 7989
/* 2593 */    MCD::OPC_Decode, 251, 4, 27, // Opcode: WRASRri
/* 2597 */    MCD::OPC_FilterValue, 49, 42, 0, 0, // Skip to: 2644
/* 2602 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2605 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 2628
/* 2610 */    MCD::OPC_CheckField, 25, 5, 0, 252, 20, 0, // Skip to: 7989
/* 2617 */    MCD::OPC_CheckField, 5, 8, 0, 245, 20, 0, // Skip to: 7989
/* 2624 */    MCD::OPC_Decode, 128, 5, 12, // Opcode: WRPSRrr
/* 2628 */    MCD::OPC_FilterValue, 1, 236, 20, 0, // Skip to: 7989
/* 2633 */    MCD::OPC_CheckField, 25, 5, 0, 229, 20, 0, // Skip to: 7989
/* 2640 */    MCD::OPC_Decode, 255, 4, 13, // Opcode: WRPSRri
/* 2644 */    MCD::OPC_FilterValue, 50, 61, 0, 0, // Skip to: 2710
/* 2649 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2652 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 2685
/* 2657 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 2660 */    MCD::OPC_FilterValue, 0, 204, 20, 0, // Skip to: 7989
/* 2665 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2676
/* 2672 */    MCD::OPC_Decode, 132, 5, 12, // Opcode: WRWIMrr
/* 2676 */    MCD::OPC_CheckPredicate, 0, 188, 20, 0, // Skip to: 7989
/* 2681 */    MCD::OPC_Decode, 254, 4, 28, // Opcode: WRPRrr
/* 2685 */    MCD::OPC_FilterValue, 1, 179, 20, 0, // Skip to: 7989
/* 2690 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 2701
/* 2697 */    MCD::OPC_Decode, 131, 5, 13, // Opcode: WRWIMri
/* 2701 */    MCD::OPC_CheckPredicate, 0, 163, 20, 0, // Skip to: 7989
/* 2706 */    MCD::OPC_Decode, 253, 4, 29, // Opcode: WRPRri
/* 2710 */    MCD::OPC_FilterValue, 51, 42, 0, 0, // Skip to: 2757
/* 2715 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 2718 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 2741
/* 2723 */    MCD::OPC_CheckField, 25, 5, 0, 139, 20, 0, // Skip to: 7989
/* 2730 */    MCD::OPC_CheckField, 5, 8, 0, 132, 20, 0, // Skip to: 7989
/* 2737 */    MCD::OPC_Decode, 130, 5, 12, // Opcode: WRTBRrr
/* 2741 */    MCD::OPC_FilterValue, 1, 123, 20, 0, // Skip to: 7989
/* 2746 */    MCD::OPC_CheckField, 25, 5, 0, 116, 20, 0, // Skip to: 7989
/* 2753 */    MCD::OPC_Decode, 129, 5, 13, // Opcode: WRTBRri
/* 2757 */    MCD::OPC_FilterValue, 52, 43, 3, 0, // Skip to: 3573
/* 2762 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 2765 */    MCD::OPC_FilterValue, 1, 11, 0, 0, // Skip to: 2781
/* 2770 */    MCD::OPC_CheckField, 14, 5, 0, 92, 20, 0, // Skip to: 7989
/* 2777 */    MCD::OPC_Decode, 187, 2, 30, // Opcode: FMOVS
/* 2781 */    MCD::OPC_FilterValue, 2, 16, 0, 0, // Skip to: 2802
/* 2786 */    MCD::OPC_CheckPredicate, 0, 78, 20, 0, // Skip to: 7989
/* 2791 */    MCD::OPC_CheckField, 14, 5, 0, 71, 20, 0, // Skip to: 7989
/* 2798 */    MCD::OPC_Decode, 161, 2, 31, // Opcode: FMOVD
/* 2802 */    MCD::OPC_FilterValue, 3, 16, 0, 0, // Skip to: 2823
/* 2807 */    MCD::OPC_CheckPredicate, 0, 57, 20, 0, // Skip to: 7989
/* 2812 */    MCD::OPC_CheckField, 14, 5, 0, 50, 20, 0, // Skip to: 7989
/* 2819 */    MCD::OPC_Decode, 165, 2, 32, // Opcode: FMOVQ
/* 2823 */    MCD::OPC_FilterValue, 5, 11, 0, 0, // Skip to: 2839
/* 2828 */    MCD::OPC_CheckField, 14, 5, 0, 34, 20, 0, // Skip to: 7989
/* 2835 */    MCD::OPC_Decode, 207, 2, 30, // Opcode: FNEGS
/* 2839 */    MCD::OPC_FilterValue, 6, 16, 0, 0, // Skip to: 2860
/* 2844 */    MCD::OPC_CheckPredicate, 0, 20, 20, 0, // Skip to: 7989
/* 2849 */    MCD::OPC_CheckField, 14, 5, 0, 13, 20, 0, // Skip to: 7989
/* 2856 */    MCD::OPC_Decode, 205, 2, 31, // Opcode: FNEGD
/* 2860 */    MCD::OPC_FilterValue, 7, 16, 0, 0, // Skip to: 2881
/* 2865 */    MCD::OPC_CheckPredicate, 0, 255, 19, 0, // Skip to: 7989
/* 2870 */    MCD::OPC_CheckField, 14, 5, 0, 248, 19, 0, // Skip to: 7989
/* 2877 */    MCD::OPC_Decode, 206, 2, 32, // Opcode: FNEGQ
/* 2881 */    MCD::OPC_FilterValue, 9, 11, 0, 0, // Skip to: 2897
/* 2886 */    MCD::OPC_CheckField, 14, 5, 0, 232, 19, 0, // Skip to: 7989
/* 2893 */    MCD::OPC_Decode, 241, 1, 30, // Opcode: FABSS
/* 2897 */    MCD::OPC_FilterValue, 10, 16, 0, 0, // Skip to: 2918
/* 2902 */    MCD::OPC_CheckPredicate, 0, 218, 19, 0, // Skip to: 7989
/* 2907 */    MCD::OPC_CheckField, 14, 5, 0, 211, 19, 0, // Skip to: 7989
/* 2914 */    MCD::OPC_Decode, 239, 1, 31, // Opcode: FABSD
/* 2918 */    MCD::OPC_FilterValue, 11, 16, 0, 0, // Skip to: 2939
/* 2923 */    MCD::OPC_CheckPredicate, 0, 197, 19, 0, // Skip to: 7989
/* 2928 */    MCD::OPC_CheckField, 14, 5, 0, 190, 19, 0, // Skip to: 7989
/* 2935 */    MCD::OPC_Decode, 240, 1, 32, // Opcode: FABSQ
/* 2939 */    MCD::OPC_FilterValue, 41, 11, 0, 0, // Skip to: 2955
/* 2944 */    MCD::OPC_CheckField, 14, 5, 0, 174, 19, 0, // Skip to: 7989
/* 2951 */    MCD::OPC_Decode, 251, 2, 30, // Opcode: FSQRTS
/* 2955 */    MCD::OPC_FilterValue, 42, 11, 0, 0, // Skip to: 2971
/* 2960 */    MCD::OPC_CheckField, 14, 5, 0, 158, 19, 0, // Skip to: 7989
/* 2967 */    MCD::OPC_Decode, 249, 2, 31, // Opcode: FSQRTD
/* 2971 */    MCD::OPC_FilterValue, 43, 11, 0, 0, // Skip to: 2987
/* 2976 */    MCD::OPC_CheckField, 14, 5, 0, 142, 19, 0, // Skip to: 7989
/* 2983 */    MCD::OPC_Decode, 250, 2, 32, // Opcode: FSQRTQ
/* 2987 */    MCD::OPC_FilterValue, 65, 4, 0, 0, // Skip to: 2996
/* 2992 */    MCD::OPC_Decode, 244, 1, 33, // Opcode: FADDS
/* 2996 */    MCD::OPC_FilterValue, 66, 4, 0, 0, // Skip to: 3005
/* 3001 */    MCD::OPC_Decode, 242, 1, 34, // Opcode: FADDD
/* 3005 */    MCD::OPC_FilterValue, 67, 4, 0, 0, // Skip to: 3014
/* 3010 */    MCD::OPC_Decode, 243, 1, 35, // Opcode: FADDQ
/* 3014 */    MCD::OPC_FilterValue, 69, 4, 0, 0, // Skip to: 3023
/* 3019 */    MCD::OPC_Decode, 138, 3, 33, // Opcode: FSUBS
/* 3023 */    MCD::OPC_FilterValue, 70, 4, 0, 0, // Skip to: 3032
/* 3028 */    MCD::OPC_Decode, 136, 3, 34, // Opcode: FSUBD
/* 3032 */    MCD::OPC_FilterValue, 71, 4, 0, 0, // Skip to: 3041
/* 3037 */    MCD::OPC_Decode, 137, 3, 35, // Opcode: FSUBQ
/* 3041 */    MCD::OPC_FilterValue, 73, 4, 0, 0, // Skip to: 3050
/* 3046 */    MCD::OPC_Decode, 200, 2, 33, // Opcode: FMULS
/* 3050 */    MCD::OPC_FilterValue, 74, 4, 0, 0, // Skip to: 3059
/* 3055 */    MCD::OPC_Decode, 196, 2, 34, // Opcode: FMULD
/* 3059 */    MCD::OPC_FilterValue, 75, 4, 0, 0, // Skip to: 3068
/* 3064 */    MCD::OPC_Decode, 199, 2, 35, // Opcode: FMULQ
/* 3068 */    MCD::OPC_FilterValue, 77, 4, 0, 0, // Skip to: 3077
/* 3073 */    MCD::OPC_Decode, 140, 2, 33, // Opcode: FDIVS
/* 3077 */    MCD::OPC_FilterValue, 78, 4, 0, 0, // Skip to: 3086
/* 3082 */    MCD::OPC_Decode, 138, 2, 34, // Opcode: FDIVD
/* 3086 */    MCD::OPC_FilterValue, 79, 4, 0, 0, // Skip to: 3095
/* 3091 */    MCD::OPC_Decode, 139, 2, 35, // Opcode: FDIVQ
/* 3095 */    MCD::OPC_FilterValue, 81, 9, 0, 0, // Skip to: 3109
/* 3100 */    MCD::OPC_CheckPredicate, 1, 20, 19, 0, // Skip to: 7989
/* 3105 */    MCD::OPC_Decode, 202, 2, 34, // Opcode: FNADDS
/* 3109 */    MCD::OPC_FilterValue, 82, 9, 0, 0, // Skip to: 3123
/* 3114 */    MCD::OPC_CheckPredicate, 1, 6, 19, 0, // Skip to: 7989
/* 3119 */    MCD::OPC_Decode, 201, 2, 34, // Opcode: FNADDD
/* 3123 */    MCD::OPC_FilterValue, 89, 9, 0, 0, // Skip to: 3137
/* 3128 */    MCD::OPC_CheckPredicate, 1, 248, 18, 0, // Skip to: 7989
/* 3133 */    MCD::OPC_Decode, 211, 2, 34, // Opcode: FNMULS
/* 3137 */    MCD::OPC_FilterValue, 90, 9, 0, 0, // Skip to: 3151
/* 3142 */    MCD::OPC_CheckPredicate, 1, 234, 18, 0, // Skip to: 7989
/* 3147 */    MCD::OPC_Decode, 210, 2, 34, // Opcode: FNMULD
/* 3151 */    MCD::OPC_FilterValue, 97, 9, 0, 0, // Skip to: 3165
/* 3156 */    MCD::OPC_CheckPredicate, 1, 220, 18, 0, // Skip to: 7989
/* 3161 */    MCD::OPC_Decode, 148, 2, 34, // Opcode: FHADDS
/* 3165 */    MCD::OPC_FilterValue, 98, 9, 0, 0, // Skip to: 3179
/* 3170 */    MCD::OPC_CheckPredicate, 1, 206, 18, 0, // Skip to: 7989
/* 3175 */    MCD::OPC_Decode, 147, 2, 34, // Opcode: FHADDD
/* 3179 */    MCD::OPC_FilterValue, 101, 9, 0, 0, // Skip to: 3193
/* 3184 */    MCD::OPC_CheckPredicate, 1, 192, 18, 0, // Skip to: 7989
/* 3189 */    MCD::OPC_Decode, 150, 2, 34, // Opcode: FHSUBS
/* 3193 */    MCD::OPC_FilterValue, 102, 9, 0, 0, // Skip to: 3207
/* 3198 */    MCD::OPC_CheckPredicate, 1, 178, 18, 0, // Skip to: 7989
/* 3203 */    MCD::OPC_Decode, 149, 2, 34, // Opcode: FHSUBD
/* 3207 */    MCD::OPC_FilterValue, 105, 4, 0, 0, // Skip to: 3216
/* 3212 */    MCD::OPC_Decode, 248, 2, 36, // Opcode: FSMULD
/* 3216 */    MCD::OPC_FilterValue, 110, 4, 0, 0, // Skip to: 3225
/* 3221 */    MCD::OPC_Decode, 141, 2, 37, // Opcode: FDMULQ
/* 3225 */    MCD::OPC_FilterValue, 113, 9, 0, 0, // Skip to: 3239
/* 3230 */    MCD::OPC_CheckPredicate, 1, 146, 18, 0, // Skip to: 7989
/* 3235 */    MCD::OPC_Decode, 209, 2, 34, // Opcode: FNHADDS
/* 3239 */    MCD::OPC_FilterValue, 114, 9, 0, 0, // Skip to: 3253
/* 3244 */    MCD::OPC_CheckPredicate, 1, 132, 18, 0, // Skip to: 7989
/* 3249 */    MCD::OPC_Decode, 208, 2, 34, // Opcode: FNHADDD
/* 3253 */    MCD::OPC_FilterValue, 121, 9, 0, 0, // Skip to: 3267
/* 3258 */    MCD::OPC_CheckPredicate, 1, 118, 18, 0, // Skip to: 7989
/* 3263 */    MCD::OPC_Decode, 218, 2, 34, // Opcode: FNSMULD
/* 3267 */    MCD::OPC_FilterValue, 129, 1, 11, 0, 0, // Skip to: 3284
/* 3273 */    MCD::OPC_CheckField, 14, 5, 0, 101, 18, 0, // Skip to: 7989
/* 3280 */    MCD::OPC_Decode, 135, 3, 38, // Opcode: FSTOX
/* 3284 */    MCD::OPC_FilterValue, 130, 1, 11, 0, 0, // Skip to: 3301
/* 3290 */    MCD::OPC_CheckField, 14, 5, 0, 84, 18, 0, // Skip to: 7989
/* 3297 */    MCD::OPC_Decode, 145, 2, 31, // Opcode: FDTOX
/* 3301 */    MCD::OPC_FilterValue, 131, 1, 11, 0, 0, // Skip to: 3318
/* 3307 */    MCD::OPC_CheckField, 14, 5, 0, 67, 18, 0, // Skip to: 7989
/* 3314 */    MCD::OPC_Decode, 243, 2, 39, // Opcode: FQTOX
/* 3318 */    MCD::OPC_FilterValue, 132, 1, 11, 0, 0, // Skip to: 3335
/* 3324 */    MCD::OPC_CheckField, 14, 5, 0, 50, 18, 0, // Skip to: 7989
/* 3331 */    MCD::OPC_Decode, 145, 3, 40, // Opcode: FXTOS
/* 3335 */    MCD::OPC_FilterValue, 136, 1, 11, 0, 0, // Skip to: 3352
/* 3341 */    MCD::OPC_CheckField, 14, 5, 0, 33, 18, 0, // Skip to: 7989
/* 3348 */    MCD::OPC_Decode, 143, 3, 31, // Opcode: FXTOD
/* 3352 */    MCD::OPC_FilterValue, 140, 1, 11, 0, 0, // Skip to: 3369
/* 3358 */    MCD::OPC_CheckField, 14, 5, 0, 16, 18, 0, // Skip to: 7989
/* 3365 */    MCD::OPC_Decode, 144, 3, 41, // Opcode: FXTOQ
/* 3369 */    MCD::OPC_FilterValue, 196, 1, 11, 0, 0, // Skip to: 3386
/* 3375 */    MCD::OPC_CheckField, 14, 5, 0, 255, 17, 0, // Skip to: 7989
/* 3382 */    MCD::OPC_Decode, 153, 2, 30, // Opcode: FITOS
/* 3386 */    MCD::OPC_FilterValue, 198, 1, 11, 0, 0, // Skip to: 3403
/* 3392 */    MCD::OPC_CheckField, 14, 5, 0, 238, 17, 0, // Skip to: 7989
/* 3399 */    MCD::OPC_Decode, 144, 2, 40, // Opcode: FDTOS
/* 3403 */    MCD::OPC_FilterValue, 199, 1, 11, 0, 0, // Skip to: 3420
/* 3409 */    MCD::OPC_CheckField, 14, 5, 0, 221, 17, 0, // Skip to: 7989
/* 3416 */    MCD::OPC_Decode, 242, 2, 42, // Opcode: FQTOS
/* 3420 */    MCD::OPC_FilterValue, 200, 1, 11, 0, 0, // Skip to: 3437
/* 3426 */    MCD::OPC_CheckField, 14, 5, 0, 204, 17, 0, // Skip to: 7989
/* 3433 */    MCD::OPC_Decode, 151, 2, 38, // Opcode: FITOD
/* 3437 */    MCD::OPC_FilterValue, 201, 1, 11, 0, 0, // Skip to: 3454
/* 3443 */    MCD::OPC_CheckField, 14, 5, 0, 187, 17, 0, // Skip to: 7989
/* 3450 */    MCD::OPC_Decode, 132, 3, 38, // Opcode: FSTOD
/* 3454 */    MCD::OPC_FilterValue, 203, 1, 11, 0, 0, // Skip to: 3471
/* 3460 */    MCD::OPC_CheckField, 14, 5, 0, 170, 17, 0, // Skip to: 7989
/* 3467 */    MCD::OPC_Decode, 240, 2, 39, // Opcode: FQTOD
/* 3471 */    MCD::OPC_FilterValue, 204, 1, 11, 0, 0, // Skip to: 3488
/* 3477 */    MCD::OPC_CheckField, 14, 5, 0, 153, 17, 0, // Skip to: 7989
/* 3484 */    MCD::OPC_Decode, 152, 2, 43, // Opcode: FITOQ
/* 3488 */    MCD::OPC_FilterValue, 205, 1, 11, 0, 0, // Skip to: 3505
/* 3494 */    MCD::OPC_CheckField, 14, 5, 0, 136, 17, 0, // Skip to: 7989
/* 3501 */    MCD::OPC_Decode, 134, 3, 43, // Opcode: FSTOQ
/* 3505 */    MCD::OPC_FilterValue, 206, 1, 11, 0, 0, // Skip to: 3522
/* 3511 */    MCD::OPC_CheckField, 14, 5, 0, 119, 17, 0, // Skip to: 7989
/* 3518 */    MCD::OPC_Decode, 143, 2, 41, // Opcode: FDTOQ
/* 3522 */    MCD::OPC_FilterValue, 209, 1, 11, 0, 0, // Skip to: 3539
/* 3528 */    MCD::OPC_CheckField, 14, 5, 0, 102, 17, 0, // Skip to: 7989
/* 3535 */    MCD::OPC_Decode, 133, 3, 30, // Opcode: FSTOI
/* 3539 */    MCD::OPC_FilterValue, 210, 1, 11, 0, 0, // Skip to: 3556
/* 3545 */    MCD::OPC_CheckField, 14, 5, 0, 85, 17, 0, // Skip to: 7989
/* 3552 */    MCD::OPC_Decode, 142, 2, 40, // Opcode: FDTOI
/* 3556 */    MCD::OPC_FilterValue, 211, 1, 75, 17, 0, // Skip to: 7989
/* 3562 */    MCD::OPC_CheckField, 14, 5, 0, 68, 17, 0, // Skip to: 7989
/* 3569 */    MCD::OPC_Decode, 241, 2, 42, // Opcode: FQTOI
/* 3573 */    MCD::OPC_FilterValue, 53, 160, 2, 0, // Skip to: 4250
/* 3578 */    MCD::OPC_ExtractField, 5, 6,  // Inst{10-5} ...
/* 3581 */    MCD::OPC_FilterValue, 1, 86, 0, 0, // Skip to: 3672
/* 3586 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3589 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3627
/* 3594 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3597 */    MCD::OPC_FilterValue, 0, 35, 17, 0, // Skip to: 7989
/* 3602 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3618
/* 3607 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3618
/* 3614 */    MCD::OPC_Decode, 188, 2, 44, // Opcode: FMOVS_FCC
/* 3618 */    MCD::OPC_CheckPredicate, 0, 14, 17, 0, // Skip to: 7989
/* 3623 */    MCD::OPC_Decode, 248, 4, 45, // Opcode: V9FMOVS_FCC
/* 3627 */    MCD::OPC_FilterValue, 1, 5, 17, 0, // Skip to: 7989
/* 3632 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 3635 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3656
/* 3640 */    MCD::OPC_CheckPredicate, 0, 248, 16, 0, // Skip to: 7989
/* 3645 */    MCD::OPC_CheckField, 18, 1, 0, 241, 16, 0, // Skip to: 7989
/* 3652 */    MCD::OPC_Decode, 189, 2, 44, // Opcode: FMOVS_ICC
/* 3656 */    MCD::OPC_FilterValue, 2, 232, 16, 0, // Skip to: 7989
/* 3661 */    MCD::OPC_CheckField, 18, 1, 0, 225, 16, 0, // Skip to: 7989
/* 3668 */    MCD::OPC_Decode, 190, 2, 44, // Opcode: FMOVS_XCC
/* 3672 */    MCD::OPC_FilterValue, 2, 86, 0, 0, // Skip to: 3763
/* 3677 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3680 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3718
/* 3685 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3688 */    MCD::OPC_FilterValue, 0, 200, 16, 0, // Skip to: 7989
/* 3693 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3709
/* 3698 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3709
/* 3705 */    MCD::OPC_Decode, 162, 2, 46, // Opcode: FMOVD_FCC
/* 3709 */    MCD::OPC_CheckPredicate, 0, 179, 16, 0, // Skip to: 7989
/* 3714 */    MCD::OPC_Decode, 246, 4, 47, // Opcode: V9FMOVD_FCC
/* 3718 */    MCD::OPC_FilterValue, 1, 170, 16, 0, // Skip to: 7989
/* 3723 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 3726 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3747
/* 3731 */    MCD::OPC_CheckPredicate, 0, 157, 16, 0, // Skip to: 7989
/* 3736 */    MCD::OPC_CheckField, 18, 1, 0, 150, 16, 0, // Skip to: 7989
/* 3743 */    MCD::OPC_Decode, 163, 2, 46, // Opcode: FMOVD_ICC
/* 3747 */    MCD::OPC_FilterValue, 2, 141, 16, 0, // Skip to: 7989
/* 3752 */    MCD::OPC_CheckField, 18, 1, 0, 134, 16, 0, // Skip to: 7989
/* 3759 */    MCD::OPC_Decode, 164, 2, 46, // Opcode: FMOVD_XCC
/* 3763 */    MCD::OPC_FilterValue, 3, 86, 0, 0, // Skip to: 3854
/* 3768 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 3771 */    MCD::OPC_FilterValue, 0, 33, 0, 0, // Skip to: 3809
/* 3776 */    MCD::OPC_ExtractField, 18, 1,  // Inst{18} ...
/* 3779 */    MCD::OPC_FilterValue, 0, 109, 16, 0, // Skip to: 7989
/* 3784 */    MCD::OPC_CheckPredicate, 0, 11, 0, 0, // Skip to: 3800
/* 3789 */    MCD::OPC_CheckField, 11, 2, 0, 4, 0, 0, // Skip to: 3800
/* 3796 */    MCD::OPC_Decode, 166, 2, 48, // Opcode: FMOVQ_FCC
/* 3800 */    MCD::OPC_CheckPredicate, 0, 88, 16, 0, // Skip to: 7989
/* 3805 */    MCD::OPC_Decode, 247, 4, 49, // Opcode: V9FMOVQ_FCC
/* 3809 */    MCD::OPC_FilterValue, 1, 79, 16, 0, // Skip to: 7989
/* 3814 */    MCD::OPC_ExtractField, 11, 2,  // Inst{12-11} ...
/* 3817 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 3838
/* 3822 */    MCD::OPC_CheckPredicate, 0, 66, 16, 0, // Skip to: 7989
/* 3827 */    MCD::OPC_CheckField, 18, 1, 0, 59, 16, 0, // Skip to: 7989
/* 3834 */    MCD::OPC_Decode, 167, 2, 48, // Opcode: FMOVQ_ICC
/* 3838 */    MCD::OPC_FilterValue, 2, 50, 16, 0, // Skip to: 7989
/* 3843 */    MCD::OPC_CheckField, 18, 1, 0, 43, 16, 0, // Skip to: 7989
/* 3850 */    MCD::OPC_Decode, 168, 2, 48, // Opcode: FMOVQ_XCC
/* 3854 */    MCD::OPC_FilterValue, 5, 31, 0, 0, // Skip to: 3890
/* 3859 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 3862 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3876
/* 3867 */    MCD::OPC_CheckPredicate, 0, 21, 16, 0, // Skip to: 7989
/* 3872 */    MCD::OPC_Decode, 177, 2, 50, // Opcode: FMOVRLEZS
/* 3876 */    MCD::OPC_FilterValue, 3, 12, 16, 0, // Skip to: 7989
/* 3881 */    MCD::OPC_CheckPredicate, 0, 7, 16, 0, // Skip to: 7989
/* 3886 */    MCD::OPC_Decode, 174, 2, 50, // Opcode: FMOVRGZS
/* 3890 */    MCD::OPC_FilterValue, 6, 31, 0, 0, // Skip to: 3926
/* 3895 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 3898 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3912
/* 3903 */    MCD::OPC_CheckPredicate, 0, 241, 15, 0, // Skip to: 7989
/* 3908 */    MCD::OPC_Decode, 175, 2, 50, // Opcode: FMOVRLEZD
/* 3912 */    MCD::OPC_FilterValue, 3, 232, 15, 0, // Skip to: 7989
/* 3917 */    MCD::OPC_CheckPredicate, 0, 227, 15, 0, // Skip to: 7989
/* 3922 */    MCD::OPC_Decode, 172, 2, 50, // Opcode: FMOVRGZD
/* 3926 */    MCD::OPC_FilterValue, 7, 31, 0, 0, // Skip to: 3962
/* 3931 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 3934 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 3948
/* 3939 */    MCD::OPC_CheckPredicate, 0, 205, 15, 0, // Skip to: 7989
/* 3944 */    MCD::OPC_Decode, 176, 2, 50, // Opcode: FMOVRLEZQ
/* 3948 */    MCD::OPC_FilterValue, 3, 196, 15, 0, // Skip to: 7989
/* 3953 */    MCD::OPC_CheckPredicate, 0, 191, 15, 0, // Skip to: 7989
/* 3958 */    MCD::OPC_Decode, 173, 2, 50, // Opcode: FMOVRGZQ
/* 3962 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 3978
/* 3967 */    MCD::OPC_CheckField, 11, 3, 1, 175, 15, 0, // Skip to: 7989
/* 3974 */    MCD::OPC_Decode, 245, 4, 51, // Opcode: V9FCMPS
/* 3978 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 3994
/* 3983 */    MCD::OPC_CheckField, 11, 3, 1, 159, 15, 0, // Skip to: 7989
/* 3990 */    MCD::OPC_Decode, 240, 4, 52, // Opcode: V9FCMPD
/* 3994 */    MCD::OPC_FilterValue, 19, 11, 0, 0, // Skip to: 4010
/* 3999 */    MCD::OPC_CheckField, 11, 3, 1, 143, 15, 0, // Skip to: 7989
/* 4006 */    MCD::OPC_Decode, 244, 4, 53, // Opcode: V9FCMPQ
/* 4010 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 4026
/* 4015 */    MCD::OPC_CheckField, 11, 3, 1, 127, 15, 0, // Skip to: 7989
/* 4022 */    MCD::OPC_Decode, 243, 4, 51, // Opcode: V9FCMPES
/* 4026 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 4042
/* 4031 */    MCD::OPC_CheckField, 11, 3, 1, 111, 15, 0, // Skip to: 7989
/* 4038 */    MCD::OPC_Decode, 241, 4, 52, // Opcode: V9FCMPED
/* 4042 */    MCD::OPC_FilterValue, 23, 11, 0, 0, // Skip to: 4058
/* 4047 */    MCD::OPC_CheckField, 11, 3, 1, 95, 15, 0, // Skip to: 7989
/* 4054 */    MCD::OPC_Decode, 242, 4, 53, // Opcode: V9FCMPEQ
/* 4058 */    MCD::OPC_FilterValue, 37, 59, 0, 0, // Skip to: 4122
/* 4063 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 4066 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4080
/* 4071 */    MCD::OPC_CheckPredicate, 0, 73, 15, 0, // Skip to: 7989
/* 4076 */    MCD::OPC_Decode, 186, 2, 50, // Opcode: FMOVRZS
/* 4080 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4094
/* 4085 */    MCD::OPC_CheckPredicate, 0, 59, 15, 0, // Skip to: 7989
/* 4090 */    MCD::OPC_Decode, 180, 2, 50, // Opcode: FMOVRLZS
/* 4094 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4108
/* 4099 */    MCD::OPC_CheckPredicate, 0, 45, 15, 0, // Skip to: 7989
/* 4104 */    MCD::OPC_Decode, 183, 2, 50, // Opcode: FMOVRNZS
/* 4108 */    MCD::OPC_FilterValue, 3, 36, 15, 0, // Skip to: 7989
/* 4113 */    MCD::OPC_CheckPredicate, 0, 31, 15, 0, // Skip to: 7989
/* 4118 */    MCD::OPC_Decode, 171, 2, 50, // Opcode: FMOVRGEZS
/* 4122 */    MCD::OPC_FilterValue, 38, 59, 0, 0, // Skip to: 4186
/* 4127 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 4130 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4144
/* 4135 */    MCD::OPC_CheckPredicate, 0, 9, 15, 0, // Skip to: 7989
/* 4140 */    MCD::OPC_Decode, 184, 2, 50, // Opcode: FMOVRZD
/* 4144 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4158
/* 4149 */    MCD::OPC_CheckPredicate, 0, 251, 14, 0, // Skip to: 7989
/* 4154 */    MCD::OPC_Decode, 178, 2, 50, // Opcode: FMOVRLZD
/* 4158 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4172
/* 4163 */    MCD::OPC_CheckPredicate, 0, 237, 14, 0, // Skip to: 7989
/* 4168 */    MCD::OPC_Decode, 181, 2, 50, // Opcode: FMOVRNZD
/* 4172 */    MCD::OPC_FilterValue, 3, 228, 14, 0, // Skip to: 7989
/* 4177 */    MCD::OPC_CheckPredicate, 0, 223, 14, 0, // Skip to: 7989
/* 4182 */    MCD::OPC_Decode, 169, 2, 50, // Opcode: FMOVRGEZD
/* 4186 */    MCD::OPC_FilterValue, 39, 214, 14, 0, // Skip to: 7989
/* 4191 */    MCD::OPC_ExtractField, 11, 3,  // Inst{13-11} ...
/* 4194 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4208
/* 4199 */    MCD::OPC_CheckPredicate, 0, 201, 14, 0, // Skip to: 7989
/* 4204 */    MCD::OPC_Decode, 185, 2, 50, // Opcode: FMOVRZQ
/* 4208 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4222
/* 4213 */    MCD::OPC_CheckPredicate, 0, 187, 14, 0, // Skip to: 7989
/* 4218 */    MCD::OPC_Decode, 179, 2, 50, // Opcode: FMOVRLZQ
/* 4222 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4236
/* 4227 */    MCD::OPC_CheckPredicate, 0, 173, 14, 0, // Skip to: 7989
/* 4232 */    MCD::OPC_Decode, 182, 2, 50, // Opcode: FMOVRNZQ
/* 4236 */    MCD::OPC_FilterValue, 3, 164, 14, 0, // Skip to: 7989
/* 4241 */    MCD::OPC_CheckPredicate, 0, 159, 14, 0, // Skip to: 7989
/* 4246 */    MCD::OPC_Decode, 170, 2, 50, // Opcode: FMOVRGEZQ
/* 4250 */    MCD::OPC_FilterValue, 54, 35, 7, 0, // Skip to: 6082
/* 4255 */    MCD::OPC_ExtractField, 5, 9,  // Inst{13-5} ...
/* 4258 */    MCD::OPC_FilterValue, 0, 9, 0, 0, // Skip to: 4272
/* 4263 */    MCD::OPC_CheckPredicate, 2, 137, 14, 0, // Skip to: 7989
/* 4268 */    MCD::OPC_Decode, 235, 1, 10, // Opcode: EDGE8
/* 4272 */    MCD::OPC_FilterValue, 1, 9, 0, 0, // Skip to: 4286
/* 4277 */    MCD::OPC_CheckPredicate, 3, 123, 14, 0, // Skip to: 7989
/* 4282 */    MCD::OPC_Decode, 238, 1, 10, // Opcode: EDGE8N
/* 4286 */    MCD::OPC_FilterValue, 2, 9, 0, 0, // Skip to: 4300
/* 4291 */    MCD::OPC_CheckPredicate, 2, 109, 14, 0, // Skip to: 7989
/* 4296 */    MCD::OPC_Decode, 236, 1, 10, // Opcode: EDGE8L
/* 4300 */    MCD::OPC_FilterValue, 3, 9, 0, 0, // Skip to: 4314
/* 4305 */    MCD::OPC_CheckPredicate, 3, 95, 14, 0, // Skip to: 7989
/* 4310 */    MCD::OPC_Decode, 237, 1, 10, // Opcode: EDGE8LN
/* 4314 */    MCD::OPC_FilterValue, 4, 9, 0, 0, // Skip to: 4328
/* 4319 */    MCD::OPC_CheckPredicate, 2, 81, 14, 0, // Skip to: 7989
/* 4324 */    MCD::OPC_Decode, 227, 1, 10, // Opcode: EDGE16
/* 4328 */    MCD::OPC_FilterValue, 5, 9, 0, 0, // Skip to: 4342
/* 4333 */    MCD::OPC_CheckPredicate, 3, 67, 14, 0, // Skip to: 7989
/* 4338 */    MCD::OPC_Decode, 230, 1, 10, // Opcode: EDGE16N
/* 4342 */    MCD::OPC_FilterValue, 6, 9, 0, 0, // Skip to: 4356
/* 4347 */    MCD::OPC_CheckPredicate, 2, 53, 14, 0, // Skip to: 7989
/* 4352 */    MCD::OPC_Decode, 228, 1, 10, // Opcode: EDGE16L
/* 4356 */    MCD::OPC_FilterValue, 7, 9, 0, 0, // Skip to: 4370
/* 4361 */    MCD::OPC_CheckPredicate, 3, 39, 14, 0, // Skip to: 7989
/* 4366 */    MCD::OPC_Decode, 229, 1, 10, // Opcode: EDGE16LN
/* 4370 */    MCD::OPC_FilterValue, 8, 9, 0, 0, // Skip to: 4384
/* 4375 */    MCD::OPC_CheckPredicate, 2, 25, 14, 0, // Skip to: 7989
/* 4380 */    MCD::OPC_Decode, 231, 1, 10, // Opcode: EDGE32
/* 4384 */    MCD::OPC_FilterValue, 9, 9, 0, 0, // Skip to: 4398
/* 4389 */    MCD::OPC_CheckPredicate, 3, 11, 14, 0, // Skip to: 7989
/* 4394 */    MCD::OPC_Decode, 234, 1, 10, // Opcode: EDGE32N
/* 4398 */    MCD::OPC_FilterValue, 10, 9, 0, 0, // Skip to: 4412
/* 4403 */    MCD::OPC_CheckPredicate, 2, 253, 13, 0, // Skip to: 7989
/* 4408 */    MCD::OPC_Decode, 232, 1, 10, // Opcode: EDGE32L
/* 4412 */    MCD::OPC_FilterValue, 11, 9, 0, 0, // Skip to: 4426
/* 4417 */    MCD::OPC_CheckPredicate, 3, 239, 13, 0, // Skip to: 7989
/* 4422 */    MCD::OPC_Decode, 233, 1, 10, // Opcode: EDGE32LN
/* 4426 */    MCD::OPC_FilterValue, 16, 9, 0, 0, // Skip to: 4440
/* 4431 */    MCD::OPC_CheckPredicate, 2, 225, 13, 0, // Skip to: 7989
/* 4436 */    MCD::OPC_Decode, 169, 1, 10, // Opcode: ARRAY8
/* 4440 */    MCD::OPC_FilterValue, 17, 9, 0, 0, // Skip to: 4454
/* 4445 */    MCD::OPC_CheckPredicate, 1, 211, 13, 0, // Skip to: 7989
/* 4450 */    MCD::OPC_Decode, 148, 1, 10, // Opcode: ADDXC
/* 4454 */    MCD::OPC_FilterValue, 18, 9, 0, 0, // Skip to: 4468
/* 4459 */    MCD::OPC_CheckPredicate, 2, 197, 13, 0, // Skip to: 7989
/* 4464 */    MCD::OPC_Decode, 167, 1, 10, // Opcode: ARRAY16
/* 4468 */    MCD::OPC_FilterValue, 19, 9, 0, 0, // Skip to: 4482
/* 4473 */    MCD::OPC_CheckPredicate, 1, 183, 13, 0, // Skip to: 7989
/* 4478 */    MCD::OPC_Decode, 149, 1, 10, // Opcode: ADDXCCC
/* 4482 */    MCD::OPC_FilterValue, 20, 9, 0, 0, // Skip to: 4496
/* 4487 */    MCD::OPC_CheckPredicate, 2, 169, 13, 0, // Skip to: 7989
/* 4492 */    MCD::OPC_Decode, 168, 1, 10, // Opcode: ARRAY32
/* 4496 */    MCD::OPC_FilterValue, 22, 9, 0, 0, // Skip to: 4510
/* 4501 */    MCD::OPC_CheckPredicate, 1, 155, 13, 0, // Skip to: 7989
/* 4506 */    MCD::OPC_Decode, 236, 4, 10, // Opcode: UMULXHI
/* 4510 */    MCD::OPC_FilterValue, 23, 16, 0, 0, // Skip to: 4531
/* 4515 */    MCD::OPC_CheckPredicate, 1, 141, 13, 0, // Skip to: 7989
/* 4520 */    MCD::OPC_CheckField, 14, 5, 0, 134, 13, 0, // Skip to: 7989
/* 4527 */    MCD::OPC_Decode, 196, 3, 54, // Opcode: LZCNT
/* 4531 */    MCD::OPC_FilterValue, 24, 9, 0, 0, // Skip to: 4545
/* 4536 */    MCD::OPC_CheckPredicate, 2, 120, 13, 0, // Skip to: 7989
/* 4541 */    MCD::OPC_Decode, 154, 1, 10, // Opcode: ALIGNADDR
/* 4545 */    MCD::OPC_FilterValue, 25, 9, 0, 0, // Skip to: 4559
/* 4550 */    MCD::OPC_CheckPredicate, 3, 106, 13, 0, // Skip to: 7989
/* 4555 */    MCD::OPC_Decode, 175, 1, 10, // Opcode: BMASK
/* 4559 */    MCD::OPC_FilterValue, 26, 9, 0, 0, // Skip to: 4573
/* 4564 */    MCD::OPC_CheckPredicate, 2, 92, 13, 0, // Skip to: 7989
/* 4569 */    MCD::OPC_Decode, 155, 1, 10, // Opcode: ALIGNADDRL
/* 4573 */    MCD::OPC_FilterValue, 27, 23, 0, 0, // Skip to: 4601
/* 4578 */    MCD::OPC_CheckPredicate, 1, 78, 13, 0, // Skip to: 7989
/* 4583 */    MCD::OPC_CheckField, 25, 5, 0, 71, 13, 0, // Skip to: 7989
/* 4590 */    MCD::OPC_CheckField, 14, 5, 0, 64, 13, 0, // Skip to: 7989
/* 4597 */    MCD::OPC_Decode, 224, 1, 55, // Opcode: CMASK8
/* 4601 */    MCD::OPC_FilterValue, 28, 9, 0, 0, // Skip to: 4615
/* 4606 */    MCD::OPC_CheckPredicate, 3, 50, 13, 0, // Skip to: 7989
/* 4611 */    MCD::OPC_Decode, 212, 1, 34, // Opcode: BSHUFFLE
/* 4615 */    MCD::OPC_FilterValue, 29, 23, 0, 0, // Skip to: 4643
/* 4620 */    MCD::OPC_CheckPredicate, 1, 36, 13, 0, // Skip to: 7989
/* 4625 */    MCD::OPC_CheckField, 25, 5, 0, 29, 13, 0, // Skip to: 7989
/* 4632 */    MCD::OPC_CheckField, 14, 5, 0, 22, 13, 0, // Skip to: 7989
/* 4639 */    MCD::OPC_Decode, 222, 1, 55, // Opcode: CMASK16
/* 4643 */    MCD::OPC_FilterValue, 31, 23, 0, 0, // Skip to: 4671
/* 4648 */    MCD::OPC_CheckPredicate, 1, 8, 13, 0, // Skip to: 7989
/* 4653 */    MCD::OPC_CheckField, 25, 5, 0, 1, 13, 0, // Skip to: 7989
/* 4660 */    MCD::OPC_CheckField, 14, 5, 0, 250, 12, 0, // Skip to: 7989
/* 4667 */    MCD::OPC_Decode, 223, 1, 55, // Opcode: CMASK32
/* 4671 */    MCD::OPC_FilterValue, 32, 9, 0, 0, // Skip to: 4685
/* 4676 */    MCD::OPC_CheckPredicate, 2, 236, 12, 0, // Skip to: 7989
/* 4681 */    MCD::OPC_Decode, 132, 2, 56, // Opcode: FCMPLE16
/* 4685 */    MCD::OPC_FilterValue, 33, 9, 0, 0, // Skip to: 4699
/* 4690 */    MCD::OPC_CheckPredicate, 1, 222, 12, 0, // Skip to: 7989
/* 4695 */    MCD::OPC_Decode, 246, 2, 34, // Opcode: FSLL16
/* 4699 */    MCD::OPC_FilterValue, 34, 9, 0, 0, // Skip to: 4713
/* 4704 */    MCD::OPC_CheckPredicate, 2, 208, 12, 0, // Skip to: 7989
/* 4709 */    MCD::OPC_Decode, 134, 2, 56, // Opcode: FCMPNE16
/* 4713 */    MCD::OPC_FilterValue, 35, 9, 0, 0, // Skip to: 4727
/* 4718 */    MCD::OPC_CheckPredicate, 1, 194, 12, 0, // Skip to: 7989
/* 4723 */    MCD::OPC_Decode, 130, 3, 34, // Opcode: FSRL16
/* 4727 */    MCD::OPC_FilterValue, 36, 9, 0, 0, // Skip to: 4741
/* 4732 */    MCD::OPC_CheckPredicate, 2, 180, 12, 0, // Skip to: 7989
/* 4737 */    MCD::OPC_Decode, 133, 2, 56, // Opcode: FCMPLE32
/* 4741 */    MCD::OPC_FilterValue, 37, 9, 0, 0, // Skip to: 4755
/* 4746 */    MCD::OPC_CheckPredicate, 1, 166, 12, 0, // Skip to: 7989
/* 4751 */    MCD::OPC_Decode, 247, 2, 34, // Opcode: FSLL32
/* 4755 */    MCD::OPC_FilterValue, 38, 9, 0, 0, // Skip to: 4769
/* 4760 */    MCD::OPC_CheckPredicate, 2, 152, 12, 0, // Skip to: 7989
/* 4765 */    MCD::OPC_Decode, 135, 2, 56, // Opcode: FCMPNE32
/* 4769 */    MCD::OPC_FilterValue, 39, 9, 0, 0, // Skip to: 4783
/* 4774 */    MCD::OPC_CheckPredicate, 1, 138, 12, 0, // Skip to: 7989
/* 4779 */    MCD::OPC_Decode, 131, 3, 34, // Opcode: FSRL32
/* 4783 */    MCD::OPC_FilterValue, 40, 9, 0, 0, // Skip to: 4797
/* 4788 */    MCD::OPC_CheckPredicate, 2, 124, 12, 0, // Skip to: 7989
/* 4793 */    MCD::OPC_Decode, 130, 2, 56, // Opcode: FCMPGT16
/* 4797 */    MCD::OPC_FilterValue, 41, 9, 0, 0, // Skip to: 4811
/* 4802 */    MCD::OPC_CheckPredicate, 1, 110, 12, 0, // Skip to: 7989
/* 4807 */    MCD::OPC_Decode, 244, 2, 34, // Opcode: FSLAS16
/* 4811 */    MCD::OPC_FilterValue, 42, 9, 0, 0, // Skip to: 4825
/* 4816 */    MCD::OPC_CheckPredicate, 2, 96, 12, 0, // Skip to: 7989
/* 4821 */    MCD::OPC_Decode, 128, 2, 56, // Opcode: FCMPEQ16
/* 4825 */    MCD::OPC_FilterValue, 43, 9, 0, 0, // Skip to: 4839
/* 4830 */    MCD::OPC_CheckPredicate, 1, 82, 12, 0, // Skip to: 7989
/* 4835 */    MCD::OPC_Decode, 252, 2, 34, // Opcode: FSRA16
/* 4839 */    MCD::OPC_FilterValue, 44, 9, 0, 0, // Skip to: 4853
/* 4844 */    MCD::OPC_CheckPredicate, 2, 68, 12, 0, // Skip to: 7989
/* 4849 */    MCD::OPC_Decode, 131, 2, 56, // Opcode: FCMPGT32
/* 4853 */    MCD::OPC_FilterValue, 45, 9, 0, 0, // Skip to: 4867
/* 4858 */    MCD::OPC_CheckPredicate, 1, 54, 12, 0, // Skip to: 7989
/* 4863 */    MCD::OPC_Decode, 245, 2, 34, // Opcode: FSLAS32
/* 4867 */    MCD::OPC_FilterValue, 46, 9, 0, 0, // Skip to: 4881
/* 4872 */    MCD::OPC_CheckPredicate, 2, 40, 12, 0, // Skip to: 7989
/* 4877 */    MCD::OPC_Decode, 129, 2, 56, // Opcode: FCMPEQ32
/* 4881 */    MCD::OPC_FilterValue, 47, 9, 0, 0, // Skip to: 4895
/* 4886 */    MCD::OPC_CheckPredicate, 1, 26, 12, 0, // Skip to: 7989
/* 4891 */    MCD::OPC_Decode, 253, 2, 34, // Opcode: FSRA32
/* 4895 */    MCD::OPC_FilterValue, 49, 9, 0, 0, // Skip to: 4909
/* 4900 */    MCD::OPC_CheckPredicate, 2, 12, 12, 0, // Skip to: 7989
/* 4905 */    MCD::OPC_Decode, 193, 2, 34, // Opcode: FMUL8X16
/* 4909 */    MCD::OPC_FilterValue, 51, 9, 0, 0, // Skip to: 4923
/* 4914 */    MCD::OPC_CheckPredicate, 2, 254, 11, 0, // Skip to: 7989
/* 4919 */    MCD::OPC_Decode, 195, 2, 34, // Opcode: FMUL8X16AU
/* 4923 */    MCD::OPC_FilterValue, 53, 9, 0, 0, // Skip to: 4937
/* 4928 */    MCD::OPC_CheckPredicate, 2, 240, 11, 0, // Skip to: 7989
/* 4933 */    MCD::OPC_Decode, 194, 2, 34, // Opcode: FMUL8X16AL
/* 4937 */    MCD::OPC_FilterValue, 54, 9, 0, 0, // Skip to: 4951
/* 4942 */    MCD::OPC_CheckPredicate, 2, 226, 11, 0, // Skip to: 7989
/* 4947 */    MCD::OPC_Decode, 191, 2, 34, // Opcode: FMUL8SUX16
/* 4951 */    MCD::OPC_FilterValue, 55, 9, 0, 0, // Skip to: 4965
/* 4956 */    MCD::OPC_CheckPredicate, 2, 212, 11, 0, // Skip to: 7989
/* 4961 */    MCD::OPC_Decode, 192, 2, 34, // Opcode: FMUL8ULX16
/* 4965 */    MCD::OPC_FilterValue, 56, 9, 0, 0, // Skip to: 4979
/* 4970 */    MCD::OPC_CheckPredicate, 2, 198, 11, 0, // Skip to: 7989
/* 4975 */    MCD::OPC_Decode, 197, 2, 34, // Opcode: FMULD8SUX16
/* 4979 */    MCD::OPC_FilterValue, 57, 9, 0, 0, // Skip to: 4993
/* 4984 */    MCD::OPC_CheckPredicate, 2, 184, 11, 0, // Skip to: 7989
/* 4989 */    MCD::OPC_Decode, 198, 2, 34, // Opcode: FMULD8ULX16
/* 4993 */    MCD::OPC_FilterValue, 58, 9, 0, 0, // Skip to: 5007
/* 4998 */    MCD::OPC_CheckPredicate, 2, 170, 11, 0, // Skip to: 7989
/* 5003 */    MCD::OPC_Decode, 228, 2, 34, // Opcode: FPACK32
/* 5007 */    MCD::OPC_FilterValue, 59, 16, 0, 0, // Skip to: 5028
/* 5012 */    MCD::OPC_CheckPredicate, 2, 156, 11, 0, // Skip to: 7989
/* 5017 */    MCD::OPC_CheckField, 14, 5, 0, 149, 11, 0, // Skip to: 7989
/* 5024 */    MCD::OPC_Decode, 227, 2, 31, // Opcode: FPACK16
/* 5028 */    MCD::OPC_FilterValue, 61, 16, 0, 0, // Skip to: 5049
/* 5033 */    MCD::OPC_CheckPredicate, 2, 135, 11, 0, // Skip to: 7989
/* 5038 */    MCD::OPC_CheckField, 14, 5, 0, 128, 11, 0, // Skip to: 7989
/* 5045 */    MCD::OPC_Decode, 229, 2, 31, // Opcode: FPACKFIX
/* 5049 */    MCD::OPC_FilterValue, 62, 9, 0, 0, // Skip to: 5063
/* 5054 */    MCD::OPC_CheckPredicate, 2, 114, 11, 0, // Skip to: 7989
/* 5059 */    MCD::OPC_Decode, 237, 3, 34, // Opcode: PDIST
/* 5063 */    MCD::OPC_FilterValue, 63, 9, 0, 0, // Skip to: 5077
/* 5068 */    MCD::OPC_CheckPredicate, 1, 100, 11, 0, // Skip to: 7989
/* 5073 */    MCD::OPC_Decode, 238, 3, 34, // Opcode: PDISTN
/* 5077 */    MCD::OPC_FilterValue, 64, 9, 0, 0, // Skip to: 5091
/* 5082 */    MCD::OPC_CheckPredicate, 1, 86, 11, 0, // Skip to: 7989
/* 5087 */    MCD::OPC_Decode, 160, 2, 34, // Opcode: FMEAN16
/* 5091 */    MCD::OPC_FilterValue, 66, 9, 0, 0, // Skip to: 5105
/* 5096 */    MCD::OPC_CheckPredicate, 1, 72, 11, 0, // Skip to: 7989
/* 5101 */    MCD::OPC_Decode, 234, 2, 34, // Opcode: FPADD64
/* 5105 */    MCD::OPC_FilterValue, 68, 9, 0, 0, // Skip to: 5119
/* 5110 */    MCD::OPC_CheckPredicate, 1, 58, 11, 0, // Skip to: 7989
/* 5115 */    MCD::OPC_Decode, 254, 1, 34, // Opcode: FCHKSM16
/* 5119 */    MCD::OPC_FilterValue, 72, 9, 0, 0, // Skip to: 5133
/* 5124 */    MCD::OPC_CheckPredicate, 2, 44, 11, 0, // Skip to: 7989
/* 5129 */    MCD::OPC_Decode, 245, 1, 34, // Opcode: FALIGNADATA
/* 5133 */    MCD::OPC_FilterValue, 75, 9, 0, 0, // Skip to: 5147
/* 5138 */    MCD::OPC_CheckPredicate, 2, 30, 11, 0, // Skip to: 7989
/* 5143 */    MCD::OPC_Decode, 235, 2, 34, // Opcode: FPMERGE
/* 5147 */    MCD::OPC_FilterValue, 77, 16, 0, 0, // Skip to: 5168
/* 5152 */    MCD::OPC_CheckPredicate, 2, 16, 11, 0, // Skip to: 7989
/* 5157 */    MCD::OPC_CheckField, 14, 5, 0, 9, 11, 0, // Skip to: 7989
/* 5164 */    MCD::OPC_Decode, 146, 2, 31, // Opcode: FEXPAND
/* 5168 */    MCD::OPC_FilterValue, 80, 9, 0, 0, // Skip to: 5182
/* 5173 */    MCD::OPC_CheckPredicate, 2, 251, 10, 0, // Skip to: 7989
/* 5178 */    MCD::OPC_Decode, 230, 2, 34, // Opcode: FPADD16
/* 5182 */    MCD::OPC_FilterValue, 81, 9, 0, 0, // Skip to: 5196
/* 5187 */    MCD::OPC_CheckPredicate, 2, 237, 10, 0, // Skip to: 7989
/* 5192 */    MCD::OPC_Decode, 231, 2, 34, // Opcode: FPADD16S
/* 5196 */    MCD::OPC_FilterValue, 82, 9, 0, 0, // Skip to: 5210
/* 5201 */    MCD::OPC_CheckPredicate, 2, 223, 10, 0, // Skip to: 7989
/* 5206 */    MCD::OPC_Decode, 232, 2, 34, // Opcode: FPADD32
/* 5210 */    MCD::OPC_FilterValue, 83, 9, 0, 0, // Skip to: 5224
/* 5215 */    MCD::OPC_CheckPredicate, 2, 209, 10, 0, // Skip to: 7989
/* 5220 */    MCD::OPC_Decode, 233, 2, 34, // Opcode: FPADD32S
/* 5224 */    MCD::OPC_FilterValue, 84, 9, 0, 0, // Skip to: 5238
/* 5229 */    MCD::OPC_CheckPredicate, 2, 195, 10, 0, // Skip to: 7989
/* 5234 */    MCD::OPC_Decode, 236, 2, 34, // Opcode: FPSUB16
/* 5238 */    MCD::OPC_FilterValue, 85, 9, 0, 0, // Skip to: 5252
/* 5243 */    MCD::OPC_CheckPredicate, 2, 181, 10, 0, // Skip to: 7989
/* 5248 */    MCD::OPC_Decode, 237, 2, 34, // Opcode: FPSUB16S
/* 5252 */    MCD::OPC_FilterValue, 86, 9, 0, 0, // Skip to: 5266
/* 5257 */    MCD::OPC_CheckPredicate, 2, 167, 10, 0, // Skip to: 7989
/* 5262 */    MCD::OPC_Decode, 238, 2, 34, // Opcode: FPSUB32
/* 5266 */    MCD::OPC_FilterValue, 87, 9, 0, 0, // Skip to: 5280
/* 5271 */    MCD::OPC_CheckPredicate, 2, 153, 10, 0, // Skip to: 7989
/* 5276 */    MCD::OPC_Decode, 239, 2, 34, // Opcode: FPSUB32S
/* 5280 */    MCD::OPC_FilterValue, 96, 23, 0, 0, // Skip to: 5308
/* 5285 */    MCD::OPC_CheckPredicate, 2, 139, 10, 0, // Skip to: 7989
/* 5290 */    MCD::OPC_CheckField, 14, 5, 0, 132, 10, 0, // Skip to: 7989
/* 5297 */    MCD::OPC_CheckField, 0, 5, 0, 125, 10, 0, // Skip to: 7989
/* 5304 */    MCD::OPC_Decode, 146, 3, 57, // Opcode: FZERO
/* 5308 */    MCD::OPC_FilterValue, 97, 23, 0, 0, // Skip to: 5336
/* 5313 */    MCD::OPC_CheckPredicate, 2, 111, 10, 0, // Skip to: 7989
/* 5318 */    MCD::OPC_CheckField, 14, 5, 0, 104, 10, 0, // Skip to: 7989
/* 5325 */    MCD::OPC_CheckField, 0, 5, 0, 97, 10, 0, // Skip to: 7989
/* 5332 */    MCD::OPC_Decode, 147, 3, 58, // Opcode: FZEROS
/* 5336 */    MCD::OPC_FilterValue, 98, 9, 0, 0, // Skip to: 5350
/* 5341 */    MCD::OPC_CheckPredicate, 2, 83, 10, 0, // Skip to: 7989
/* 5346 */    MCD::OPC_Decode, 212, 2, 34, // Opcode: FNOR
/* 5350 */    MCD::OPC_FilterValue, 99, 9, 0, 0, // Skip to: 5364
/* 5355 */    MCD::OPC_CheckPredicate, 2, 69, 10, 0, // Skip to: 7989
/* 5360 */    MCD::OPC_Decode, 213, 2, 33, // Opcode: FNORS
/* 5364 */    MCD::OPC_FilterValue, 100, 9, 0, 0, // Skip to: 5378
/* 5369 */    MCD::OPC_CheckPredicate, 2, 55, 10, 0, // Skip to: 7989
/* 5374 */    MCD::OPC_Decode, 249, 1, 34, // Opcode: FANDNOT2
/* 5378 */    MCD::OPC_FilterValue, 101, 9, 0, 0, // Skip to: 5392
/* 5383 */    MCD::OPC_CheckPredicate, 2, 41, 10, 0, // Skip to: 7989
/* 5388 */    MCD::OPC_Decode, 250, 1, 33, // Opcode: FANDNOT2S
/* 5392 */    MCD::OPC_FilterValue, 102, 16, 0, 0, // Skip to: 5413
/* 5397 */    MCD::OPC_CheckPredicate, 2, 27, 10, 0, // Skip to: 7989
/* 5402 */    MCD::OPC_CheckField, 14, 5, 0, 20, 10, 0, // Skip to: 7989
/* 5409 */    MCD::OPC_Decode, 216, 2, 31, // Opcode: FNOT2
/* 5413 */    MCD::OPC_FilterValue, 103, 16, 0, 0, // Skip to: 5434
/* 5418 */    MCD::OPC_CheckPredicate, 2, 6, 10, 0, // Skip to: 7989
/* 5423 */    MCD::OPC_CheckField, 14, 5, 0, 255, 9, 0, // Skip to: 7989
/* 5430 */    MCD::OPC_Decode, 217, 2, 30, // Opcode: FNOT2S
/* 5434 */    MCD::OPC_FilterValue, 104, 9, 0, 0, // Skip to: 5448
/* 5439 */    MCD::OPC_CheckPredicate, 2, 241, 9, 0, // Skip to: 7989
/* 5444 */    MCD::OPC_Decode, 247, 1, 34, // Opcode: FANDNOT1
/* 5448 */    MCD::OPC_FilterValue, 105, 9, 0, 0, // Skip to: 5462
/* 5453 */    MCD::OPC_CheckPredicate, 2, 227, 9, 0, // Skip to: 7989
/* 5458 */    MCD::OPC_Decode, 248, 1, 33, // Opcode: FANDNOT1S
/* 5462 */    MCD::OPC_FilterValue, 106, 16, 0, 0, // Skip to: 5483
/* 5467 */    MCD::OPC_CheckPredicate, 2, 213, 9, 0, // Skip to: 7989
/* 5472 */    MCD::OPC_CheckField, 0, 5, 0, 206, 9, 0, // Skip to: 7989
/* 5479 */    MCD::OPC_Decode, 214, 2, 59, // Opcode: FNOT1
/* 5483 */    MCD::OPC_FilterValue, 107, 16, 0, 0, // Skip to: 5504
/* 5488 */    MCD::OPC_CheckPredicate, 2, 192, 9, 0, // Skip to: 7989
/* 5493 */    MCD::OPC_CheckField, 0, 5, 0, 185, 9, 0, // Skip to: 7989
/* 5500 */    MCD::OPC_Decode, 215, 2, 60, // Opcode: FNOT1S
/* 5504 */    MCD::OPC_FilterValue, 108, 9, 0, 0, // Skip to: 5518
/* 5509 */    MCD::OPC_CheckPredicate, 2, 171, 9, 0, // Skip to: 7989
/* 5514 */    MCD::OPC_Decode, 141, 3, 34, // Opcode: FXOR
/* 5518 */    MCD::OPC_FilterValue, 109, 9, 0, 0, // Skip to: 5532
/* 5523 */    MCD::OPC_CheckPredicate, 2, 157, 9, 0, // Skip to: 7989
/* 5528 */    MCD::OPC_Decode, 142, 3, 33, // Opcode: FXORS
/* 5532 */    MCD::OPC_FilterValue, 110, 9, 0, 0, // Skip to: 5546
/* 5537 */    MCD::OPC_CheckPredicate, 2, 143, 9, 0, // Skip to: 7989
/* 5542 */    MCD::OPC_Decode, 203, 2, 34, // Opcode: FNAND
/* 5546 */    MCD::OPC_FilterValue, 111, 9, 0, 0, // Skip to: 5560
/* 5551 */    MCD::OPC_CheckPredicate, 2, 129, 9, 0, // Skip to: 7989
/* 5556 */    MCD::OPC_Decode, 204, 2, 33, // Opcode: FNANDS
/* 5560 */    MCD::OPC_FilterValue, 112, 9, 0, 0, // Skip to: 5574
/* 5565 */    MCD::OPC_CheckPredicate, 2, 115, 9, 0, // Skip to: 7989
/* 5570 */    MCD::OPC_Decode, 246, 1, 34, // Opcode: FAND
/* 5574 */    MCD::OPC_FilterValue, 113, 9, 0, 0, // Skip to: 5588
/* 5579 */    MCD::OPC_CheckPredicate, 2, 101, 9, 0, // Skip to: 7989
/* 5584 */    MCD::OPC_Decode, 251, 1, 33, // Opcode: FANDS
/* 5588 */    MCD::OPC_FilterValue, 114, 9, 0, 0, // Skip to: 5602
/* 5593 */    MCD::OPC_CheckPredicate, 2, 87, 9, 0, // Skip to: 7989
/* 5598 */    MCD::OPC_Decode, 139, 3, 34, // Opcode: FXNOR
/* 5602 */    MCD::OPC_FilterValue, 115, 9, 0, 0, // Skip to: 5616
/* 5607 */    MCD::OPC_CheckPredicate, 2, 73, 9, 0, // Skip to: 7989
/* 5612 */    MCD::OPC_Decode, 140, 3, 33, // Opcode: FXNORS
/* 5616 */    MCD::OPC_FilterValue, 116, 16, 0, 0, // Skip to: 5637
/* 5621 */    MCD::OPC_CheckPredicate, 2, 59, 9, 0, // Skip to: 7989
/* 5626 */    MCD::OPC_CheckField, 0, 5, 0, 52, 9, 0, // Skip to: 7989
/* 5633 */    MCD::OPC_Decode, 254, 2, 59, // Opcode: FSRC1
/* 5637 */    MCD::OPC_FilterValue, 117, 16, 0, 0, // Skip to: 5658
/* 5642 */    MCD::OPC_CheckPredicate, 2, 38, 9, 0, // Skip to: 7989
/* 5647 */    MCD::OPC_CheckField, 0, 5, 0, 31, 9, 0, // Skip to: 7989
/* 5654 */    MCD::OPC_Decode, 255, 2, 60, // Opcode: FSRC1S
/* 5658 */    MCD::OPC_FilterValue, 118, 9, 0, 0, // Skip to: 5672
/* 5663 */    MCD::OPC_CheckPredicate, 2, 17, 9, 0, // Skip to: 7989
/* 5668 */    MCD::OPC_Decode, 224, 2, 34, // Opcode: FORNOT2
/* 5672 */    MCD::OPC_FilterValue, 119, 9, 0, 0, // Skip to: 5686
/* 5677 */    MCD::OPC_CheckPredicate, 2, 3, 9, 0, // Skip to: 7989
/* 5682 */    MCD::OPC_Decode, 225, 2, 33, // Opcode: FORNOT2S
/* 5686 */    MCD::OPC_FilterValue, 120, 16, 0, 0, // Skip to: 5707
/* 5691 */    MCD::OPC_CheckPredicate, 2, 245, 8, 0, // Skip to: 7989
/* 5696 */    MCD::OPC_CheckField, 14, 5, 0, 238, 8, 0, // Skip to: 7989
/* 5703 */    MCD::OPC_Decode, 128, 3, 31, // Opcode: FSRC2
/* 5707 */    MCD::OPC_FilterValue, 121, 16, 0, 0, // Skip to: 5728
/* 5712 */    MCD::OPC_CheckPredicate, 2, 224, 8, 0, // Skip to: 7989
/* 5717 */    MCD::OPC_CheckField, 14, 5, 0, 217, 8, 0, // Skip to: 7989
/* 5724 */    MCD::OPC_Decode, 129, 3, 30, // Opcode: FSRC2S
/* 5728 */    MCD::OPC_FilterValue, 122, 9, 0, 0, // Skip to: 5742
/* 5733 */    MCD::OPC_CheckPredicate, 2, 203, 8, 0, // Skip to: 7989
/* 5738 */    MCD::OPC_Decode, 222, 2, 34, // Opcode: FORNOT1
/* 5742 */    MCD::OPC_FilterValue, 123, 9, 0, 0, // Skip to: 5756
/* 5747 */    MCD::OPC_CheckPredicate, 2, 189, 8, 0, // Skip to: 7989
/* 5752 */    MCD::OPC_Decode, 223, 2, 33, // Opcode: FORNOT1S
/* 5756 */    MCD::OPC_FilterValue, 124, 9, 0, 0, // Skip to: 5770
/* 5761 */    MCD::OPC_CheckPredicate, 2, 175, 8, 0, // Skip to: 7989
/* 5766 */    MCD::OPC_Decode, 221, 2, 34, // Opcode: FOR
/* 5770 */    MCD::OPC_FilterValue, 125, 9, 0, 0, // Skip to: 5784
/* 5775 */    MCD::OPC_CheckPredicate, 2, 161, 8, 0, // Skip to: 7989
/* 5780 */    MCD::OPC_Decode, 226, 2, 33, // Opcode: FORS
/* 5784 */    MCD::OPC_FilterValue, 126, 23, 0, 0, // Skip to: 5812
/* 5789 */    MCD::OPC_CheckPredicate, 2, 147, 8, 0, // Skip to: 7989
/* 5794 */    MCD::OPC_CheckField, 14, 5, 0, 140, 8, 0, // Skip to: 7989
/* 5801 */    MCD::OPC_CheckField, 0, 5, 0, 133, 8, 0, // Skip to: 7989
/* 5808 */    MCD::OPC_Decode, 219, 2, 57, // Opcode: FONE
/* 5812 */    MCD::OPC_FilterValue, 127, 23, 0, 0, // Skip to: 5840
/* 5817 */    MCD::OPC_CheckPredicate, 2, 119, 8, 0, // Skip to: 7989
/* 5822 */    MCD::OPC_CheckField, 14, 5, 0, 112, 8, 0, // Skip to: 7989
/* 5829 */    MCD::OPC_CheckField, 0, 5, 0, 105, 8, 0, // Skip to: 7989
/* 5836 */    MCD::OPC_Decode, 220, 2, 58, // Opcode: FONES
/* 5840 */    MCD::OPC_FilterValue, 128, 1, 30, 0, 0, // Skip to: 5876
/* 5846 */    MCD::OPC_CheckPredicate, 2, 90, 8, 0, // Skip to: 7989
/* 5851 */    MCD::OPC_CheckField, 25, 5, 0, 83, 8, 0, // Skip to: 7989
/* 5858 */    MCD::OPC_CheckField, 14, 5, 0, 76, 8, 0, // Skip to: 7989
/* 5865 */    MCD::OPC_CheckField, 0, 5, 0, 69, 8, 0, // Skip to: 7989
/* 5872 */    MCD::OPC_Decode, 133, 4, 4, // Opcode: SHUTDOWN
/* 5876 */    MCD::OPC_FilterValue, 129, 1, 30, 0, 0, // Skip to: 5912
/* 5882 */    MCD::OPC_CheckPredicate, 3, 54, 8, 0, // Skip to: 7989
/* 5887 */    MCD::OPC_CheckField, 25, 5, 0, 47, 8, 0, // Skip to: 7989
/* 5894 */    MCD::OPC_CheckField, 14, 5, 0, 40, 8, 0, // Skip to: 7989
/* 5901 */    MCD::OPC_CheckField, 0, 5, 0, 33, 8, 0, // Skip to: 7989
/* 5908 */    MCD::OPC_Decode, 134, 4, 4, // Opcode: SIAM
/* 5912 */    MCD::OPC_FilterValue, 144, 2, 16, 0, 0, // Skip to: 5934
/* 5918 */    MCD::OPC_CheckPredicate, 1, 18, 8, 0, // Skip to: 7989
/* 5923 */    MCD::OPC_CheckField, 14, 5, 0, 11, 8, 0, // Skip to: 7989
/* 5930 */    MCD::OPC_Decode, 198, 3, 61, // Opcode: MOVDTOX
/* 5934 */    MCD::OPC_FilterValue, 145, 2, 16, 0, 0, // Skip to: 5956
/* 5940 */    MCD::OPC_CheckPredicate, 1, 252, 7, 0, // Skip to: 7989
/* 5945 */    MCD::OPC_CheckField, 14, 5, 0, 245, 7, 0, // Skip to: 7989
/* 5952 */    MCD::OPC_Decode, 216, 3, 61, // Opcode: MOVSTOUW
/* 5956 */    MCD::OPC_FilterValue, 147, 2, 16, 0, 0, // Skip to: 5978
/* 5962 */    MCD::OPC_CheckPredicate, 1, 230, 7, 0, // Skip to: 7989
/* 5967 */    MCD::OPC_CheckField, 14, 5, 0, 223, 7, 0, // Skip to: 7989
/* 5974 */    MCD::OPC_Decode, 215, 3, 61, // Opcode: MOVSTOSW
/* 5978 */    MCD::OPC_FilterValue, 149, 2, 9, 0, 0, // Skip to: 5993
/* 5984 */    MCD::OPC_CheckPredicate, 1, 208, 7, 0, // Skip to: 7989
/* 5989 */    MCD::OPC_Decode, 133, 5, 10, // Opcode: XMULX
/* 5993 */    MCD::OPC_FilterValue, 151, 2, 9, 0, 0, // Skip to: 6008
/* 5999 */    MCD::OPC_CheckPredicate, 1, 193, 7, 0, // Skip to: 7989
/* 6004 */    MCD::OPC_Decode, 134, 5, 10, // Opcode: XMULXHI
/* 6008 */    MCD::OPC_FilterValue, 152, 2, 16, 0, 0, // Skip to: 6030
/* 6014 */    MCD::OPC_CheckPredicate, 1, 178, 7, 0, // Skip to: 7989
/* 6019 */    MCD::OPC_CheckField, 14, 5, 0, 171, 7, 0, // Skip to: 7989
/* 6026 */    MCD::OPC_Decode, 220, 3, 62, // Opcode: MOVXTOD
/* 6030 */    MCD::OPC_FilterValue, 153, 2, 16, 0, 0, // Skip to: 6052
/* 6036 */    MCD::OPC_CheckPredicate, 1, 156, 7, 0, // Skip to: 7989
/* 6041 */    MCD::OPC_CheckField, 14, 5, 0, 149, 7, 0, // Skip to: 7989
/* 6048 */    MCD::OPC_Decode, 217, 3, 62, // Opcode: MOVWTOS
/* 6052 */    MCD::OPC_FilterValue, 209, 2, 9, 0, 0, // Skip to: 6067
/* 6058 */    MCD::OPC_CheckPredicate, 1, 134, 7, 0, // Skip to: 7989
/* 6063 */    MCD::OPC_Decode, 155, 2, 52, // Opcode: FLCMPS
/* 6067 */    MCD::OPC_FilterValue, 210, 2, 124, 7, 0, // Skip to: 7989
/* 6073 */    MCD::OPC_CheckPredicate, 1, 119, 7, 0, // Skip to: 7989
/* 6078 */    MCD::OPC_Decode, 154, 2, 52, // Opcode: FLCMPD
/* 6082 */    MCD::OPC_FilterValue, 56, 28, 0, 0, // Skip to: 6115
/* 6087 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6090 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6106
/* 6095 */    MCD::OPC_CheckField, 5, 8, 0, 95, 7, 0, // Skip to: 7989
/* 6102 */    MCD::OPC_Decode, 149, 3, 63, // Opcode: JMPLrr
/* 6106 */    MCD::OPC_FilterValue, 1, 86, 7, 0, // Skip to: 7989
/* 6111 */    MCD::OPC_Decode, 148, 3, 63, // Opcode: JMPLri
/* 6115 */    MCD::OPC_FilterValue, 57, 42, 0, 0, // Skip to: 6162
/* 6120 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6123 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 6146
/* 6128 */    MCD::OPC_CheckField, 25, 5, 0, 62, 7, 0, // Skip to: 7989
/* 6135 */    MCD::OPC_CheckField, 5, 8, 0, 55, 7, 0, // Skip to: 7989
/* 6142 */    MCD::OPC_Decode, 250, 3, 64, // Opcode: RETTrr
/* 6146 */    MCD::OPC_FilterValue, 1, 46, 7, 0, // Skip to: 7989
/* 6151 */    MCD::OPC_CheckField, 25, 5, 0, 39, 7, 0, // Skip to: 7989
/* 6158 */    MCD::OPC_Decode, 249, 3, 64, // Opcode: RETTri
/* 6162 */    MCD::OPC_FilterValue, 58, 119, 0, 0, // Skip to: 6286
/* 6167 */    MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 6170 */    MCD::OPC_FilterValue, 16, 18, 0, 0, // Skip to: 6193
/* 6175 */    MCD::OPC_CheckField, 29, 1, 0, 15, 7, 0, // Skip to: 7989
/* 6182 */    MCD::OPC_CheckField, 5, 3, 0, 8, 7, 0, // Skip to: 7989
/* 6189 */    MCD::OPC_Decode, 225, 4, 65, // Opcode: TXCCrr
/* 6193 */    MCD::OPC_FilterValue, 32, 72, 0, 0, // Skip to: 6270
/* 6198 */    MCD::OPC_ExtractField, 0, 8,  // Inst{7-0} ...
/* 6201 */    MCD::OPC_FilterValue, 1, 18, 0, 0, // Skip to: 6224
/* 6206 */    MCD::OPC_CheckField, 25, 5, 8, 240, 6, 0, // Skip to: 7989
/* 6213 */    MCD::OPC_CheckField, 14, 5, 0, 233, 6, 0, // Skip to: 7989
/* 6220 */    MCD::OPC_Decode, 204, 4, 4, // Opcode: TA1
/* 6224 */    MCD::OPC_FilterValue, 3, 18, 0, 0, // Skip to: 6247
/* 6229 */    MCD::OPC_CheckField, 25, 5, 8, 217, 6, 0, // Skip to: 7989
/* 6236 */    MCD::OPC_CheckField, 14, 5, 0, 210, 6, 0, // Skip to: 7989
/* 6243 */    MCD::OPC_Decode, 205, 4, 4, // Opcode: TA3
/* 6247 */    MCD::OPC_FilterValue, 5, 201, 6, 0, // Skip to: 7989
/* 6252 */    MCD::OPC_CheckField, 25, 5, 8, 194, 6, 0, // Skip to: 7989
/* 6259 */    MCD::OPC_CheckField, 14, 5, 0, 187, 6, 0, // Skip to: 7989
/* 6266 */    MCD::OPC_Decode, 206, 4, 4, // Opcode: TA5
/* 6270 */    MCD::OPC_FilterValue, 48, 178, 6, 0, // Skip to: 7989
/* 6275 */    MCD::OPC_CheckField, 29, 1, 0, 171, 6, 0, // Skip to: 7989
/* 6282 */    MCD::OPC_Decode, 224, 4, 66, // Opcode: TXCCri
/* 6286 */    MCD::OPC_FilterValue, 59, 62, 0, 0, // Skip to: 6353
/* 6291 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6294 */    MCD::OPC_FilterValue, 0, 38, 0, 0, // Skip to: 6337
/* 6299 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 6302 */    MCD::OPC_FilterValue, 0, 146, 6, 0, // Skip to: 7989
/* 6307 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 6310 */    MCD::OPC_FilterValue, 0, 138, 6, 0, // Skip to: 7989
/* 6315 */    MCD::OPC_CheckField, 14, 5, 0, 11, 0, 0, // Skip to: 6333
/* 6322 */    MCD::OPC_CheckField, 0, 5, 0, 4, 0, 0, // Skip to: 6333
/* 6329 */    MCD::OPC_Decode, 156, 2, 4, // Opcode: FLUSH
/* 6333 */    MCD::OPC_Decode, 159, 2, 4, // Opcode: FLUSHrr
/* 6337 */    MCD::OPC_FilterValue, 1, 111, 6, 0, // Skip to: 7989
/* 6342 */    MCD::OPC_CheckField, 25, 5, 0, 104, 6, 0, // Skip to: 7989
/* 6349 */    MCD::OPC_Decode, 158, 2, 4, // Opcode: FLUSHri
/* 6353 */    MCD::OPC_FilterValue, 60, 28, 0, 0, // Skip to: 6386
/* 6358 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6361 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6377
/* 6366 */    MCD::OPC_CheckField, 5, 8, 0, 80, 6, 0, // Skip to: 7989
/* 6373 */    MCD::OPC_Decode, 252, 3, 8, // Opcode: SAVErr
/* 6377 */    MCD::OPC_FilterValue, 1, 71, 6, 0, // Skip to: 7989
/* 6382 */    MCD::OPC_Decode, 251, 3, 9, // Opcode: SAVEri
/* 6386 */    MCD::OPC_FilterValue, 61, 28, 0, 0, // Skip to: 6419
/* 6391 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6394 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6410
/* 6399 */    MCD::OPC_CheckField, 5, 8, 0, 47, 6, 0, // Skip to: 7989
/* 6406 */    MCD::OPC_Decode, 246, 3, 8, // Opcode: RESTORErr
/* 6410 */    MCD::OPC_FilterValue, 1, 38, 6, 0, // Skip to: 7989
/* 6415 */    MCD::OPC_Decode, 245, 3, 9, // Opcode: RESTOREri
/* 6419 */    MCD::OPC_FilterValue, 62, 28, 0, 0, // Skip to: 6452
/* 6424 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6427 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6443
/* 6432 */    MCD::OPC_CheckField, 5, 8, 0, 14, 6, 0, // Skip to: 7989
/* 6439 */    MCD::OPC_Decode, 233, 4, 8, // Opcode: UMACrr
/* 6443 */    MCD::OPC_FilterValue, 1, 5, 6, 0, // Skip to: 7989
/* 6448 */    MCD::OPC_Decode, 232, 4, 9, // Opcode: UMACri
/* 6452 */    MCD::OPC_FilterValue, 63, 252, 5, 0, // Skip to: 7989
/* 6457 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6460 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6476
/* 6465 */    MCD::OPC_CheckField, 5, 8, 0, 237, 5, 0, // Skip to: 7989
/* 6472 */    MCD::OPC_Decode, 140, 4, 8, // Opcode: SMACrr
/* 6476 */    MCD::OPC_FilterValue, 1, 228, 5, 0, // Skip to: 7989
/* 6481 */    MCD::OPC_Decode, 139, 4, 9, // Opcode: SMACri
/* 6485 */    MCD::OPC_FilterValue, 3, 219, 5, 0, // Skip to: 7989
/* 6490 */    MCD::OPC_ExtractField, 19, 6,  // Inst{24-19} ...
/* 6493 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 6526
/* 6498 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6501 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6517
/* 6506 */    MCD::OPC_CheckField, 5, 8, 0, 196, 5, 0, // Skip to: 7989
/* 6513 */    MCD::OPC_Decode, 193, 3, 67, // Opcode: LDrr
/* 6517 */    MCD::OPC_FilterValue, 1, 187, 5, 0, // Skip to: 7989
/* 6522 */    MCD::OPC_Decode, 192, 3, 67, // Opcode: LDri
/* 6526 */    MCD::OPC_FilterValue, 1, 28, 0, 0, // Skip to: 6559
/* 6531 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6534 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6550
/* 6539 */    MCD::OPC_CheckField, 5, 8, 0, 163, 5, 0, // Skip to: 7989
/* 6546 */    MCD::OPC_Decode, 184, 3, 67, // Opcode: LDUBrr
/* 6550 */    MCD::OPC_FilterValue, 1, 154, 5, 0, // Skip to: 7989
/* 6555 */    MCD::OPC_Decode, 183, 3, 67, // Opcode: LDUBri
/* 6559 */    MCD::OPC_FilterValue, 2, 28, 0, 0, // Skip to: 6592
/* 6564 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6567 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6583
/* 6572 */    MCD::OPC_CheckField, 5, 8, 0, 130, 5, 0, // Skip to: 7989
/* 6579 */    MCD::OPC_Decode, 187, 3, 67, // Opcode: LDUHrr
/* 6583 */    MCD::OPC_FilterValue, 1, 121, 5, 0, // Skip to: 7989
/* 6588 */    MCD::OPC_Decode, 186, 3, 67, // Opcode: LDUHri
/* 6592 */    MCD::OPC_FilterValue, 3, 28, 0, 0, // Skip to: 6625
/* 6597 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6600 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6616
/* 6605 */    MCD::OPC_CheckField, 5, 8, 0, 97, 5, 0, // Skip to: 7989
/* 6612 */    MCD::OPC_Decode, 162, 3, 68, // Opcode: LDDrr
/* 6616 */    MCD::OPC_FilterValue, 1, 88, 5, 0, // Skip to: 7989
/* 6621 */    MCD::OPC_Decode, 161, 3, 68, // Opcode: LDDri
/* 6625 */    MCD::OPC_FilterValue, 4, 28, 0, 0, // Skip to: 6658
/* 6630 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6633 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6649
/* 6638 */    MCD::OPC_CheckField, 5, 8, 0, 64, 5, 0, // Skip to: 7989
/* 6645 */    MCD::OPC_Decode, 190, 4, 69, // Opcode: STrr
/* 6649 */    MCD::OPC_FilterValue, 1, 55, 5, 0, // Skip to: 7989
/* 6654 */    MCD::OPC_Decode, 189, 4, 69, // Opcode: STri
/* 6658 */    MCD::OPC_FilterValue, 5, 28, 0, 0, // Skip to: 6691
/* 6663 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6666 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6682
/* 6671 */    MCD::OPC_CheckField, 5, 8, 0, 31, 5, 0, // Skip to: 7989
/* 6678 */    MCD::OPC_Decode, 157, 4, 69, // Opcode: STBrr
/* 6682 */    MCD::OPC_FilterValue, 1, 22, 5, 0, // Skip to: 7989
/* 6687 */    MCD::OPC_Decode, 156, 4, 69, // Opcode: STBri
/* 6691 */    MCD::OPC_FilterValue, 6, 28, 0, 0, // Skip to: 6724
/* 6696 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6699 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6715
/* 6704 */    MCD::OPC_CheckField, 5, 8, 0, 254, 4, 0, // Skip to: 7989
/* 6711 */    MCD::OPC_Decode, 181, 4, 69, // Opcode: STHrr
/* 6715 */    MCD::OPC_FilterValue, 1, 245, 4, 0, // Skip to: 7989
/* 6720 */    MCD::OPC_Decode, 180, 4, 69, // Opcode: STHri
/* 6724 */    MCD::OPC_FilterValue, 7, 28, 0, 0, // Skip to: 6757
/* 6729 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6732 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6748
/* 6737 */    MCD::OPC_CheckField, 5, 8, 0, 221, 4, 0, // Skip to: 7989
/* 6744 */    MCD::OPC_Decode, 173, 4, 70, // Opcode: STDrr
/* 6748 */    MCD::OPC_FilterValue, 1, 212, 4, 0, // Skip to: 7989
/* 6753 */    MCD::OPC_Decode, 172, 4, 70, // Opcode: STDri
/* 6757 */    MCD::OPC_FilterValue, 8, 28, 0, 0, // Skip to: 6790
/* 6762 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6765 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6781
/* 6770 */    MCD::OPC_CheckField, 5, 8, 0, 188, 4, 0, // Skip to: 7989
/* 6777 */    MCD::OPC_Decode, 181, 3, 67, // Opcode: LDSWrr
/* 6781 */    MCD::OPC_FilterValue, 1, 179, 4, 0, // Skip to: 7989
/* 6786 */    MCD::OPC_Decode, 180, 3, 67, // Opcode: LDSWri
/* 6790 */    MCD::OPC_FilterValue, 9, 28, 0, 0, // Skip to: 6823
/* 6795 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6798 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6814
/* 6803 */    MCD::OPC_CheckField, 5, 8, 0, 155, 4, 0, // Skip to: 7989
/* 6810 */    MCD::OPC_Decode, 173, 3, 67, // Opcode: LDSBrr
/* 6814 */    MCD::OPC_FilterValue, 1, 146, 4, 0, // Skip to: 7989
/* 6819 */    MCD::OPC_Decode, 172, 3, 67, // Opcode: LDSBri
/* 6823 */    MCD::OPC_FilterValue, 10, 28, 0, 0, // Skip to: 6856
/* 6828 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6831 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6847
/* 6836 */    MCD::OPC_CheckField, 5, 8, 0, 122, 4, 0, // Skip to: 7989
/* 6843 */    MCD::OPC_Decode, 176, 3, 67, // Opcode: LDSHrr
/* 6847 */    MCD::OPC_FilterValue, 1, 113, 4, 0, // Skip to: 7989
/* 6852 */    MCD::OPC_Decode, 175, 3, 67, // Opcode: LDSHri
/* 6856 */    MCD::OPC_FilterValue, 11, 28, 0, 0, // Skip to: 6889
/* 6861 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6864 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6880
/* 6869 */    MCD::OPC_CheckField, 5, 8, 0, 89, 4, 0, // Skip to: 7989
/* 6876 */    MCD::OPC_Decode, 191, 3, 67, // Opcode: LDXrr
/* 6880 */    MCD::OPC_FilterValue, 1, 80, 4, 0, // Skip to: 7989
/* 6885 */    MCD::OPC_Decode, 190, 3, 67, // Opcode: LDXri
/* 6889 */    MCD::OPC_FilterValue, 13, 28, 0, 0, // Skip to: 6922
/* 6894 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6897 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6913
/* 6902 */    MCD::OPC_CheckField, 5, 8, 0, 56, 4, 0, // Skip to: 7989
/* 6909 */    MCD::OPC_Decode, 179, 3, 4, // Opcode: LDSTUBrr
/* 6913 */    MCD::OPC_FilterValue, 1, 47, 4, 0, // Skip to: 7989
/* 6918 */    MCD::OPC_Decode, 178, 3, 4, // Opcode: LDSTUBri
/* 6922 */    MCD::OPC_FilterValue, 14, 28, 0, 0, // Skip to: 6955
/* 6927 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6930 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6946
/* 6935 */    MCD::OPC_CheckField, 5, 8, 0, 23, 4, 0, // Skip to: 7989
/* 6942 */    MCD::OPC_Decode, 188, 4, 69, // Opcode: STXrr
/* 6946 */    MCD::OPC_FilterValue, 1, 14, 4, 0, // Skip to: 7989
/* 6951 */    MCD::OPC_Decode, 187, 4, 69, // Opcode: STXri
/* 6955 */    MCD::OPC_FilterValue, 15, 28, 0, 0, // Skip to: 6988
/* 6960 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 6963 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 6979
/* 6968 */    MCD::OPC_CheckField, 5, 8, 0, 246, 3, 0, // Skip to: 7989
/* 6975 */    MCD::OPC_Decode, 203, 4, 71, // Opcode: SWAPrr
/* 6979 */    MCD::OPC_FilterValue, 1, 237, 3, 0, // Skip to: 7989
/* 6984 */    MCD::OPC_Decode, 202, 4, 71, // Opcode: SWAPri
/* 6988 */    MCD::OPC_FilterValue, 16, 11, 0, 0, // Skip to: 7004
/* 6993 */    MCD::OPC_CheckField, 13, 1, 0, 221, 3, 0, // Skip to: 7989
/* 7000 */    MCD::OPC_Decode, 150, 3, 67, // Opcode: LDArr
/* 7004 */    MCD::OPC_FilterValue, 17, 11, 0, 0, // Skip to: 7020
/* 7009 */    MCD::OPC_CheckField, 13, 1, 0, 205, 3, 0, // Skip to: 7989
/* 7016 */    MCD::OPC_Decode, 182, 3, 67, // Opcode: LDUBArr
/* 7020 */    MCD::OPC_FilterValue, 18, 11, 0, 0, // Skip to: 7036
/* 7025 */    MCD::OPC_CheckField, 13, 1, 0, 189, 3, 0, // Skip to: 7989
/* 7032 */    MCD::OPC_Decode, 185, 3, 67, // Opcode: LDUHArr
/* 7036 */    MCD::OPC_FilterValue, 19, 11, 0, 0, // Skip to: 7052
/* 7041 */    MCD::OPC_CheckField, 13, 1, 0, 173, 3, 0, // Skip to: 7989
/* 7048 */    MCD::OPC_Decode, 155, 3, 68, // Opcode: LDDArr
/* 7052 */    MCD::OPC_FilterValue, 20, 11, 0, 0, // Skip to: 7068
/* 7057 */    MCD::OPC_CheckField, 13, 1, 0, 157, 3, 0, // Skip to: 7989
/* 7064 */    MCD::OPC_Decode, 153, 4, 69, // Opcode: STArr
/* 7068 */    MCD::OPC_FilterValue, 21, 11, 0, 0, // Skip to: 7084
/* 7073 */    MCD::OPC_CheckField, 13, 1, 0, 141, 3, 0, // Skip to: 7989
/* 7080 */    MCD::OPC_Decode, 155, 4, 69, // Opcode: STBArr
/* 7084 */    MCD::OPC_FilterValue, 22, 11, 0, 0, // Skip to: 7100
/* 7089 */    MCD::OPC_CheckField, 13, 1, 0, 125, 3, 0, // Skip to: 7989
/* 7096 */    MCD::OPC_Decode, 179, 4, 69, // Opcode: STHArr
/* 7100 */    MCD::OPC_FilterValue, 23, 11, 0, 0, // Skip to: 7116
/* 7105 */    MCD::OPC_CheckField, 13, 1, 0, 109, 3, 0, // Skip to: 7989
/* 7112 */    MCD::OPC_Decode, 162, 4, 70, // Opcode: STDArr
/* 7116 */    MCD::OPC_FilterValue, 25, 11, 0, 0, // Skip to: 7132
/* 7121 */    MCD::OPC_CheckField, 13, 1, 0, 93, 3, 0, // Skip to: 7989
/* 7128 */    MCD::OPC_Decode, 171, 3, 67, // Opcode: LDSBArr
/* 7132 */    MCD::OPC_FilterValue, 26, 11, 0, 0, // Skip to: 7148
/* 7137 */    MCD::OPC_CheckField, 13, 1, 0, 77, 3, 0, // Skip to: 7989
/* 7144 */    MCD::OPC_Decode, 174, 3, 67, // Opcode: LDSHArr
/* 7148 */    MCD::OPC_FilterValue, 29, 11, 0, 0, // Skip to: 7164
/* 7153 */    MCD::OPC_CheckField, 13, 1, 0, 61, 3, 0, // Skip to: 7989
/* 7160 */    MCD::OPC_Decode, 177, 3, 72, // Opcode: LDSTUBArr
/* 7164 */    MCD::OPC_FilterValue, 31, 11, 0, 0, // Skip to: 7180
/* 7169 */    MCD::OPC_CheckField, 13, 1, 0, 45, 3, 0, // Skip to: 7989
/* 7176 */    MCD::OPC_Decode, 201, 4, 71, // Opcode: SWAPArr
/* 7180 */    MCD::OPC_FilterValue, 32, 28, 0, 0, // Skip to: 7213
/* 7185 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7188 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7204
/* 7193 */    MCD::OPC_CheckField, 5, 8, 0, 21, 3, 0, // Skip to: 7989
/* 7200 */    MCD::OPC_Decode, 167, 3, 73, // Opcode: LDFrr
/* 7204 */    MCD::OPC_FilterValue, 1, 12, 3, 0, // Skip to: 7989
/* 7209 */    MCD::OPC_Decode, 166, 3, 73, // Opcode: LDFri
/* 7213 */    MCD::OPC_FilterValue, 33, 79, 0, 0, // Skip to: 7297
/* 7218 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7221 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 7266
/* 7226 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 7229 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7245
/* 7234 */    MCD::OPC_CheckField, 5, 8, 0, 236, 2, 0, // Skip to: 7989
/* 7241 */    MCD::OPC_Decode, 165, 3, 73, // Opcode: LDFSRrr
/* 7245 */    MCD::OPC_FilterValue, 1, 227, 2, 0, // Skip to: 7989
/* 7250 */    MCD::OPC_CheckPredicate, 0, 222, 2, 0, // Skip to: 7989
/* 7255 */    MCD::OPC_CheckField, 5, 8, 0, 215, 2, 0, // Skip to: 7989
/* 7262 */    MCD::OPC_Decode, 189, 3, 73, // Opcode: LDXFSRrr
/* 7266 */    MCD::OPC_FilterValue, 1, 206, 2, 0, // Skip to: 7989
/* 7271 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 7274 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7283
/* 7279 */    MCD::OPC_Decode, 164, 3, 73, // Opcode: LDFSRri
/* 7283 */    MCD::OPC_FilterValue, 1, 189, 2, 0, // Skip to: 7989
/* 7288 */    MCD::OPC_CheckPredicate, 0, 184, 2, 0, // Skip to: 7989
/* 7293 */    MCD::OPC_Decode, 188, 3, 73, // Opcode: LDXFSRri
/* 7297 */    MCD::OPC_FilterValue, 34, 38, 0, 0, // Skip to: 7340
/* 7302 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7305 */    MCD::OPC_FilterValue, 0, 16, 0, 0, // Skip to: 7326
/* 7310 */    MCD::OPC_CheckPredicate, 0, 162, 2, 0, // Skip to: 7989
/* 7315 */    MCD::OPC_CheckField, 5, 8, 0, 155, 2, 0, // Skip to: 7989
/* 7322 */    MCD::OPC_Decode, 170, 3, 74, // Opcode: LDQFrr
/* 7326 */    MCD::OPC_FilterValue, 1, 146, 2, 0, // Skip to: 7989
/* 7331 */    MCD::OPC_CheckPredicate, 0, 141, 2, 0, // Skip to: 7989
/* 7336 */    MCD::OPC_Decode, 169, 3, 74, // Opcode: LDQFri
/* 7340 */    MCD::OPC_FilterValue, 35, 28, 0, 0, // Skip to: 7373
/* 7345 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7348 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7364
/* 7353 */    MCD::OPC_CheckField, 5, 8, 0, 117, 2, 0, // Skip to: 7989
/* 7360 */    MCD::OPC_Decode, 160, 3, 75, // Opcode: LDDFrr
/* 7364 */    MCD::OPC_FilterValue, 1, 108, 2, 0, // Skip to: 7989
/* 7369 */    MCD::OPC_Decode, 159, 3, 75, // Opcode: LDDFri
/* 7373 */    MCD::OPC_FilterValue, 36, 28, 0, 0, // Skip to: 7406
/* 7378 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7381 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7397
/* 7386 */    MCD::OPC_CheckField, 5, 8, 0, 84, 2, 0, // Skip to: 7989
/* 7393 */    MCD::OPC_Decode, 178, 4, 76, // Opcode: STFrr
/* 7397 */    MCD::OPC_FilterValue, 1, 75, 2, 0, // Skip to: 7989
/* 7402 */    MCD::OPC_Decode, 177, 4, 76, // Opcode: STFri
/* 7406 */    MCD::OPC_FilterValue, 37, 79, 0, 0, // Skip to: 7490
/* 7411 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7414 */    MCD::OPC_FilterValue, 0, 40, 0, 0, // Skip to: 7459
/* 7419 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 7422 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7438
/* 7427 */    MCD::OPC_CheckField, 5, 8, 0, 43, 2, 0, // Skip to: 7989
/* 7434 */    MCD::OPC_Decode, 176, 4, 76, // Opcode: STFSRrr
/* 7438 */    MCD::OPC_FilterValue, 1, 34, 2, 0, // Skip to: 7989
/* 7443 */    MCD::OPC_CheckPredicate, 0, 29, 2, 0, // Skip to: 7989
/* 7448 */    MCD::OPC_CheckField, 5, 8, 0, 22, 2, 0, // Skip to: 7989
/* 7455 */    MCD::OPC_Decode, 186, 4, 76, // Opcode: STXFSRrr
/* 7459 */    MCD::OPC_FilterValue, 1, 13, 2, 0, // Skip to: 7989
/* 7464 */    MCD::OPC_ExtractField, 25, 5,  // Inst{29-25} ...
/* 7467 */    MCD::OPC_FilterValue, 0, 4, 0, 0, // Skip to: 7476
/* 7472 */    MCD::OPC_Decode, 175, 4, 76, // Opcode: STFSRri
/* 7476 */    MCD::OPC_FilterValue, 1, 252, 1, 0, // Skip to: 7989
/* 7481 */    MCD::OPC_CheckPredicate, 0, 247, 1, 0, // Skip to: 7989
/* 7486 */    MCD::OPC_Decode, 185, 4, 76, // Opcode: STXFSRri
/* 7490 */    MCD::OPC_FilterValue, 38, 61, 0, 0, // Skip to: 7556
/* 7495 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7498 */    MCD::OPC_FilterValue, 0, 28, 0, 0, // Skip to: 7531
/* 7503 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 7506 */    MCD::OPC_FilterValue, 0, 222, 1, 0, // Skip to: 7989
/* 7511 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 7522
/* 7518 */    MCD::OPC_Decode, 169, 4, 76, // Opcode: STDFQrr
/* 7522 */    MCD::OPC_CheckPredicate, 0, 206, 1, 0, // Skip to: 7989
/* 7527 */    MCD::OPC_Decode, 184, 4, 77, // Opcode: STQFrr
/* 7531 */    MCD::OPC_FilterValue, 1, 197, 1, 0, // Skip to: 7989
/* 7536 */    MCD::OPC_CheckField, 25, 5, 0, 4, 0, 0, // Skip to: 7547
/* 7543 */    MCD::OPC_Decode, 168, 4, 76, // Opcode: STDFQri
/* 7547 */    MCD::OPC_CheckPredicate, 0, 181, 1, 0, // Skip to: 7989
/* 7552 */    MCD::OPC_Decode, 183, 4, 77, // Opcode: STQFri
/* 7556 */    MCD::OPC_FilterValue, 39, 28, 0, 0, // Skip to: 7589
/* 7561 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7564 */    MCD::OPC_FilterValue, 0, 11, 0, 0, // Skip to: 7580
/* 7569 */    MCD::OPC_CheckField, 5, 8, 0, 157, 1, 0, // Skip to: 7989
/* 7576 */    MCD::OPC_Decode, 171, 4, 78, // Opcode: STDFrr
/* 7580 */    MCD::OPC_FilterValue, 1, 148, 1, 0, // Skip to: 7989
/* 7585 */    MCD::OPC_Decode, 170, 4, 78, // Opcode: STDFri
/* 7589 */    MCD::OPC_FilterValue, 48, 37, 0, 0, // Skip to: 7631
/* 7594 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7597 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7622
/* 7602 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7613
/* 7609 */    MCD::OPC_Decode, 154, 3, 79, // Opcode: LDCrr
/* 7613 */    MCD::OPC_CheckPredicate, 0, 115, 1, 0, // Skip to: 7989
/* 7618 */    MCD::OPC_Decode, 163, 3, 73, // Opcode: LDFArr
/* 7622 */    MCD::OPC_FilterValue, 1, 106, 1, 0, // Skip to: 7989
/* 7627 */    MCD::OPC_Decode, 153, 3, 79, // Opcode: LDCri
/* 7631 */    MCD::OPC_FilterValue, 49, 42, 0, 0, // Skip to: 7678
/* 7636 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7639 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7662
/* 7644 */    MCD::OPC_CheckField, 25, 5, 0, 82, 1, 0, // Skip to: 7989
/* 7651 */    MCD::OPC_CheckField, 5, 8, 0, 75, 1, 0, // Skip to: 7989
/* 7658 */    MCD::OPC_Decode, 152, 3, 79, // Opcode: LDCSRrr
/* 7662 */    MCD::OPC_FilterValue, 1, 66, 1, 0, // Skip to: 7989
/* 7667 */    MCD::OPC_CheckField, 25, 5, 0, 59, 1, 0, // Skip to: 7989
/* 7674 */    MCD::OPC_Decode, 151, 3, 79, // Opcode: LDCSRri
/* 7678 */    MCD::OPC_FilterValue, 50, 16, 0, 0, // Skip to: 7699
/* 7683 */    MCD::OPC_CheckPredicate, 0, 45, 1, 0, // Skip to: 7989
/* 7688 */    MCD::OPC_CheckField, 13, 1, 0, 38, 1, 0, // Skip to: 7989
/* 7695 */    MCD::OPC_Decode, 168, 3, 74, // Opcode: LDQFArr
/* 7699 */    MCD::OPC_FilterValue, 51, 37, 0, 0, // Skip to: 7741
/* 7704 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7707 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7732
/* 7712 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7723
/* 7719 */    MCD::OPC_Decode, 157, 3, 80, // Opcode: LDDCrr
/* 7723 */    MCD::OPC_CheckPredicate, 0, 5, 1, 0, // Skip to: 7989
/* 7728 */    MCD::OPC_Decode, 158, 3, 75, // Opcode: LDDFArr
/* 7732 */    MCD::OPC_FilterValue, 1, 252, 0, 0, // Skip to: 7989
/* 7737 */    MCD::OPC_Decode, 156, 3, 80, // Opcode: LDDCri
/* 7741 */    MCD::OPC_FilterValue, 52, 37, 0, 0, // Skip to: 7783
/* 7746 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7749 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7774
/* 7754 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7765
/* 7761 */    MCD::OPC_Decode, 161, 4, 81, // Opcode: STCrr
/* 7765 */    MCD::OPC_CheckPredicate, 0, 219, 0, 0, // Skip to: 7989
/* 7770 */    MCD::OPC_Decode, 174, 4, 76, // Opcode: STFArr
/* 7774 */    MCD::OPC_FilterValue, 1, 210, 0, 0, // Skip to: 7989
/* 7779 */    MCD::OPC_Decode, 160, 4, 81, // Opcode: STCri
/* 7783 */    MCD::OPC_FilterValue, 53, 42, 0, 0, // Skip to: 7830
/* 7788 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7791 */    MCD::OPC_FilterValue, 0, 18, 0, 0, // Skip to: 7814
/* 7796 */    MCD::OPC_CheckField, 25, 5, 0, 186, 0, 0, // Skip to: 7989
/* 7803 */    MCD::OPC_CheckField, 5, 8, 0, 179, 0, 0, // Skip to: 7989
/* 7810 */    MCD::OPC_Decode, 159, 4, 81, // Opcode: STCSRrr
/* 7814 */    MCD::OPC_FilterValue, 1, 170, 0, 0, // Skip to: 7989
/* 7819 */    MCD::OPC_CheckField, 25, 5, 0, 163, 0, 0, // Skip to: 7989
/* 7826 */    MCD::OPC_Decode, 158, 4, 81, // Opcode: STCSRri
/* 7830 */    MCD::OPC_FilterValue, 54, 51, 0, 0, // Skip to: 7886
/* 7835 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7838 */    MCD::OPC_FilterValue, 0, 27, 0, 0, // Skip to: 7870
/* 7843 */    MCD::OPC_CheckField, 25, 5, 0, 11, 0, 0, // Skip to: 7861
/* 7850 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7861
/* 7857 */    MCD::OPC_Decode, 164, 4, 81, // Opcode: STDCQrr
/* 7861 */    MCD::OPC_CheckPredicate, 0, 123, 0, 0, // Skip to: 7989
/* 7866 */    MCD::OPC_Decode, 182, 4, 77, // Opcode: STQFArr
/* 7870 */    MCD::OPC_FilterValue, 1, 114, 0, 0, // Skip to: 7989
/* 7875 */    MCD::OPC_CheckField, 25, 5, 0, 107, 0, 0, // Skip to: 7989
/* 7882 */    MCD::OPC_Decode, 163, 4, 81, // Opcode: STDCQri
/* 7886 */    MCD::OPC_FilterValue, 55, 37, 0, 0, // Skip to: 7928
/* 7891 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7894 */    MCD::OPC_FilterValue, 0, 20, 0, 0, // Skip to: 7919
/* 7899 */    MCD::OPC_CheckField, 5, 8, 0, 4, 0, 0, // Skip to: 7910
/* 7906 */    MCD::OPC_Decode, 166, 4, 82, // Opcode: STDCrr
/* 7910 */    MCD::OPC_CheckPredicate, 0, 74, 0, 0, // Skip to: 7989
/* 7915 */    MCD::OPC_Decode, 167, 4, 78, // Opcode: STDFArr
/* 7919 */    MCD::OPC_FilterValue, 1, 65, 0, 0, // Skip to: 7989
/* 7924 */    MCD::OPC_Decode, 165, 4, 82, // Opcode: STDCri
/* 7928 */    MCD::OPC_FilterValue, 60, 39, 0, 0, // Skip to: 7972
/* 7933 */    MCD::OPC_ExtractField, 13, 1,  // Inst{13} ...
/* 7936 */    MCD::OPC_FilterValue, 0, 48, 0, 0, // Skip to: 7989
/* 7941 */    MCD::OPC_ExtractField, 5, 8,  // Inst{12-5} ...
/* 7944 */    MCD::OPC_FilterValue, 10, 4, 0, 0, // Skip to: 7953
/* 7949 */    MCD::OPC_Decode, 216, 1, 83, // Opcode: CASAasi10
/* 7953 */    MCD::OPC_FilterValue, 128, 1, 9, 0, 0, // Skip to: 7968
/* 7959 */    MCD::OPC_CheckPredicate, 0, 4, 0, 0, // Skip to: 7968
/* 7964 */    MCD::OPC_Decode, 219, 1, 83, // Opcode: CASrr
/* 7968 */    MCD::OPC_Decode, 217, 1, 84, // Opcode: CASArr
/* 7972 */    MCD::OPC_FilterValue, 62, 12, 0, 0, // Skip to: 7989
/* 7977 */    MCD::OPC_CheckField, 5, 9, 128, 1, 4, 0, 0, // Skip to: 7989
/* 7985 */    MCD::OPC_Decode, 218, 1, 85, // Opcode: CASXrr
/* 7989 */    MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV832[] = {
/* 0 */       MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 3 */       MCD::OPC_FilterValue, 0, 25, 0, 0, // Skip to: 33
/* 8 */       MCD::OPC_CheckField, 29, 3, 4, 41, 0, 0, // Skip to: 56
/* 15 */      MCD::OPC_CheckField, 19, 6, 58, 34, 0, 0, // Skip to: 56
/* 22 */      MCD::OPC_CheckField, 5, 3, 0, 27, 0, 0, // Skip to: 56
/* 29 */      MCD::OPC_Decode, 219, 4, 86, // Opcode: TRAPrr
/* 33 */      MCD::OPC_FilterValue, 32, 18, 0, 0, // Skip to: 56
/* 38 */      MCD::OPC_CheckField, 29, 3, 4, 11, 0, 0, // Skip to: 56
/* 45 */      MCD::OPC_CheckField, 19, 6, 58, 4, 0, 0, // Skip to: 56
/* 52 */      MCD::OPC_Decode, 218, 4, 86, // Opcode: TRAPri
/* 56 */      MCD::OPC_Fail,
  0
};

static const uint8_t DecoderTableSparcV932[] = {
/* 0 */       MCD::OPC_ExtractField, 8, 6,  // Inst{13-8} ...
/* 3 */       MCD::OPC_FilterValue, 0, 30, 0, 0, // Skip to: 38
/* 8 */       MCD::OPC_CheckPredicate, 0, 53, 0, 0, // Skip to: 66
/* 13 */      MCD::OPC_CheckField, 29, 3, 4, 46, 0, 0, // Skip to: 66
/* 20 */      MCD::OPC_CheckField, 19, 6, 58, 39, 0, 0, // Skip to: 66
/* 27 */      MCD::OPC_CheckField, 5, 3, 0, 32, 0, 0, // Skip to: 66
/* 34 */      MCD::OPC_Decode, 212, 4, 86, // Opcode: TICCrr
/* 38 */      MCD::OPC_FilterValue, 32, 23, 0, 0, // Skip to: 66
/* 43 */      MCD::OPC_CheckPredicate, 0, 18, 0, 0, // Skip to: 66
/* 48 */      MCD::OPC_CheckField, 29, 3, 4, 11, 0, 0, // Skip to: 66
/* 55 */      MCD::OPC_CheckField, 19, 6, 58, 4, 0, 0, // Skip to: 66
/* 62 */      MCD::OPC_Decode, 211, 4, 86, // Opcode: TICCri
/* 66 */      MCD::OPC_Fail,
  0
};

static bool checkDecoderPredicate(unsigned Idx, const FeatureBitset& Bits) {
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    return (Bits[Sparc::FeatureV9]);
  case 1:
    return (Bits[Sparc::FeatureVIS3]);
  case 2:
    return (Bits[Sparc::FeatureVIS]);
  case 3:
    return (Bits[Sparc::FeatureVIS2]);
  }
}

template<typename InsnType>
static DecodeStatus decodeToMCInst(DecodeStatus S, unsigned Idx, InsnType insn, MCInst &MI,
                                   uint64_t Address, const void *Decoder, bool &DecodeComplete) {
  DecodeComplete = true;
  InsnType tmp;
  switch (Idx) {
  default: llvm_unreachable("Invalid index!");
  case 0:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 1:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 2:
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 3:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = 0;
    tmp |= fieldFromInstruction(insn, 0, 14) << 0;
    tmp |= fieldFromInstruction(insn, 20, 2) << 14;
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 4:
    return S;
  case 5:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 22);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 6:
    tmp = fieldFromInstruction(insn, 0, 19);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 20, 2);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 7:
    tmp = fieldFromInstruction(insn, 0, 30);
    if (DecodeCall(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 8:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 9:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (DecodeSIMM13(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 10:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 11:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 12:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 13:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (DecodeSIMM13(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 14:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 15:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 6);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 16:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 17:
    tmp = fieldFromInstruction(insn, 0, 13);
    if (DecodeSIMM13(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 18:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 19:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodePRRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 20:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 21:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 22:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 23:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 11);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 24:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 25:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 10);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 26:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 27:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeASRRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (DecodeSIMM13(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 28:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodePRRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 29:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodePRRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 13);
    if (DecodeSIMM13(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 30:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 31:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 32:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 33:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 34:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 35:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 36:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 37:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 38:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 39:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 40:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 41:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 42:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 43:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 44:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 45:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 46:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 47:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 48:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 49:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 11, 2);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 50:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 51:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 52:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 53:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFCCRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeQFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 54:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 55:
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 56:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 57:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 58:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 59:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 60:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 61:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 62:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeDFPRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 63:
    if (DecodeJMPL(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 64:
    if (DecodeReturn(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 65:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 66:
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    tmp = fieldFromInstruction(insn, 25, 4);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 67:
    if (DecodeLoadInt(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 68:
    if (DecodeLoadIntPair(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 69:
    if (DecodeStoreInt(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 70:
    if (DecodeStoreIntPair(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 71:
    if (DecodeSWAP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 72:
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 73:
    if (DecodeLoadFP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 74:
    if (DecodeLoadQFP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 75:
    if (DecodeLoadDFP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 76:
    if (DecodeStoreFP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 77:
    if (DecodeStoreQFP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 78:
    if (DecodeStoreDFP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 79:
    if (DecodeLoadCP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 80:
    if (DecodeLoadCPPair(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 81:
    if (DecodeStoreCP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 82:
    if (DecodeStoreCPPair(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 83:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 84:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeIntRegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 5, 8);
    MI.addOperand(MCOperand::createImm(tmp));
    return S;
  case 85:
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 14, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 0, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    tmp = fieldFromInstruction(insn, 25, 5);
    if (DecodeI64RegsRegisterClass(MI, tmp, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  case 86:
    if (DecodeTRAP(MI, insn, Address, Decoder) == MCDisassembler::Fail) { return MCDisassembler::Fail; }
    return S;
  }
}

template<typename InsnType>
static DecodeStatus decodeInstruction(const uint8_t DecodeTable[], MCInst &MI,
                                      InsnType insn, uint64_t Address,
                                      const void *DisAsm,
                                      const MCSubtargetInfo &STI) {
  const FeatureBitset& Bits = STI.getFeatureBits();

  const uint8_t *Ptr = DecodeTable;
  uint32_t CurFieldValue = 0;
  DecodeStatus S = MCDisassembler::Success;
  while (true) {
    ptrdiff_t Loc = Ptr - DecodeTable;
    switch (*Ptr) {
    default:
      errs() << Loc << ": Unexpected decode table opcode!\n";
      return MCDisassembler::Fail;
    case MCD::OPC_ExtractField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      ++Ptr;
      CurFieldValue = fieldFromInstruction(insn, Start, Len);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_ExtractField(" << Start << ", "
                   << Len << "): " << CurFieldValue << "\n");
      break;
    }
    case MCD::OPC_FilterValue: {
      // Decode the field value.
      unsigned Len;
      InsnType Val = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the filter operation.
      if (Val != CurFieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_FilterValue(" << Val << ", " << NumToSkip
                   << "): " << ((Val != CurFieldValue) ? "FAIL:" : "PASS:")
                   << " continuing at " << (Ptr - DecodeTable) << "\n");

      break;
    }
    case MCD::OPC_CheckField: {
      unsigned Start = *++Ptr;
      unsigned Len = *++Ptr;
      InsnType FieldValue = fieldFromInstruction(insn, Start, Len);
      // Decode the field value.
      uint32_t ExpectedValue = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // If the actual and expected values don't match, skip.
      if (ExpectedValue != FieldValue)
        Ptr += NumToSkip;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckField(" << Start << ", "
                   << Len << ", " << ExpectedValue << ", " << NumToSkip
                   << "): FieldValue = " << FieldValue << ", ExpectedValue = "
                   << ExpectedValue << ": "
                   << ((ExpectedValue == FieldValue) ? "PASS\n" : "FAIL\n"));
      break;
    }
    case MCD::OPC_CheckPredicate: {
      unsigned Len;
      // Decode the Predicate Index value.
      unsigned PIdx = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;
      // Check the predicate.
      bool Pred;
      if (!(Pred = checkDecoderPredicate(PIdx, Bits)))
        Ptr += NumToSkip;
      (void)Pred;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_CheckPredicate(" << PIdx << "): "
            << (Pred ? "PASS\n" : "FAIL\n"));

      break;
    }
    case MCD::OPC_Decode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;

      MI.clear();
      MI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, MI, Address, DisAsm, DecodeComplete);
      assert(DecodeComplete);

      LLVM_DEBUG(dbgs() << Loc << ": OPC_Decode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": "
                   << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
      return S;
    }
    case MCD::OPC_TryDecode: {
      unsigned Len;
      // Decode the Opcode value.
      unsigned Opc = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      unsigned DecodeIdx = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      // NumToSkip is a plain 24-bit integer.
      unsigned NumToSkip = *Ptr++;
      NumToSkip |= (*Ptr++) << 8;
      NumToSkip |= (*Ptr++) << 16;

      // Perform the decode operation.
      MCInst TmpMI;
      TmpMI.setOpcode(Opc);
      bool DecodeComplete;
      S = decodeToMCInst(S, DecodeIdx, insn, TmpMI, Address, DisAsm, DecodeComplete);
      LLVM_DEBUG(dbgs() << Loc << ": OPC_TryDecode: opcode " << Opc
                   << ", using decoder " << DecodeIdx << ": ");

      if (DecodeComplete) {
        // Decoding complete.
        LLVM_DEBUG(dbgs() << (S != MCDisassembler::Fail ? "PASS" : "FAIL") << "\n");
        MI = TmpMI;
        return S;
      } else {
        assert(S == MCDisassembler::Fail);
        // If the decoding was incomplete, skip.
        Ptr += NumToSkip;
        LLVM_DEBUG(dbgs() << "FAIL: continuing at " << (Ptr - DecodeTable) << "\n");
        // Reset decode status. This also drops a SoftFail status that could be
        // set before the decode attempt.
        S = MCDisassembler::Success;
      }
      break;
    }
    case MCD::OPC_SoftFail: {
      // Decode the mask values.
      unsigned Len;
      InsnType PositiveMask = decodeULEB128(++Ptr, &Len);
      Ptr += Len;
      InsnType NegativeMask = decodeULEB128(Ptr, &Len);
      Ptr += Len;
      bool Fail = (insn & PositiveMask) || (~insn & NegativeMask);
      if (Fail)
        S = MCDisassembler::SoftFail;
      LLVM_DEBUG(dbgs() << Loc << ": OPC_SoftFail: " << (Fail ? "FAIL\n":"PASS\n"));
      break;
    }
    case MCD::OPC_Fail: {
      LLVM_DEBUG(dbgs() << Loc << ": OPC_Fail\n");
      return MCDisassembler::Fail;
    }
    }
  }
  llvm_unreachable("bogosity detected in disassembler state machine!");
}


} // End llvm namespace
